/* ===============================================================


	DEMOALG - program pentru analiza experimenatala a
	complexitatii algoritmilor de:
	- inmultirea scalara a vectorilor;
	- inmultirea polinoamelor;
	- inmultirea matricelor.

Intrare: n - dimensiunea datelor;
Iesire : Timpul de executie;

Programator: Daniel Ioan
Data ultimei modificari: 17.08.91

===============================================================*/
#define N 62
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <dos.h>


/* Calculeaza produsul scalar a doi vectori */
float prods(int n, 	  	/* dimensiunea vectorilor */
	    float a[N],         /* factorii produsului */
	    float b[N])
{
float p = 0;	/* Produsul scalar intors de functia prods */
int i;

for (i = 0; i<n; i++){
	p += a[i] * b[i];
	delay(2);
	}

return (p);
}

/* Calculeaza produsul a doua polinoame */
void  prodp(int n, 	  	/* gradul polinoamelor */
	    float a[N+1],       /* coeficientii polinoamelor factor*/
	    float b[N+1],
	    float c[2*N+1])     /* coeficientii polinomului produs*/
{
int i,j;

for (i = 0; i<=2*n;i++)
	c[i] = 0;

for (i = 0; i<=n; i++)
	for (j = 0; j<=n; j++){
		c[i+j] += a[i] * b[j];
		delay(1);}
}

/* Calculeaza produsul a doua matrice patrate*/
void  prodm(int n, 	  	/* dimensiunea maticelor: n*n */
	    float a[N+1][N+1],      /* matricele  factor*/
	    float b[N+1][N+1],
	    float c[N+1][N+1])     /* matricea produs*/
{
int i,j,k;

for (i = 0; i<n; i++)
	for (j = 0; j<n; j++)
		{
		 c[i][j] = 0;
		 for (k = 0; k<n; k++){
			c[i][j] += a[i][k] * b[k][j];
			delay(0);}
		 }
}

void main()
{
float t=0;
static float a[N+1], b[N+1], c[2*N+1];
static float aa[N+1][N+1], bb[N+1][N+1], cc[N+1][N+1];
int i,j,n;
clock_t first, second;

do{
  clrscr();
  printf("\n\n       PROGRAM  PENTRU ANALIZA  COMPLEXITATII ALGORITMILOR\n");
  printf(    "       ===================================================\n");
  printf("\n         Programul determina timpul de calcul in functie de dimensiunea");
  printf("\n     problemei pentru:\n");
  printf("\n        - produsul scalar a doi vectori n-dimensionali\n");
  printf("\n        - produsul a doua polinoame de grad n\n");
  printf("\n        - produsul a doua matrice patrate cu n*n elemente\n");
  printf("\n     Introduceti n ( min.2, max. %d, altfel iesire): ",N-2);
  scanf("%d",&n);
  if (n<2 || n>= N-1) 	return;

  /* Initializare date */
  for(i = 0; i<=n; i++){
	  a[i] = i;
	  b[i] = i;
	  for(j = 0; j<=n; j++) {
		  aa[i][j] = i;
		  bb[i][j] = i;
		  }
	  }

  printf("\n\n     Timpul de executie:\n");

  /* Vectori  */
  first = clock();  /* Gets system time */
  prods(n,a,b);
  second = clock(); /* Gets system time again */
  t = (second-first)/CLK_TCK;
  printf("\n        Produsul scalar: %e  ",t);

  /* Polinoame  */
  first = clock();  /* Gets system time */
  prodp(n,a,b,c);
  second = clock(); /* Gets system time again */
  t = (second-first)/CLK_TCK;
  printf("\n        Produsul polinoamelor: %e   ",t);

  /* Matrice  */
  first = clock();  /* Gets system time */
  prodm(n,aa,bb,cc);
  second = clock(); /* Gets system time again */
  t = (second-first)/CLK_TCK;
  printf("\n        Produsul matricelor: %e \n",t);
  printf("\n Pentru continuare apasati o tasta ");
  getch();
  } while (1);
}
