/* Procedura de factorizare cu pivotare pe linii */
/*-----------------------------------------------*/
/* Data:28.01.1990   */
int fact_pl(int n, float (*a)[N], float b[], float x[])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   La iesire matricea a contine L+U-I.
	   Sistemul se rezolva tot aici.
	   Se face pivotare partiala pe linii fara
	   cautarea pivotului optim ci doar a unui pivot
	   nenul de modul maxim.
	   Intoarce ier = 0 - all OK
		    ier = 1 - eroare. Nu se gaseste pivot diferit de 0. */

   /* Declaratii */
   int i,j,k,ier,m,max;
   float p, temp, s ;
   float y[N];	/* se poate renunta la el- se lucreaza in x */


   /* Eliminare */
   for (i=0; i<n-1; i++) /* Contor linii pivot */
     {
     /* Gaseste pivot */

     max=i;
     for (m=i+1; m<n; m++)
       if (fabs(a[m][i]) > fabs(a[max][i])) max = m;
     if ( a[max][i] == 0) return 1; /* Eroare */
     else if (max != i)  /* interschimba linia i cu linia max */
       {
       for (m=0; m<n; m++)
	 {
	 temp = a[i][m];
	 a[i][m] = a[max][m];
	 a[max][m] = temp;
	 }
       temp = b[i];
       b[i] = b[max];
       b[max] = temp;
       }  /* S-a gasit pivotul */

     for (j=i+1; j<n; j++) /* Contor coloane */
	 {
	 a[i][j] /= a[i][i];
	 for (k=i+1; k<n; k++)  /* Contor linii urmatoare */
	   if (a[k][i] != 0)
	     a[k][j] -= a[k][i]*a[i][j];
	 }
     }



   /* substitutie progresiva : Ly = b*/
   y[0] = b[0]/a[0][0];
   for ( i=1; i<n; i++)
     {
     s = b[i];
     for ( j=0; j<i; j++)
       s -= a[i][j]*y[j];
     y[i] = s/a[i][i];
     }

   /* substitutie regresiva */
   x[n-1] = y[n-1];
   for (i=n-2; i>=0; i--)
     {
     s = y[i];
     for (j=n-1; j>i; j--)
       s -= a[i][j]*x[j];
     x[i] = s;
     }

   return(0);	/* all OK */
}	/* end functie */


