#define X M+N
/* Procedura Gauss fara pivotare cu matricea bordata*/
/*--------------------------------------------------*/
/* Data:23.01.1990   */
gaussm(int n, int m, float (*a)[X])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;
   float s,p;

   /* Eliminare */
   for (k=0; k<n-1; k++) /* Contor linii pivot */
     {
/*     printf(" %d",k);*/
     for (i=k+1; i<n; i++) /* Contor linii urmatoare */
       {
       p=a[i][k]/a[k][k];
       for (j=k+1; j<n+m; j++)  /* Contor coloane */
	 a[i][j] -= p*a[k][j];
       }
     }
   /* Retrosubstitutie */
   for (k=n; k<n+m; k++)
     {
     a[n-1][k] /= a[n-1][n-1];
     for (i=n-2; i>=0; i--)
       {
       s = a[i][k];
       for (j=n-1; j>i; j--)
	 s -= a[i][j]*a[j][k];
       a[i][k] = s/a[i][i];
       }
     }

   return;
}	/* end functie */