#define N 4
#define ii pivlin[i]
#define kk pivlin[k]



/* Procedura Gauss cu pivotare pe linii */
/*--------------------------------------*/
/* Data:23.01.1990   */
int gauss_pl(int n, float (*a)[N], float b[], float x[])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b.
	   Se face pivotare partiala pe linii fara
	   cautarea pivotului optim ci doar a unui pivot
	   nenul de modul maxim.
	   Intoarce ier = 0 - all OK
		    ier = 1 - eroare. Nu se gaseste pivot diferit de 0. */

   /* Declaratii */
   int i,j,k,ier,m,max,temp, pivlin[N];
   float p, s;



   /* Initializare contor de linii */
   for ( i=0; i<n; i++)
     pivlin[i] = i;	/* Se noteaza cu ii = pivlin[i] */

   /* Eliminare */
   for (i=0; i<n-1; i++) /* Contor linii pivot */
     {
     /* Gaseste pivot */

     max=i;
     for (m=i+1; m<n; m++)
       if (fabs(a[pivlin[m]][i]) > fabs(a[pivlin[max]][i])) max = m;
     if ( a[pivlin[max]][i] == 0) return 1; /* Eroare */
     else if (max != i)
       {
       temp = pivlin[i];
       pivlin[i]=pivlin[max];
       pivlin[max]=temp;
       }  /* S-a gasit pivotul */

     for (k=i+1; k<n; k++) /* Contor linii urmatoare */
       {
       if (a[kk][i] != 0)
	 {
	 p=a[kk][i]/a[ii][i];
	 for (j=i+1; j<n; j++)  /* Contor coloane */
	   a[kk][j] -= p*a[ii][j];
	 b[kk] -= p*b[ii];
	 }
       }
     }

   /* Retrosubstitutie */
   x[n-1] = b[pivlin[n-1]]/a[pivlin[n-1]][n-1];
   for (i=n-2; i>=0; i--)
     {
     s=b[ii];
     for (j=n-1; j>i; j--)
       s -= a[ii][j]*x[j];
     x[i] = s/a[ii][i];
     }

   return(0);	/* all OK */
}	/* end functie */

