#define AP(x,y) a[pivlin[0][x]][pivlin[1][y]]
#define BP(x) b[pivlin[0][x]]



/* Procedura Gauss cu pivotare totala */
/*------------------------------------*/
/* Data:25.01.1990   */
int gauss_pt(int n, float (*a)[N], float b[], float x[])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b.
	   Se face pivotare totala pe linii si coloane fara
	   cautarea pivotului optim ci doar a unui pivot
	   nenul de valoare absoluta maxima.
	   Intoarce ier = 0 - all OK
		    ier = 1 - eroare. Nu se gaseste pivot diferit de 0. */

   /* Declaratii */
   int i,j,k,ier,m,m1,temp, pivlin[2][N]; /* pivlin[0] - linii
					      pivlin[1] - coloane */
   int maxl,maxc;
   float p, s, curent;




   /* Initializare contor de linii */
   for ( i=0; i<n; i++)
     {
     pivlin[0][i] = i;
     pivlin[1][i] = i;
     }

   /* Eliminare */
   for (i=0; i<n-1; i++) /* Contor linii pivot */
     {
     /* Gaseste pivot */

     maxl = maxc = i;
     for (m=i+1; m<n; m++)
       for (m1 = i; m1<n; m1++)
       {
       if (fabs(AP(m,m1)) > fabs(AP(maxl,maxc))) {maxl = m;maxc = m1;}
	 /* maxl=lin.cu elem.max.pe col.i*/
	 /* maxc=col.cu elem.max.pe lin.i*/
       }
     if ( AP(maxl,maxc)== 0) return 1; /* Eroare */
     else if ((maxl != i) || (maxc != i))
       {
       temp = pivlin[0][i];	/* prin m aleg : linia sau coloana */
       pivlin[0][i]=pivlin[0][maxl];
       pivlin[0][maxl]=temp;
       temp = pivlin[1][i];	/* prin m aleg : linia sau coloana */
       pivlin[1][i]=pivlin[1][maxc];
       pivlin[1][maxc]=temp;
       }  /* S-a gasit pivotul */

     for (k=i+1; k<n; k++) /* Contor linii urmatoare */
       {
       if ( AP(k,i) != 0) 	/* Vezi #define pentru semnificatie */
	 {
	 p=AP(k,i)/AP(i,i);
	 for (j=i+1; j<n; j++)  /* Contor coloane */
	   AP(k,j) -= p*AP(i,j);
	 BP(k) -= p*BP(i);
	 }
       }
     }

   /* Retrosubstitutie */
   if (AP(n-1,n-1) == 0) return 1;  /* e necesara-i merge pina la n-2 doar*/
   x[pivlin[1][n-1]] = BP(n-1)/AP(n-1,n-1);

   for (i=n-2; i>=0; i--)
     {
     s=BP(i);
     for (j=n-1; j>i; j--)
       s -= AP(i,j)*x[pivlin[1][j]];
     x[pivlin[1][i]] =  s/AP(i,i);
     }

   return(0);	/* all OK */
}	/* end functie */

