/* Testare procedura Gauss fara pivotare.
Sistemul nu are a[i,i] nuli. */

#define N 5
#include <stdio.h>
#include <conio.h>


/* Procedura Gauss fara pivotare */
int gauss_fp(int n, float (*a)[N], float b[], float x[])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;
   float s,p;

   /* Eliminare */
   for (k=0; k<n-1; k++) /* Contor linii pivot */
     {
     if (a[k][k] == 0) return 1;  /* Eroare */
     for (i=k+1; i<n; i++) /* Contor linii urmatoare */
       {
       p=a[i][k]/a[k][k];
       for (j=k; j<n; j++)  /* Contor coloane */
	 {
	 a[i][j] -= p*a[k][j];
	 gotoxy(9*j+1, i+2);
	 printf("%8.2f",a[i][j]);
	 }
       b[i] -= p*b[k];
       gotoxy(9*n+12, i+2);
       printf("%8.2f",b[i]);
       gotoxy(1,n+3);
       printf("S-a anulat elementul a(%d,%d). Pentru continuare apasati <Enter>: ",i+1,k+1);
       getchar();
       }
     }

   /* Retrosubstitutie */
   if (a[n-1][n-1] == 0) return 1;  /* Eroare */
   x[n-1] = b[n-1]/a[n-1][n-1];
   gotoxy(9*n+4, n+1);
   printf("%8.2f",x[n-1]);
   gotoxy(1,n+3);
   clreol();
   printf("S-a calculat x(%d). Pentru continuare apasati <Enter>: ",n);
   getchar();

   for (i=n-2; i>=0; i--)
     {
     s = b[i];
     for (j=n-1; j>i; j--)
       s -= a[i][j]*x[j];
     x[i] = s/a[i][i];
     gotoxy(9*n+4, i+2);
     printf("%8.2f",x[i]);
     gotoxy(1,n+3);
     printf("S-a calculat x(%d). Pentru continuare apasati <Enter>: ",i+1);
     getchar();
     }

   return 0;  /* all OK */
}	/* end functie GAUSSFP */


main()
{
float mat[N][N],  /* matricea a */
      b[N], 	  /* vectorul termenilor liberi */
      x[N];	  /* vectorul rezultatelor */
int   n,	  /* dimensiunea sistemului */
      ier,	  /* indice de eroare */
      i,j;	  /* variabile contor */

do{
  clrscr();
  printf("\n\t\tPROGRAM TEST GAUSSFP\n");
  printf("\t\t====================\n\n\n");
  printf("Rezolva sisteme liniare prin metoda Gauss fara pivotare\n\n");

  printf("\nIntroduceti numarul de ecuatii (min.2, max.5, altfel - iesire): ");
  scanf("%d",&n);
  if (n<2 || n>5) break;
  for(i=0; i<n; i++)
    {
    for (j=0; j<n ; j++)
      {
      printf("a(%d,%d) = ",i+1,j+1);
      scanf("%f",&mat[i][j]);
      }
    }
  for (j=0; j<n ; j++)
    {
    printf("b(%d) = ",j+1);
    scanf("%f",&b[j]);
    }

  clrscr();
  printf("    A");
  gotoxy(9*n+8,1);
  printf("x       b");
  for (i=0; i<n; i++)
    {
    for (j=0; j<n; j++)
      {
      gotoxy(9*j+1, i+2);
      printf("%8.2f", mat[i][j]);
      }
    gotoxy(9*n+12, i+2);
    printf("%8.2f", b[i]);
    }
  gotoxy(1,n+3);
  fflush(stdin);
  printf("Pentru continuare apasati <Enter>:");
  getchar();

  ier = gauss_fp(n,mat,b,x);
  gotoxy(1,n+3);
  clreol();
  if (ier == 0) printf("\tEroarea:\n");
  else
    {
    fflush(stdin);
    printf("\tEroare: impartire prin 0.\n");
    printf("Pentru continuare apasati <Enter>:");
    getchar();
    }
  } while(1);

}  /* end main */