/* Testare procedura de factorizare fara pivotare.
Sistemul nu are a[i,i] nuli.
Data: 11.02.1991
Programator : Irina Munteanu */

#define N 5
#include <math.h>
#include <stdio.h>
#include <conio.h>

#define restaurare(j) for (ii=0; ii<n; ii++) {gotoxy(9*j+1, n+ii+4);printf("%8.2f",a[ii][j]);}
int ii;


float mat[N][N],  /* matricea a */
      b[N], 	  /* vectorul termenilor liberi */
      x[N];	  /* vectorul rezultatelor */


/* Procedura de factorizare fara pivotare */
/*----------------------------------------*/
fact_lu(int n, float (*a)[N])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;

     gotoxy(1, n+3);
     clreol();
     printf("L+U-I");

     highvideo();
     gotoxy(1,2*n+5);
     clreol();
     cprintf("Factorizeaza LU matricea sistemului");

     for (i=0; i<n; i++)
       {
       gotoxy(1, i+n+4);
       cprintf("%8.2f",a[i][0]);
       }
   gotoxy(1,2*n+7);
   printf("Pentru continuare apasati <Enter>: ");
   getchar();


   restaurare(0);


   /* Eliminare */
   for (k=0; k<n-1; k++) /* Contor linii pivot */
     {
     for (j=k+1; j<n; j++) /* Contor coloane urmatoare */
       {
       if (a[k][k] == 0) return 1;  /* Eroare */
       a[k][j] /= a[k][k];
       gotoxy(9*j+1, n+k+4);
       cprintf("%8.2f",a[k][j]);
       gotoxy(1,2*n+7);
       printf("S-a impartit a(%d,%d) la pivot.Pentru continuare apasati <Enter>: ",k+1,j+1);
       getchar();
       for (i=k+1; i<n; i++)  /* Contor linii */
	 {
	 a[i][j] -= a[i][k]*a[k][j];
	 gotoxy(9*j+1, n+i+4);
	 cprintf("%8.2f",a[i][j]);
	 }
       gotoxy(1,2*n+7);
       clreol();
       printf("S-a calculat coloana %d.Pentru continuare apasati <Enter>: ",j+1);
       getchar();


       restaurare(j);


       }
     }


     normvideo();

   if (a[n-1][n-1] == 0) return 1;
   return 0;
}  /* end fact_lu */


/* Procedura de rezolvare a unui sistem cu
matricea factorizata LU                   */
/*----------------------------------------*/

rez_lu(int n, float (*a)[N], float b[], float x[])
{
   int i,j;
   float s;
   float y[N];	/* se poate renunta la el- se lucreaza in x */

   highvideo();
   gotoxy(1,2*n+5);
   clreol();
   cprintf("Rezolva sistem L*y = b");


   /* substitutie progresiva : Ly = b*/
   y[0] = b[0]/a[0][0];
   gotoxy(9*n+4,n+4);
   cprintf("%8.2f",y[0]);
   gotoxy(1,2*n+7);
   fflush(stdin);
   printf("S-a calculat y(%d). Pentru continuare apasati <Enter>: ",1);
   getchar();

   gotoxy(9*n+4,n+4);
   printf("%8.2f",y[0]);


   for ( i=1; i<n; i++)
     {
     s = b[i];
     for ( j=0; j<i; j++)
       s -= a[i][j]*y[j];
     y[i] = s/a[i][i];
     gotoxy(9*n+4,n+i+4);
     cprintf("%8.2f",y[i]);
     gotoxy(1,2*n+7);
     printf("S-a calculat y(%d). Pentru continuare apasati <Enter>: ",i+1);
     getchar();

     gotoxy(9*n+4,n+i+4);
     printf("%8.2f",y[i]);



     }

   gotoxy(1,2*n+5);
   clreol();
   cprintf("Rezolva sistem U*x = y");

   /* substitutie regresiva Ux=y*/
   x[n-1] = y[n-1];
   gotoxy(9*n+4,2*n+3);
   cprintf("%8.2f",x[n-1]);
   gotoxy(1,2*n+7);
   printf("S-a calculat x(%d). Pentru continuare apasati <Enter>: ",n);
   getchar();

   gotoxy(9*n+4,2*n+3);
   printf("%8.2f",x[n-1]);



   for (i=n-2; i>=0; i--)
     {
     s = y[i];
     for (j=n-1; j>i; j--)
       s -= a[i][j]*x[j];
     x[i] = s;
     gotoxy(9*n+4,n+4+i);
     cprintf("%8.2f",x[i]);
     gotoxy(1,2*n+7);
     printf("S-a calculat x(%d). Pentru continuare apasati <Enter>: ",i+1);
     getchar();


     gotoxy(9*n+4,n+4+i);
     printf("%8.2f",x[i]);


     }
     normvideo();
   return;
}	/* end functie rez_lu */


main()
{
int   n,	  /* dimensiunea sistemului */
      ier,	  /* indice de eroare */
      c,	  /* caracter preluat */
      i,j;	  /* variabile contor */

do{
  clrscr();
  printf("\n\t\tPROGRAM TEST FACTLU\n");
  printf(  "\t\t===================\n\n\n");
  printf("Rezolva sisteme liniare prin metoda factorizarii LU\n\n");

  printf("\nIntroduceti numarul de ecuatii (min.2, max.5, altfel - iesire): ");
  scanf("%d",&n);
  if (n<2 || n>5) break;
  for(i=0; i<n; i++)
    {
    for (j=0; j<n ; j++)
      {
      printf("a(%d,%d) = ",i+1,j+1);
      scanf("%f",&mat[i][j]);
      }
    }

  clrscr();
  printf("    A");
  gotoxy(9*n+8,1);
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      {
      gotoxy(9*j+1, i+2);
      printf("%8.2f", mat[i][j]);
      }
  gotoxy(1,n+3);
  fflush(stdin);
  printf("Pentru continuare apasati <Enter>:");
  getchar();

  ier = fact_lu(n,mat);
  gotoxy(1,2*n+7);
  clreol();
  if (ier != 0)
    {
    fflush(stdin);
    printf("\tEroare: impartire prin 0.\n");
    printf("Pentru continuare apasati <Enter>:");
    getchar();
    }

  /* rezolvare de sisteme pe baza matr. factorizate */
  else do
    {
    gotoxy(9*n+4,n+3);
    clreol();
    printf("    y/x      b");
    fflush(stdin);
    gotoxy(1,2*n+5);
    clreol();
    for (i=0; i<n; i++)  /* Sterge vechiul x */
      {
      gotoxy(9*n+4, i+n+4);
      clreol();
      }
    for (i=0; i<n; i++)
      {
      gotoxy(1,2*n+7);
      clreol();
      printf("Introduceti b(%d): ",i+1);
      gotoxy(9*(n+1) +5, i+n+4);
      scanf("%f", &b[i]);
      gotoxy(9*(n+1) +5, i+n+4);
      printf("%8.2f", b[i]);
      }

    rez_lu(n,mat,b,x);
    gotoxy(1,2*n+5);
    clreol();       /* sterge mesaj */

    gotoxy(1,2*n+7 );
    clreol();
    fflush(stdin);
    printf("Rezolvare alt sistem? [D/N]: ");
    } while ((c=getchar())=='d' || (c== 'D'));
  } while(1);

}  /* end main */