/* Comparatie intre metodele de rezolvare a sistemlor liniare prin 2
metode:
- inversare matrici prin procedura Gauss cu matricea bordata;
- factorizare LU.
Se genereaza aleator sistemele.
Rezultatele nu se afiseaza.
Se calculeaza eroarea si timpul de lucru, care se afiseaza.
Sistemul nu are a[i,i] nuli.

Data : 11.02.1991
Data ultimei modificari: 11.05.1991
Programator : Irina Munteanu */

#define N 40
#define M 60

#include <math.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include "gaussm.c"
#include "factlu.c"
#include "rezlu.c"

void gen_sist(int m);   /* Declarare proc. de generare de sisteme aleatoare */
void gen_b(int n,int m);   /* Declarare proc. de generare de sisteme aleatoare */


/* Declaratiile s-au mutat temporar aici */
float mat[N][N],	/* matricea a */
      b[N][M],		/* matricea a */
      xinv[N][M],	/* solutia prin metoda inversarii */
      xfact[N][M];	/* solutia prin metoda factorizarii */
int   n,	  	/* dimensiunea sistemului */
      i,j,	  	/* variabile contor */
      car;	   	/* caracter tastat la consola */




void main()
{

float mat1[N][N+M]; 	/* copia matricii a */
clock_t start,end; 	/* inceput, sfirsit rulare procedura */
/*float rezcrt,		/* norma curenta */
  /*    rezc;		/* norma reziduului: Cebisev */
int k;
int tmax,tl;		/* numar de termeni liberi */
float s;
float tinv,tfact,	/* timp inversare, factorizare */
      txinv[8],		/* timp rezolvare prin inversare */
      txfact[8];	/* timp rezolvare prin factorizare */


do{
  clrscr();
  printf("\n\t\tPROGRAM EVALUARE FACTLU\n");
  printf(  "\t\t=======================\n\n\n");
  printf("Determina erori si timp de calcul la rezolvarea succesiva a sistemelor\n");
  printf("liniare, generate aleator, prin metodele:\n\n");
  printf("* Inmultirea termenilor liberi cu inversa matricii sistemului;\n");
  printf("* Factorizarea LU a matricii sistemului.\n\n");
  printf("Introduceti numarul de ecuatii (min.2, max.40, altfel - iesire): ");
  scanf("%d",&n);
  if (n<2 || n>40) break;

  /* Generare sistem de ecuatii */
  gen_sist(n);

  /* INVERSARE
     Copiere matrice a, init.vector b pentru rezolvare */

  printf("\nInversarea matricii ...");
  for (i=0;i<n;i++)
    {
    for (j=0; j<n; j++)
      mat1[i][j] = mat[i][j];
    for (j=n; j<2*n; j++)
      mat1[i][j] = 0;
    mat1[i][i+n] = 1;
    }
  start = clock();	/* Determina timpul scurs */
  gaussm(n,n,mat1);
  end = clock();
  tinv = (end - start)/ CLK_TCK;

  /* FACTORIZARE
     Copiere matrice a */

  gotoxy(1, wherey());
  printf("Factorizarea matricii ...");
  for (i=0;i<n;i++)
    for (j=0; j<n; j++)
      mat1[i][j] = mat[i][j];

  start = clock();	/* Determina timpul scurs */
  fact_lu(n,mat1);
  end = clock();
  tfact = (end - start)/ CLK_TCK;

  gotoxy(1, wherey());
  printf("Introduceti numarul de sisteme succesive(min.2, max.60, altfel - iesire): ");
  scanf("%d",&tmax);
  if (tmax<1 || tmax>60) break;
  printf("\n");
  for (tl=1; tl<=tmax; (tl==1)? (tl+= 9):(tl+= 10))
    {
    gotoxy(1, wherey());
    printf("Rezolva succesiv %d sisteme ...",tl);
    gen_b(n,tl);
    /* Calculeaza term. liberi xinv */
    start = clock();
    for (i=0; i<n; i++)
      for (j=0; j<tl; j++)
	{
	s=0;
	for (k=0; k<n; k++)
	  s += mat1[i][k+n] * b[k][j];
	xinv[i][j] = s;
	}
    end = clock();
    txinv[(int)(tl/10)] = (end - start)/ CLK_TCK;

    /* Calculeaza term. liberi xfact */
    start = clock();
    for (i=0; i<tl; i++)
      rez_lu(n,mat1,b[i],xfact[i]);
    end = clock();
    txfact[(int)(tl/10)] = (end - start)/ CLK_TCK;
    } /* sfirsit ciclu ptr. diversi termeni liberi */

  clrscr();
  printf("\n\t\tRezultate :\n");
  printf("\t\t=========\n\n");

  /* Calculeaza norma reziduului */
  /* Inmulteste A cu A-1 */
  /*for (i=0; i<n; i++)
    for (j=0; j<n; j++)
    {
    s = 0;
    for (k=0; k<n; k++)
      s += mat[i][k]*mat1[k][j+n];  /* mat-initiala; mat1[][j+n]-inversa*/
    /*mat1[i][j] = s;
    }

  rezc = 0;	/* norma Cebisev a reziduului */
/*  for (i=0; i<n; i++)
    {
    s = 0;
    for (j=0; j<n; j++)
      {
      rezcrt = mat1[i][j];
      if (i==j) rezcrt -=1;
      rezcrt = fabs(rezcrt);
      s += rezcrt;
      }
    if (rezcrt > rezc) rezc = rezcrt;
    }

  printf("\nNorma Cebisev a reziduului: ");
  printf("%e\n", rezc);
  printf("\nTimpul de calcul : %f secunde\n\n",(end - start)/ CLK_TCK);
  */

  printf("Dimensiunea sistemului : %d\n", n);
  printf("---------------------------\n\n");
  printf("Nr.termeni liberi:\tTimpul de calcul :\n");
  printf("-----------------\t----------------\n");
  printf("\t\t\t   -1\n");
  printf("\t\t\tx=A  *b\t\t\tfactorizare\n");
  for(i=0; i<=(tmax/10); i++)
    {
    printf(" %d ",(i==0)? 1:(i*10));
    printf("\t\t\t%f",tinv+txinv[i]);
    printf("\t\t%f\n",tfact+txfact[i]);
    }
  printf("\ndin care:\t\tpentru inversare\tptr.factorizare\n");
  printf("\t\t\t%f secunde\t%f secunde\n",tinv,tfact);

  fflush(stdin);
  printf("\nPentru continuare apasati <Enter>:");
  getchar();

  } while(1);

}  /* end main */

void gen_sist(int n)
{
  int i,j;

  randomize();
  for(i=0; i<n; i++)
    {
    for (j=0; j<n ; j++)
      {
      mat[i][j] = ((float)(rand())/RAND_MAX  );
      /* Numere negative ?? */
      /*if (i==j) mat[i][j] *= 100;  /* pentru pivot optim */
      }
    }
}

void gen_b(int n,int m)
{
  int i,j;

  randomize();
  for(i=0; i<n; i++)
    for (j=0; j<m ; j++)
      b[i][j] = ((float)(rand())/RAND_MAX  );
}  /* end gen_b */
