/* Testare procedura Gauss fara pivotare cu matricea bordata.
Sistemul nu are a[i,i] nuli. */

#define N 5
#define M 5
#include <stdio.h>
#include <conio.h>


#define X M+N

float mat[N][N+M],  /* matricea a */
      b[N], 	  /* vectorul termenilor liberi */
      x[N];	  /* vectorul rezultatelor */


/* Procedura Gauss fara pivotare cu matricea bordata*/
/*--------------------------------------------------*/
/* Data:23.01.1990   */
gaussm(int n, int m, float (*a)[X])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;
   float s,p;

   /* Eliminare */
   for (k=0; k<n-1; k++) /* Contor linii pivot */
     {
/*     printf(" %d",k);*/
     for (i=k+1; i<n; i++) /* Contor linii urmatoare */
       {
       if (a[k][k] == 0) return 1;
       p=a[i][k]/a[k][k];
       for (j=k; j<n+m; j++)  /* Contor coloane */
	 {
	 a[i][j] -= p*a[k][j];
	 if (j<n)
	   {
	   gotoxy(9*j+1, i+2);
	   printf("%8.2f",a[i][j]);
	   }
	 else
	   {
	   gotoxy(9*(j-n)+1, n+i+4);
	   printf("%8.2f",a[i][j]);
	   }
	 }
       gotoxy(1,2*n+5);
       printf("S-a anulat elementul a(%d,%d). Pentru continuare apasati <Enter>: ",i+1,k+1);
       getchar();
       }
     }

   gotoxy(1,2*n+5);
   clreol();
   /* Retrosubstitutie */
   for (k=n; k<n+m; k++)
     {
     if (a[n-1][n-1] == 0) return 1;
     a[n-1][k] /= a[n-1][n-1];
     gotoxy(9*(k-n)+1, n-1+n+4);
     printf("%8.2f",a[n-1][k]);
     gotoxy(1,2*n+5);
     printf("S-a calculat x%d(%d). Pentru continuare apasati <Enter>: ",k-n+1,n);
     getchar();
     for (i=n-2; i>=0; i--)
       {
       s = a[i][k];
       for (j=n-1; j>i; j--)
	 s -= a[i][j]*a[j][k];
       a[i][k] = s/a[i][i];
       gotoxy(9*(k-n)+1, i+n+4);
       printf("%8.2f",a[i][k]);
       gotoxy(1,2*n+5);
       printf("S-a calculat x%d(%d). Pentru continuare apasati <Enter>: ",(k-n+1),i+1);
       getchar();
       }
     }

   return 0;
}	/* end functie *//* Procedura Gauss fara pivotare */



main()
{
int   n,	  /* dimensiunea sistemului */
      m,	  /* numarul de termeni liberi */
      ier,	  /* indice de eroare */
      i,j;	  /* variabile contor */
float r;

do{
  clrscr();
  printf("\n\t\tPROGRAM TEST GAUSSM\n");
  printf("\t\t===================\n\n\n");
  printf("Rezolva sisteme liniare multiple prin metoda Gauss .\n\n");

  printf("\nIntroduceti numarul de ecuatii (min.2, max.5, altfel - iesire): ");
  scanf("%f",&r);
  n=r;
  if (n<2 || n>5) break;
  printf("\nIntroduceti numarul de termeni liberi(min.1, max.5): ");
  scanf("%d",&m);
  if (m<1 || m>5)
    {printf("Numar de termeni liberi incorect.\n");getchar();continue;}
  for(i=0; i<n; i++)
    {
    for (j=0; j<n ; j++)
      {
      printf("a(%d,%d) = ",i+1,j+1);
      scanf("%f",&mat[i][j]);
      }
    }
  for(j=0; j<m; j++)
    {
    for (i=0; i<n ; i++)
      {
      printf("b%d(%d) = ",j+1,i+1);
      scanf("%f",&mat[i][j+n]);
      }
    }

  clrscr();
  printf("    A");
  gotoxy(1,n+3);
  printf("    B/X");
  for (i=0; i<n; i++)
    {
    for (j=0; j<n; j++)
      {
      gotoxy(9*j+1, i+2);
      printf("%8.2f", mat[i][j]);
      }
    }
  for (i=0; i<n; i++)
    {
    for (j=0; j<m; j++)
      {
      gotoxy(9*j+1, i+n+4);
      printf("%8.2f", mat[i][j+n]);
      }
    }
  gotoxy(1,2*n+5);
  fflush(stdin);
  printf("Pentru continuare apasati <Enter>:");
  getchar();

  ier = gaussm(n,m,mat);
  gotoxy(1,n+3);
  clreol();
  if (ier == 0) printf("\tEroarea:\n");
  else
    {
    fflush(stdin);
    printf("\tEroare: impartire prin 0.\n");
    printf("Pentru continuare apasati <Enter>:");
    getchar();
    }
  } while(1);

}  /* end main */