/* Testare inversare matrici prin procedura Gauss cu matricea bordata.
Se genereaza aleator matrici care se inverseaza.
Rezultatele nu se afiseaza. Se calculeaza eroarea maxima
si timpul de lucru, care se afiseaza.
Sistemul nu are a[i,i] nuli.

Data : 09.02.1991
Programator : Irina Munteanu */

#define N 60
#define M 60
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "gaussm.c"

void gen_sist(int m);   /* Declarare proc. de generare de sisteme aleatoare */


/* Declaratiile s-au mutat temporar aici */
float mat[N][N];  /* matricea a */
int   n,	  /* dimensiunea sistemului */
      i,j,	  /* variabile contor */
      car;	  /* caracter tastat la consola */




void main()
{

float mat1[N][2*N]; /* copia matricii a */
clock_t start,end; /* inceput, sfirsit rulare procedura */
float rezcrt,		/* norma curenta */
      rezc;		/* norma reziduului: Cebisev */
int k;
float s;

do{
  clrscr();
  printf("\n\t\tPROGRAM EVALUARE INVERSARE MATRICI\n");
  printf(  "\t\t==================================\n\n\n");
  printf("Determina erori si timp de calcul la inversarea, prin metoda Gauss cu \n");
  printf("matricea bordata, a matricilor generate aleator.\n\n");
  printf("Introduceti numarul de ecuatii (min.2, max.60, altfel - iesire): ");
  scanf("%d",&n);
  if (n<2 || n>60) break;

  /* Generare sistem de ecuatii */
  gen_sist(n);
  /* Copiere matrice a, init.vector b pentru rezolvare */
  for (i=0;i<n;i++)
    {
    for (j=0; j<n; j++)
      mat1[i][j] = mat[i][j];
    for (j=n; j<2*n; j++)
      mat1[i][j] = 0;
    mat1[i][i+n] = 1;
    }
  start = clock();	/* Determina timpul scurs */
  gaussm(n,n,mat1);
  end = clock();

  printf("\n\n\t\tRezultate :\n");
  printf(    "\t\t=========\n\n");

  /* Calculeaza norma reziduului */
  /* Inmulteste A cu A-1 */
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
    {
    s = 0;
    for (k=0; k<n; k++)
      s += mat[i][k]*mat1[k][j+n];  /* mat-initiala; mat1[][j+n]-inversa*/
    mat1[i][j] = s;
    }

  rezc = 0;	/* norma Cebisev a reziduului */
  for (i=0; i<n; i++)
    {
    s = 0;
    for (j=0; j<n; j++)
      {
      rezcrt = mat1[i][j];
      if (i==j) rezcrt -=1;
      rezcrt = fabs(rezcrt);
      s += rezcrt;
      }
    if (rezcrt > rezc) rezc = rezcrt;
    }

  printf("\nNorma Cebisev a reziduului: ");
  printf("%e\n", rezc);
  printf("\nTimpul de calcul : %f secunde\n\n",(end - start)/ CLK_TCK);
  fflush(stdin);
  printf("Pentru continuare apasati <Enter>:");
  getchar();

  } while(1);

}  /* end main */

void gen_sist(int n)
{
  int i,j;

  randomize();
  for(i=0; i<n; i++)
    for (j=0; j<n ; j++)
      {
      mat[i][j] = ((float)(rand())/RAND_MAX  );
      /* Numere negative ?? */
      /*if (i==j) mat[i][j] *= 100;  /* pentru pivot optim */
      }
}
