/* Testare procedura Gauss cu pivotare partiala.
Se genereaza aleator sisteme de ecuatii care se rezolva.
Rezultatele nu se afiseaza. Se calculeaza erorile
si timpul de lucru, care se afiseaza.
Eroarea adevarata :   __________________________________
 - Euclidiana : e = \/suma de (x - x adevarat) la patrat
			____________________________
 - Cebisev : eps = e/ \/suma de x adevarat la patrat
Norma reziduului :    __________________________
 - Euclidiana : r = \/suma de (Ax - b) la patrat
			___________________
 - Cebisev : eps = e/ \/suma de b la patrat


Data : 04.02.1991
Programator : Irina Munteanu */

#define N 80
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <\mn\rezsist\metdir\gauss\gausspl1.c>

void gen_sist(int m);   /* Declarare proc. de generare de sisteme aleatoare */


/* Declaratiile s-au mutat temporar aici */
float mat[N][N],  /* matricea a */
      b[N], 	  /* vectorul termenilor liberi */
      xa[N],	  /* vectorul rezultatelor adevarate */
      x[N];	  /* vectorul rezultatelor obtinute dupa rezolvare */
int   n,	  /* dimensiunea sistemului */
      i,j,	  /* variabile contor */
      car;	  /* caracter tastat la consola */




void main()
{

clock_t start,end; /* inceput, sfirsit rulare procedura */
float errcrt, 		/* eroarea curenta */
      rezcrt,		/* norma curenta */
      erre, errc,	/* norma erorii: euclidiana, Cebisev */
      reze, rezc,	/* norma reziduului: euclidiana, Cebisev */
      bnorme, bnormc,	/* norma lui b: euclidiana, Cebisev */
      xanorme, xanormc;	/* norma solutiei adevarate: euclidiana, Cebisev */
float mat1[N][N], 	/* copia matricii a */
      b1[N]; 	  	/* copia vectorului termenilor liberi */
float ier;		/* indice de eroare */

do{
  clrscr();
  printf("\n\t\tPROGRAM EVALUARE GAUSSPL\n");
  printf(  "\t\t========================\n\n\n");
  printf("Determina erori si timp de calcul la rezolvarea, prin metoda Gauss cu \n");
  printf("pivotare partiala, a sistemelor de ecuatii liniare generate aleator.\n\n");
  printf("Introduceti numarul de ecuatii (min.2, max.80, altfel - iesire): ");
  scanf("%d",&n);
  if (n<2 || n>80) break;

  /* Generare sistem de ecuatii */
  gen_sist(n);
  /* Copiere matrice a, vector b pentru rezolvare */
  for (i=0;i<n;i++)
    {
    for (j=0; j<n; j++)
      mat1[i][j] = mat[i][j];
    b1[i] = b[i];
    }

  start = clock();	/* Determina timpul scurs */
  ier = gauss_pl1(n,mat1,b1,x);
  end = clock();

  printf("\n\n\t\tRezultate :\n");
  printf(    "\t\t=========\n\n");

  erre = 0;	/* Calculeaza eroarea */
  errc = 0;
  reze = 0;
  rezc = 0;
  bnorme = 0;	/* Calculeaza eroarea */
  bnormc = 0;
  xanorme= 0;
  xanormc= 0;
  /* Calculeaza norma lui x adevarat si a lui b */
  for (i=0; i<n; i++)
    {
    errcrt = fabs(b[i]);
    if ( errcrt > bnormc) bnormc = errcrt;
    bnorme += errcrt*errcrt;

    errcrt = fabs(xa[i]);
    if ( errcrt > xanormc) xanormc = errcrt;
    xanorme += errcrt*errcrt;
    }


  for (i=0; i<n; i++)
    {
    errcrt = fabs(xa[i] - x[i]);
    if (errcrt > errc) errc = errcrt;
    erre = erre + errcrt*errcrt;

    rezcrt = 0;
    for (j=0; j<n; j++)
      rezcrt += mat[i][j]*x[j];
    rezcrt = fabs(rezcrt - b[i]);
    if (rezcrt > rezc) rezc = rezcrt;
    reze = reze + rezcrt*rezcrt;

    }

  printf("Norma erorii:\t\tabsoluta\trelativa\n");
  printf("\t* euclidiana: \t%e\t%e\n", sqrt(erre),sqrt(erre/xanorme));
  printf("\t* Cebisev   : \t%e\t%e\n", errc, (errc/xanormc));
  printf("\nNorma reziduului:\tabsoluta\trelativa\n");
  printf("\t* euclidiana: \t%e\t%e\n", sqrt(reze), sqrt(reze/bnorme));
  printf("\t* Cebisev   : \t%e\t%e\n", rezc, (rezc/bnormc));
  printf("\nTimpul de calcul : %f secunde\n\n",(end - start)/ CLK_TCK);
  fflush(stdin);
  printf("Pentru continuare apasati <Enter>:");
  getchar();

  } while(1);

}  /* end main */

void gen_sist(int n)
{
  int i,j;
  float s;

  randomize();
  for(i=0; i<n; i++)
    {
    for (j=0; j<n ; j++)
      {
      mat[i][j] = ((float)(rand())/RAND_MAX  );
      if (i==j) mat[i][j] /= 1000;
      /* Numere negative ?? */
      }
      xa[i] = ((float)(rand())/RAND_MAX);
    }
  for (i=0; i<n; i++)
    {
    s=0;
    for (j=0; j<n ; j++)
      s += mat[i][j]*xa[j];
    b[i] = s;
    }
}
