/* Rezolvarea sistemelor tridiagonale */
/*------------------------------------*/
/* Data : 28.01.90
 Rezolva un sistem de ecuatii cu matricea A tridiagonala.
 Date de intrare: q[N] = vectorul diagonalei
		  p[N] = vectorul subdiagonal
		  r[N] = vectorul de deasupra diagonalei.
 Nu se accepta q[i] nul. */

tridiag(int n, float p[N], float q[N], float r[N], float b[N], float x[N])
{

  int k;
  float s;

  /* Eliminare */
  for (k=1; k<n; k++)
    {
    if (q[k-1] == 0) return 1;	/* eroare */
    s = p[k]/q[k-1];
    q[k] -= r[k-1]*s;
    b[k] -= b[k-1]* s;
    }
  /* Substitutie */
  if (q[n-1] == 0) return 1; 	/* eroare */
  x[n-1] = b[n-1]/q[n-1];
  for (k=n-2; k>=0; k--)
    x[k] = (b[k] - r[k]*x[k+1]) / q[k];

  return 0;	/* all OK */
}