/* Rezolvare sistem cu matricea rara prin metoda Gauss fara pivotare.
Se genereaza aleator sisteme de ecuatii care se rezolva.
Sistemul nu are a[i,i] nuli.

Data : 11.02.1991
Programator : Irina Munteanu */
#define creaza_elem(elem)  val[nr++] = elem
#define N 20
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

int gen_sist_rare(int m,int nen);   /* Declarare proceduri */
afis_matr(void);
pivotare(int k);

/* Declaratiile s-au mutat temporar aici */
int   mat[N][N];  	/* matricea a */
float val[N*N+1];	/* vectorul rezultatelor obtinute dupa rezolvare */

int   mat1[N][N];	/* copia matricii a */
int   n,	  /* dimensiunea sistemului */
      i,j,	  /* variabile contor */
      car;	  /* caracter tastat la consola */
int nr,nrinit;	  /* numar de elemente nenule */


/* Procedura de factorizare fara pivotare */
/*----------------------------------------*/
/* Data:28.01.1990   */
fact_lu(int n, int (*a)[N])
{	/* n = dimens. matricii
	   a = matricea coeficientilor. */


   int i,j,k,modif;

   modif = 0;

   /* Eliminare */
   for (k=0; k<n; k++) /* Contor linii pivot */
     {
     if (k != 0)
       {
       gotoxy(2*k-1, k);
       if (a[k][k] > nrinit)
	 cprintf ("X");
       else
	 printf ("X");
       }
     textcolor( YELLOW );
     gotoxy(2*k+1, k+1);
     cprintf ("X");
     textcolor( WHITE );
     for (j=k+1; j<n; j++) /* Contor coloane urmatoare */
       if (a[k][j] != 0)
	 {
	 val[ a[k][j] ] /= val[ a[k][k] ];
	 for (i=k+1; i<n; i++)  /* Contor linii */
	   if (a[i][k] != 0)
	     {
	     if (a[i][j] != 0)
	       val[ a[i][j] ] -= val[ a[i][k] ]* val[ a[k][j] ];
	     else
	       {
	       creaza_elem(-val[ a[k][j] ]* val[ a[i][k] ]);
	       gotoxy(2*j+1, i+1);
	       cprintf ("X");
	       a[i][j] = nr;
	       modif = 1;
	       }
	     } /* if a[i][k] */
	 if ( modif != 0)
	   {
	   textattr(WHITE+(BLACK<<4)+BLINK);
	   gotoxy(2*j+1, k+1);
	   cprintf ("X");
	   gotoxy(1,24);
	   clreol();
	   printf(" S-a modificat coloana %d. Apasati <Enter> :",j+1,k+1);
	   getchar();
	   modif = 0;
	   textattr(WHITE+(BLACK<<4));
	   gotoxy(2*j+1, k+1);
	   if (a[k][j] > nrinit)
	     cprintf ("X");
	   else
	     printf ("X");
	   }
	 } /* if a[k][j] = 0 */
	 gotoxy(1,24);
	 clreol();
	 printf(" S-a terminat etapa %d. Apasati <Enter> :",k+1);
	 getchar();
       } /* pentru k */

}  /* end fact_lu */


/* Procedura de factorizare cu pivotare pe linii */
/*-----------------------------------------------*/
/* Data:28.01.1990   */
int fact_pl(int n, int (*a)[N])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   La iesire matricea a contine L+U-I.
	   Se face pivotare partiala pe linii .
	   Intoarce ier = 0 - all OK
		    ier = 1 - eroare. Nu se gaseste pivot diferit de 0. */

   /* Declaratii */
   int i,j,k;
   int modif;


   modif = 0;

   /* Eliminare */
   for (k=0; k<n; k++) /* Contor linii pivot */
     {
     pivotare(k);
     if (k != 0)
       {
       gotoxy(2*k-1, k);
       if (a[k][k] > nrinit)
	 cprintf ("X");
       else
	 printf ("X");
       }
     textcolor( YELLOW );
     gotoxy(2*k+1, k+1);
     cprintf ("X");
     textcolor( WHITE );

     for (j=k+1; j<n; j++) /* Contor coloane urmatoare */
       if (a[k][j] != 0)
	 {
	 val[ a[k][j] ] /= val[ a[k][k] ];
	 for (i=k+1; i<n; i++)  /* Contor linii */
	   if (a[i][k] != 0)
	     {
	     if (a[i][j] != 0)
	       val[ a[i][j] ] -= val[ a[i][k] ]* val[ a[k][j] ];
	     else
	       {
	       creaza_elem(-val[ a[k][j] ]* val[ a[i][k] ]);
	       gotoxy(2*j+1, i+1);
	       cprintf ("X");
	       a[i][j] = nr;
	       modif = 1;
	       }
	     } /* if a[i][k] */
	 if ( modif != 0)
	   {
	   textattr(WHITE+(BLACK<<4)+BLINK);
	   gotoxy(2*j+1, k+1);
	   cprintf ("X");
	   gotoxy(1,24);
	   clreol();
	   printf(" S-a modificat coloana %d. Apasati <Enter> :",j+1,k+1);
	   getchar();
	   modif = 0;
	   textattr(WHITE+(BLACK<<4));
	   gotoxy(2*j+1, k+1);
	   if (a[k][j] > nrinit)
	     cprintf ("X");
	   else
	     printf ("X");
	   }
	 } /* if a[k][j] = 0 */
	 gotoxy(1,24);
	 clreol();
	 printf(" S-a terminat etapa %d. Apasati <Enter> :",k+1);
	 getchar();
       } /* pentru k */
   return(0);	/* all OK */

} /* end functie */



void main()
{

  int nenule,nrprog;
  float dens;

do
  {
  clrscr();
  highvideo();
  printf("\n\t\tPROGRAM RARE\n");
  printf(  "\t\t============\n\n\n");
  printf("\tFactorizeaza matrici rare.\n\n");
  printf("Introduceti numarul de ecuatii (min.5, max.%d, altfel - iesire): ",N);
  scanf("%d",&n);
  if (n<2 || n>N) break;
  printf("Introduceti numarul maxim de elemente nenule pe linie ( max.%d): ",n);
  scanf("%d",&nenule);
  if (nenule<1 || nenule>n) continue;
  clrscr();

  /* Generare sistem de ecuatii */
  nrinit=gen_sist_rare(n,nenule);

  for (nrprog =0; nrprog<3; nrprog++)
    {
    nr = nrinit;
    /* Copiere matrice a, vector b pentru rezolvare */
    for (i=0;i<n;i++)
      for (j=0; j<n; j++)
	mat1[i][j] = mat[i][j];
    afis_matr();

    fflush(stdin);
    gotoxy(1,23);
    clreol();
    dens = (float)nr/(n*n)*100;
    printf("Densitatea initiala a matricei: %.2f \%.\n",dens);
    clreol();
    printf("Apasati <Enter> :");
    getchar();

    switch(nrprog)
      {
      case 0:
	gotoxy(1,23);
	clreol();
	cprintf("Factorizarea matricii rare fara pivotare");
	fact_lu(n,mat1);break;

      case 1:
	gotoxy(1,23);
	clreol();
	cprintf("Pivotarea statica a matricii rare ");
	for (i=0; i<n; i++)
	  pivotare(i);
	gotoxy(1,23);
	clreol();
	cprintf("Factorizarea matricii rare cu pivotare statica");
	fact_lu(n,mat1);break;

     case 2:
	gotoxy(1,23);
	clreol();
	cprintf("Factorizarea matricii rare cu pivotare dinamica");
	fact_pl(n,mat1);break;

     }


    fflush(stdin);
    gotoxy(1,23);
    clreol();
    dens = (float)nr/(n*n)*100;
    printf("Densitatea actuala a matricei: %.2f \%.\n",dens);
    clreol();
    printf("Apasati <Enter> :");
    getchar();
    }
  } while(1);
  lowvideo();
}  /* end main */



int gen_sist_rare(int n,int nenule)
{
  int k;  /* pozitia in val */
  int poz;  /* pozitia in linie */
  int i,j,crt;

  k=1;
  randomize();
  for(i=0; i<n; i++)
    {
    for (j=0; j<=n; j++)  /* contor coloane */
      mat[i][j] = 0;
    crt = random(nenule);  /* un numar mai mic decit nr.elem nenule */
    mat[i][i] = k;
    val[k++] = ((float)(rand())/RAND_MAX );
    j=0;
    do
      {
      poz = random(n);   /* o pozitie aleatoare in linie */
      if (mat[i][poz] == 0)
	{
	mat[i][poz] = k;
	val[k++] = ((float)(rand())/RAND_MAX );
	j++;
	}
      } while (j<crt);
    }   /* S-a generat matricea rara */

    return k;
}  /* end gen_sist_rare */


pivotare(int k)
{
  int m,min,minl,i;
  int crt,temp;

  /* Gaseste pivot */

  minl=k;
  min = 1000;

  textattr(WHITE+(BLACK<<4)+BLINK);
  gotoxy(2*k+1, k+1);
  cprintf ("*");
  for (m=k; m<n; m++)
    {
    crt = 0;
    for (i=0; i<n; i++)
      if (mat1[m][i] != 0) crt++;
	if (crt<min && mat1[m][k]!=0)
	 {
	 min = crt;
	 minl = m;
	 }
    } /* minl = linia min. min= nr.minim de elem */

    gotoxy(2*minl+1, minl+1);
    cprintf ("*");
    textattr(WHITE+(BLACK<<4));
    gotoxy(1,24);
    clreol();
    printf("Linia optima: %d. Apasati <Enter> :",minl+1);
    getchar();

    if (minl != k)  /* interschimba linia k cu linia min */
      {
      for (m=0; m<n; m++)
	{
	temp = mat1[k][m];
	mat1[k][m] = mat1[minl][m];
	mat1[minl][m] = temp;
	}
	/* S-a gasit pivotul */


       /* Interschimba liniile pe ecran */
    gotoxy(1, k+1);
    clreol();
    gotoxy(1, minl+1);
    clreol();
    for (m=0; m<n; m++)
      {
      gotoxy(2*m+1, k+1);
      if (mat1[k][m] !=0 )
	{
	if (mat1[k][m] > nrinit)
	  cprintf ("X");
	else
	  printf ("X");
	}
	gotoxy(2*m+1, minl+1);
	if (mat1[minl][m] !=0 )
	  {
	  if (mat1[minl][m] > nrinit)
	    cprintf ("X");
	  else
	    printf ("X");
	  }
	}
	gotoxy(1,24);
	clreol();
	printf(" S-au permutat liniile %d si %d. Apasati <Enter> :",k+1,minl+1);
	getchar();
      }
      else  /* minl este egal cu k */
	{
	gotoxy(2*k+1, k+1);
	if (mat1[k][k] != 0)
	   {
	   if (mat1[k][k] > nrinit)
	     cprintf ("X");
	   else
	     printf ("X");
	   }
	 else printf(" ");
	 }

} /* end pivotare */

afis_matr()
{
int i,j;

  for(i=0; i<n; i++)
    {
    gotoxy(1, i+1);
    clreol();
    for (j=0; j<n; j++)  /* contor coloane */
      if (mat1[i][j] != 0)
	{
	gotoxy(2*j+1, i+1);
	printf("X");
	}
    }
} /* end afis_matr */
