/* Testare procedura de rezolvare a unui sistem cu matricea
tridiagonala.
Se genereaza aleator sisteme de ecuatii care se rezolva.
Rezultatele nu se afiseaza. Se calculeaza eroarea maxima
si timpul de lucru, care se afiseaza.
Sistemul nu are a[i,i] nuli.

Data : 15.02.1991
Programator : Irina Munteanu */

#define N 100
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "tridiag.c"

void gen_sist_tridg(int m);   /* Declarare proc. de generare de sisteme aleatoare */


/* Declaratiile s-au mutat temporar aici */

float p[N],q[N],r[N], b[N], x[N];
int i,j,n,nr,ier;


float p[N],	  /* termenii de sub diagonala */
      q[N],	  /* termenii diagonali */
      r[N],	  /* termenii de deasupra diagonalei */

b[N], 	  /* vectorul termenilor liberi */
      xa[N],	  /* vectorul rezultatelor adevarate */
      x[N];	  /* vectorul rezultatelor obtinute dupa rezolvare */
int   n,	  /* dimensiunea sistemului */
      i,j,	  /* variabile contor */
      car;	  /* caracter tastat la consola */




void main()
{

clock_t start,end; /* inceput, sfirsit rulare procedura */
float errcrt, 		/* eroarea curenta */
      rezcrt,		/* norma curenta */
      erre, errc,	/* norma erorii: euclidiana, Cebisev */
      reze, rezc,	/* norma reziduului: euclidiana, Cebisev */
      bnorme, bnormc,	/* norma lui b: euclidiana, Cebisev */
      xanorme, xanormc;	/* norma solutiei adevarate: euclidiana, Cebisev */


float p1[N],q1[N],r1[N], b1[N];
int i,n,ier;


do{
  clrscr();
  printf("\n\t\tPROGRAM EVALUARE TRIDIAG\n");
  printf(  "\t\t========================\n\n\n");
  printf("Determina erori si timp de calcul la rezolvarea \n");
  printf("sistemelor tridiagonale de ecuatii liniare generate aleator.\n\n");
  printf("Introduceti numarul de ecuatii (min.2, max.%d, altfel - iesire): ",N);
  scanf("%d",&n);
  if (n<2 || n>N) break;

  /* Generare sistem de ecuatii */
  gen_sist_tridg(n);
  /* Copiere matrice a, vector b pentru rezolvare */
  for (i=0;i<n;i++)
    {
    p1[i] = p[i];
    q1[i] = q[i];
    r1[i] = r[i];
    b1[i] = b[i];
    }

  start = clock();	/* Determina timpul scurs */
  ier=tridiag(n,p1,q1,r1,b1,x);
  end = clock();

  if (ier != 0) printf("Eroare. Matrice nesingulara.");
  else
    {
    printf("\n\n\t\tRezultate :\n");
    printf(    "\t\t=========\n\n");

    erre = 0;	/* Calculeaza eroarea */
    errc = 0;
    reze = 0;
    rezc = 0;
    bnorme = 0;	/* Calculeaza eroarea */
    bnormc = 0;
    xanorme= 0;
    xanormc= 0;
    /* Calculeaza norma lui x adevarat si a lui b */
    for (i=0; i<n; i++)
      {
      errcrt = fabs(b[i]);
      if ( errcrt > bnormc) bnormc = errcrt;
      bnorme += errcrt*errcrt;

      errcrt = fabs(xa[i]);
      if ( errcrt > xanormc) xanormc = errcrt;
      xanorme += errcrt*errcrt;
      }


    for (i=0; i<n; i++)
      {
      errcrt = fabs(xa[i] - x[i]);
      if (errcrt > errc) errc = errcrt;
      erre = erre + errcrt*errcrt;

      rezcrt = p[i]*x[i-1] + q[i]*x[i] + r[i]*x[i+1];
      rezcrt = fabs(rezcrt - b[i]);
      if (rezcrt > rezc) rezc = rezcrt;
      reze = reze + rezcrt*rezcrt;

      }

    printf("Norma erorii:\t\tabsoluta\trelativa\n");
    printf("\t* euclidiana: \t%e\t%e\n", sqrt(erre),sqrt(erre/xanorme));
    printf("\t* Cebisev   : \t%e\t%e\n", errc, (errc/xanormc));
    printf("\nNorma reziduului:\tabsoluta\trelativa\n");
    printf("\t* euclidiana: \t%e\t%e\n", sqrt(reze), sqrt(reze/bnorme));
    printf("\t* Cebisev   : \t%e\t%e\n", rezc, (rezc/bnormc));
    printf("\nTimpul de calcul : %f secunde\n\n",(end - start)/ CLK_TCK);
    fflush(stdin);
    }
  printf("Pentru continuare apasati <Enter>:");
  getchar();

  } while(1);

}  /* end main */

void gen_sist_tridg(int n)
{
  int i;

  randomize();
  for(i=0; i<n; i++)
    {

/*      mat[i][j] = ((float)(rand())/RAND_MAX  );
      if (i==j) mat[i][j] /= 1000;
      /* Numere negative ?? */

    p[i] = ((float)(rand())/RAND_MAX);
    q[i] = ((float)(rand())/RAND_MAX);
    r[i] = ((float)(rand())/RAND_MAX);
    xa[i] = ((float)(rand())/RAND_MAX);
    }
  b[0] = q[0]*xa[0]+ r[0]*xa[1];
  b[n-1]=p[n-1]*xa[n-2] + q[n-1]*xa[n-1];
  for (i=1; i<n-1; i++)
    b[i] = p[i]*xa[i-1] + q[i]*xa[i] + r[i]*xa[i+1];

}  /* end gen_sist_rare */
