/* Rezolvarea circuitelor liniare rezistive.
Data : 18.02.1991
Programator: Irina Munteanu */

#define N 50
#define L 100
#include <stdio.h>
#include <conio.h>


/* Procedura Gauss fara pivotare */
int gauss_fp(int n, float (*a)[N], float b[], float x[])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;
   float s,p;

   /* Eliminare */
   for (k=0; k<n-1; k++) /* Contor linii pivot */
     {
     if (a[k][k] == 0) return 1;  /* Eroare */
     for (i=k+1; i<n; i++) /* Contor linii urmatoare */
       {
       p=a[i][k]/a[k][k];
       for (j=k; j<n; j++)  /* Contor coloane */
	 {
	 a[i][j] -= p*a[k][j];
	 }
       b[i] -= p*b[k];
       }
     }

   /* Retrosubstitutie */
   if (a[n-1][n-1] == 0) return 1;  /* Eroare */
   x[n-1] = b[n-1]/a[n-1][n-1];

   for (i=n-2; i>=0; i--)
     {
     s = b[i];
     for (j=n-1; j>i; j--)
       s -= a[i][j]*x[j];
     x[i] = s/a[i][i];
     }

   return 0;  /* all OK */
}	/* end functie GAUSSFP */


main()
{
int   n,	  /* numarul de noduri */
      l,	  /* numarul de laturi */
      i,j,	  /* variabile contor */
      ier;
float g[N][N],
      is[N],
      v[N];
int   ni[N],n1,
      nf[N],n2;
float e[L],
      r[L],
      u,
      intens;
float pc,pg;

highvideo();
do{
  clrscr();
  printf("\n\tREZOLVAREA CIRCUITELOR LINIARE REZISTIVE\n");
  printf(  "\t========================================\n\n\n");

  printf("\nIntroduceti numarul de laturi(min.2, max.%d, altfel - iesire): ",L);
  scanf("%d",&l);
  if (l<2 || l>L) break;
  printf("\nIntroduceti numarul de noduri(min.2, max.%d) : ",N);
  scanf("%d",&n);
  if (n<2 || n>N) continue;

  for (i=0; i<l; i++)
    {
    cprintf("\n\rLatura %d\n\r", i+1);
    printf("Nodul initial: ");
    scanf("%d",&ni[i]);
    ni[i]--;
    if (ni[i]>n-1 || ni[i]<0)
      {
      printf("\nNumar de nod incorect\n");
      i--;
      continue;
      }
    printf("Nodul final: ");
    scanf("%d",&nf[i]);
    nf[i]--;
    if (nf[i]>n-1 || nf[i]<0)
      {
      printf("\nNumar de nod incorect\n");
      i--;
      continue;
      }

    printf("Rezistenta: ");
    scanf("%f",&r[i]);
    if (r[i] == 0)
      {
      printf("\nNu se admit laturi de rezistenta nula");
      i--;
      continue;
      }
    printf("Tensiunea electromotoare: ");
    scanf("%f",&e[i]);
    }
  for (i=0; i<n; i++)
    {
    is[i] = 0;
    for (j=0; j<n; j++)
      g[i][j] = 0;
    }
  for (i=0; i<l; i++)
    {
    n1 = ni[i];
    n2 = nf[i];
    g[n1][n1] += 1./r[i];
    g[n2][n2] += 1./r[i];
    g[n1][n2] -= 1./r[i];
    g[n2][n1] -= 1./r[i];
    is[n1] -= e[i]/r[i];
    is[n2] += e[i]/r[i];
    }

  ier = gauss_fp(n-1,g,is,v);
  if (ier)
    {
    fflush(stdin);
    printf("\n\nCircuit prost formulat");
    getchar();
    continue;
    }
  v[n-1] = 0;
  pc = pg = 0;
  clrscr();
  printf("\n\tRezultatele\n\t===========\n");
  for (i=0; i<l; i++)
    {
    n1 = ni[i];
    n2 = nf[i];
    u = v[n1] - v[n2];
    intens = (u+e[i]) / r[i];
    printf ("Latura: %d  \tI = %f  \tU = %f\n", i+1, intens,u);
    pc += r[i]*intens*intens;
    pg += e[i]*intens;
    }
  printf("\n\tPuterea consumata: %f\n",pc);
  printf("\tPuterea generata : %f\n",pg);


  fflush(stdin);
  printf("\nPentru continuare apasati <Enter>:");
  getchar();
  } while(1);
  lowvideo();

}  /* end main */