/* Rezolvarea circuitelor liniare rezistive de curent alternativ.
Data : 04.03.1991
Programator: Irina Munteanu */

#define N 25
#define L 100
#define PI (atan(1)*4)
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "complex.c"

float g[N][N],
	  y[N][N],
	  real_is[N],
	  imag_is[N],
	  v[2*N];


main()
{
int   n,	  /* numarul de noduri */
	  lat,	  /* numarul de laturi */
      i,j,	  /* variabile contor */
	  ier,
	  tip;



int   ni[L],n1,
	  nf[L],n2;
float e[L],
	  fi_e[L],
	  r[L],
	  l[L],
	  c[L],
	  u1,u2,
	  fi,
	  i_r, i_c, intens,  /* partea reala, imaginara si val.efect.a lui I*/
	  real_e, imag_e,
	  omega;
float pc,pg,qc,qg;


highvideo();
do{
  clrscr();
  printf("\n\tREZOLVAREA CIRCUITELOR LINIARE REZISTIVE DE C.A.\n");
  printf(  "\t================================================\n\n\n");

  printf("\nIntroduceti numarul de laturi(min.2, max.%d, altfel - iesire): ",L);
  scanf("%d",&lat);
  if (lat<2 || lat>L) break;
  printf("\nIntroduceti numarul de noduri(min.2, max.%d) : ",N);
  scanf("%d",&n);
  if (n<2 || n>N) continue;
  printf("\nIntroduceti frecventa: ");
  scanf("%f",&omega);
  omega = omega*2*PI;

  for (i=0; i<lat; i++)  /* Initializeaza r, l, c cu 0 */
	{
	r[i] = 0;
	l[i] = 0;
	c[i] = 0;
	}
  for (i=0; i<lat; i++)
    {
    cprintf("\n\rLatura %d\n\r", i+1);
    printf("Nodul initial: ");
    scanf("%d",&ni[i]);
    ni[i]--;
    if (ni[i]>n-1 || ni[i]<0)
      {
      printf("\nNumar de nod incorect\n");
      i--;
      continue;
      }
    printf("Nodul final: ");
    scanf("%d",&nf[i]);
    nf[i]--;
    if (nf[i]>n-1 || nf[i]<0)
      {
      printf("\nNumar de nod incorect\n");
      i--;
      continue;
      }

	fflush(stdin);
	printf("Tipul laturii (R,L,C): ");
	tip = getchar();
	ier = 0;
	switch(tip)
	  {
	  case 'R':
	  case 'r':
		printf("Rezistenta: ");
		scanf("%f",&r[i]);
		if (r[i] == 0)
		  {
		  printf("\nNu se admit laturi de rezistenta nula\n");
		  i--;
		  ier = 1;
		  }
		break;

	  case 'L':
	  case 'l':
		printf("Inductivitatea: ");
		scanf("%f",&l[i]);
		if (l[i] == 0)
		  {
		  printf("\nNu se admit laturi de inductanta nula\n");
		  i--;
		  ier = 1;
		  }
		l[i] = -l[i]*omega;
		break;

	  case 'C':
	  case 'c':
		printf("Capacitatea: ");
		scanf("%f",&c[i]);
		if (c[i] == 0)
		  {
		  printf("\nNu se admit laturi de capacitate nula\n");
		  i--;
		  ier = 1;
		  }
		c[i] = c[i]*omega;
		break;

	  default:
		printf("\nTip latura incorect !!\n");
		i--;
		ier = 1;

	  } /* End switch */

	if (ier) continue;
	printf("Valoarea efectiva a tensiunii electromotoare: ");
	scanf("%f",&e[i]);
	if (e[i] != 0)
	  {
	  printf("Faza initiala a tensiunii electromotoare: ");
	  scanf("%f",&fi_e[i]);
	  }
	}

  for (i=0; i<n; i++)
	{
	real_is[i] = 0;
	imag_is[i] = 0;
	for (j=0; j<n; j++)
	  {
	  g[i][j] = 0;
	  y[i][j] = 0;
	  }
	} /* S-au facut initializari */

  /* Calculeaza coeficientii reali - imaginari ai lui: G, Y, Is */
  for (i=0; i<lat; i++)
    {
    n1 = ni[i];
	n2 = nf[i];
	real_e = e[i]*cos(fi_e[i]*PI/180.);
	imag_e = e[i]*sin(fi_e[i]*PI/180.);
	if (r[i] != 0)
	  {
	  g[n1][n1] += 1./r[i];
	  g[n2][n2] += 1./r[i];
	  g[n1][n2] -= 1./r[i];
	  g[n2][n1] -= 1./r[i];
	  real_is[n1] -= real_e /r[i];
	  real_is[n2] += real_e/r[i];
	  imag_is[n1] -= imag_e/r[i];
	  imag_is[n2] += imag_e/r[i];
	  }
	else if (l[i] != 0)
	  {
	  y[n1][n1] += 1./l[i]; /* Acum l[i] are valoarea -L*omega */
	  y[n2][n2] += 1./l[i];
	  y[n1][n2] -= 1./l[i];
	  y[n2][n1] -= 1./l[i];
	  imag_is[n1] -= real_e/l[i];
	  imag_is[n2] += real_e/l[i];
	  real_is[n1] -= -imag_e/l[i];
	  real_is[n2] += -imag_e/l[i];
	  }
	else if (c[i] != 0)
	  {
	  y[n1][n1] += c[i]; /* Acum c[i] are valoarea C*omega */
	  y[n2][n2] += c[i];
	  y[n1][n2] -= c[i];
	  y[n2][n1] -= c[i];
	  imag_is[n1] -= real_e*c[i];
	  imag_is[n2] += real_e*c[i];
	  real_is[n1] -= -imag_e*c[i];
	  real_is[n2] += -imag_e*c[i];
	  }
	}



/*do{*/
  ier = rezolva_complex(n-1, g, y, real_is, imag_is, v);
  if (ier)
    {
    fflush(stdin);
    printf("\n\nCircuit prost formulat");
    getchar();
    continue;
	}

/*  printf("Apasati 'c' pentru a relua cu aceleasi date: ");
  fflush(stdin);
  } while (getchar() == 'c');*/

  v[2*n-1] = 0;
  pc = pg = qc = qg = 0;
  clrscr();
  printf("\n\tRezultatele\n\t===========\n");
  for (i=0; i<lat; i++)
    {
    n1 = ni[i];
	n2 = nf[i];
	if (n1 == n-1)
	  {
	  n1 = 2*n-1;
	  u2 = v[n1] - v[n+n2-1];
	  }
	else if (n2 == n-1)
	  {
	  n2 = 2*n-1;
	  u2 = v[n+n1-1] - v[n2];
	  }
	else u2 = v[n+n1-1] - v[n+n2-1];

	u1 = v[n1] - v[n2]; /* Partea reala */

	real_e = e[i]*cos(fi_e[i]*PI/180.);
	imag_e = e[i]*sin(fi_e[i]*PI/180.);

	if (r[i] != 0)
	  {
	  i_r = (u1 + real_e)/r[i];
	  i_c = (u2 + imag_e)/r[i];
	  }
	else
	  {
	  if (l[i] != 0) c[i] = 1./l[i];
	  i_r = -(u2 + imag_e) * c[i];
	  i_c = (u1 + real_e) * c[i];
	  }
	intens = sqrt( i_r*i_r + i_c*i_c);
	if (i_c == 0 && i_r == 0) fi = 0;
	else fi = atan2(i_c,i_r)*180/PI;
	printf ("Latura: %d  \tI = %f  \tFaza initiala = %f grade\n", i+1, intens,fi);
	if (r[i] != 0)
	  pc += r[i]*intens*intens;
	else
	  qc -= intens*intens/c[i];
	pg += real_e*i_r + imag_e*i_c;
	qg += imag_e*i_r - real_e*i_c;
    }
  printf("\n\tPuterea consumata: activa= %f\treactiva= %f\n",pc,qc);
  printf(  "\tPuterea generata : activa= %f\treactiva= %f\n",pg,qg);


  fflush(stdin);
  printf("\nPentru continuare apasati <Enter>:");
  getchar();
  } while(1);
  lowvideo();

}  /* end main */