/* Rezolvarea unui sistem de ecuatii prin metoda Jacobi */
/*------------------------------------------------------*/
/* Data : 28.01.1991
  Procedura este facuta fara pivotare.
  Restrictie : oricare a[i][i] nenul
  Intoarce : 0 = all OK
	     1 = pivot nul
	     2 = depasire nr. iteratii
	     3 = overflow */

jacobi(int n, float (*a)[N], float b[N], float x[N], int *nrit, float *eps)
{

  int i,j,k,ier;
  float s,err, xn[N];


  /* Initializari */
  k=0;	/* contor iteratii */
  ier = 0; /* indicator overflow */
  for (i=0; i<n; i++)
    {
    if (a[i][i] == 0) return 1; 	/* eroare */
    x[i] = 0;  /* x vechi; solutia */
    }

  do
    {
    err = 0;			/* eroarea */
    for ( i=0; i<n; i++)	/* ecuatia curenta */
      {
      s = b[i];
      for (j=0; j<n; j++)	/* parcurge ecuatia */
	s -= a[i][j]*x[j];
      xn[i] = (s+a[i][i]*x[i])/a[i][i];	/* se elimina termenul cu x[i] */
      s = fabs(xn[i]-x[i]);	/* x nou - x vechi */
      if (err < s) err=s;
      }
    for ( i=0; i<n; i++)
      x[i] = xn[i];
    k++;	/* incrementeaza contor iteratii */
    if (err>1.e+38) {ier = 1;break;}

  } while ((err > *eps) && (k <= *nrit));  /* cit timp.cond. e indepl.*/
  *eps = err;
  if (k>*nrit)
    {
    *nrit = k;
    return 2;	/* eroare: nr. iteratii */
    }
  *nrit = k;
  if (ier) return 3; /* eroare:overflow */
  return 0;	/* all OK */
}
