/* Testare procedura Jacobi.
Sistemul nu are a[i,i] nuli. */

#define N 5
#define MAXIT 100
#include <math.h>
#include <stdio.h>
#include <conio.h>


/* Rezolvarea unui sistem de ecuatii prin metoda Jacobi */
/*------------------------------------------------------*/
/* Data : 28.01.1991
  Procedura este facuta fara pivotare.
  Restrictie : oricare a[i][i] nenul
  Intoarce : 0 = all OK
	     1 = pivot nul
	     2 = depasire nr. iteratii*/

jacobi(int n, float (*a)[N], float b[N], float x[N], int *nrit, float *eps)
{

  int i,j,k,ier;
  float s,err, xn[N];


  /* Initializari */
  k=0;	/* contor iteratii */
  ier=0; /* indice overflow */
  for (i=0; i<n; i++)
    {
    if (a[i][i] == 0) return 1; 	/* eroare */
    x[i] = 0;  /* x vechi; solutia */
    }
  gotoxy(1,2*n+7);
  printf("Pentru oprire apasati o tasta ...");

  do
    {
    err = 0;			/* eroarea */
    for ( i=0; i<n; i++)	/* ecuatia curenta */
      {
      s = b[i];
      for (j=0; j<n; j++)	/* parcurge ecuatia */
	s -= a[i][j]*x[j];
      xn[i] = (s+a[i][i]*x[i])/a[i][i];	/* se elimina termenul cu x[i] */
      s = fabs(xn[i]-x[i]);	/* x nou - x vechi */
      if (err < s) err=s;
      }
    for ( i=0; i<n; i++)
      {
      x[i] = xn[i];
      gotoxy(1, n+i+4);
      printf("%f",x[i]);
      }
    k++;	/* incrementeaza contor iteratii */
    gotoxy(1,2*n+5);
    clreol();
    printf("Iteratia: %d. Eroarea: %e",k,err);
    if (kbhit()) break;
    if (err > 1.e+38) {ier=1;break;}
  } while ((err > *eps) && (k <= *nrit));  /* cit timp.cond. e indepl.*/
  *eps = err;
  if (k>*nrit)
    {
    *nrit = k;
    return 2;	/* eroare: nr. iteratii */
    }
  *nrit = k;
  if (ier) return 3;
  return 0;	/* all OK */
}  /* end JACOBI */



main()
{
float mat[N][N],  /* matricea a */
      b[N], 	  /* vectorul termenilor liberi */
      x[N];	  /* vectorul rezultatelor */
int   n,	  /* dimensiunea sistemului */
      ier,	  /* indice de eroare */
      i,j;	  /* variabile contor */
float eps;
int nrit;

do{
  clrscr();
  printf("\n\t\tPROGRAM TEST JACOBI\n");
  printf(  "\t\t===================\n\n\n");
  printf("Rezolva sisteme liniare prin metoda Jacobi\n\n");

  printf("\nIntroduceti numarul de ecuatii (min.2, max.5, altfel - iesire): ");
  scanf("%d",&n);
  if (n<2 || n>5) break;
  for(i=0; i<n; i++)
    {
    for (j=0; j<n ; j++)
      {
      printf("a(%d,%d) = ",i+1,j+1);
      scanf("%f",&mat[i][j]);
      }
    }
  for (j=0; j<n ; j++)
    {
    printf("b(%d) = ",j+1);
    scanf("%f",&b[j]);
    }
  printf("Introduceti eroarea admisa: ");
  scanf("%g",&eps);
  nrit = MAXIT;

  clrscr();
  printf("    A");
  gotoxy(9*n+8,1);
  printf("        b");
  for (i=0; i<n; i++)
    {
    for (j=0; j<n; j++)
      {
      gotoxy(9*j+1, i+2);
      printf("%8.2f", mat[i][j]);
      }
    gotoxy(9*n+12, i+2);
    printf("%8.2f", b[i]);
    }
  gotoxy(1,n+3);
  fflush(stdin);
  printf("Pentru continuare apasati <Enter>:");
  getchar();
  gotoxy(1,n+3);
  clreol();
  printf("   x");
  ier = jacobi(n,mat,b,x,&nrit,&eps);

  gotoxy(1,2*n+7);
  clreol();

  switch(ier)
    {
    case 1: printf("    Eroare : pivot nul.\n");break;
    case 2: printf("    Eroare : depasire numar de iteratii.\n");break;
    case 3: printf("    Eroare : depasire domeniu.\n");
    }
    printf("Pentru continuare apasati <Enter>:");
    getchar();

  } while(1);

}  /* end main */

/* Testare metode iterative de rezolvare a unui sistem.
Sistemul nu are a[i,i] nuli.

#define N 4
#include <stdio.h>
#include <math.h>	/* necesar ptr. modul */

/*#include <\i\jacobi.c>
#include <\i\seidel.c>
#include <\i\frankel.c>

main()
{
float mat[N][N], b[N], x[N];
float omega,eps; /* factor suprarelaxare,eroarea prescrisa
int i,j,n,nr,ier;
int nrit;

printf("introduceti n:\n");
scanf("%d",&n);
printf("introduceti matricea a:\n");
for(i=0; i<n; i++)
  for (j=0; j<n ; j++)
    scanf("%f",&mat[i][j]);
printf("introduceti vectorul b:\n");
for (j=0; j<n ; j++)
  scanf("%f",&b[j]);
printf("introduceti nr.maxim de iteratii:\n");
scanf("%d",&nrit);
printf("introduceti eroarea admisa:\n");
scanf("%f",&eps);
printf("introduceti factorul de suprarelaxare:\n");
scanf("%f",&omega);


/*ier = jacobi(n,mat,b,x,&nrit,&eps);
ier = seidel(n,mat,b,x,&nrit,&eps);*/

/*ier = frankel(n,mat,b,x,omega,&nrit,&eps);
switch(ier)
  {
  case 0:
    {
    printf("Rezultatele :\n");
    for (i=0; i<n; i++)
      {
      printf("%f  ", x[i]);
      if (((i+1)%3)==0) printf("\n");
      }
    printf("\nNumar de iteratii : %d\n", nrit);
    printf("Precizia obtinuta : %f\n", eps );
    break;
    }
  case 1: printf("Eroare:pivot nul\n");break;
  case 2: printf("Eroare:depasire numar de iteratii\n");
  }
printf("\n");

}  /* end main */
