/* Procedura Gauss cu pivotare pe linii */
/*--------------------------------------*/
/* Data:28.01.1990   */
int gauss_pl1(int n, float (*a)[N], float b[], float x[])
{	/* n = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b.
	   Se face pivotare partiala pe linii fara
	   cautarea pivotului optim ci doar a unui pivot
	   nenul de modul maxim.
	   Intoarce ier = 0 - all OK
		    ier = 1 - eroare. Nu se gaseste pivot diferit de 0. */

   /* Declaratii */
   int i,j,k,m,max;
   float p, temp, s ;


   /* Eliminare */
   for (i=0; i<n-1; i++) /* Contor linii pivot */
     {
     /* Gaseste pivot */

     max=i;
     for (m=i+1; m<n; m++)
       if (fabs(a[m][i]) > fabs(a[max][i])) max = m;
     if ( a[max][i] == 0) return 1; /* Eroare */
     else if (max != i)  /* interschimba linia i cu linia max */
       {
       for (m=i; m<n; m++)
	 {
	 temp = a[i][m];
	 a[i][m] = a[max][m];
	 a[max][m] = temp;
	 }
       temp = b[i];
       b[i] = b[max];
       b[max] = temp;
       }  /* S-a gasit pivotul */

     for (k=i+1; k<n; k++) /* Contor linii urmatoare */
       {
       if (a[k][i] != 0)
	 {
	 p=a[k][i]/a[i][i];
	 for (j=i+1; j<n; j++)  /* Contor coloane */
	   a[k][j] -= p*a[i][j];
	 b[k] -= p*b[i];
	 }
       }
     }

   /* Retrosubstitutie */
   if (a[n-1][n-1] == 0) return 1; /* eroare */
   x[n-1] = b[n-1]/a[n-1][n-1];
   for (i=n-2; i>=0; i--)
     {
     s=b[i];
     for (j=n-1; j>i; j--)
       s -= a[i][j]*x[j];
     x[i] = s/a[i][i];
     }

   return(0);	/* all OK */
}	/* end functie */

