#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>
#include "c:\radu\grader.cpp"

void trapeze(void);
void simpson(void);
void romberg(int nr_iter);
clock_t start, end;

float depo[2][N];
int col, cont, it, met;
float rez, h, rezi, rez0 = 0;
char c[20];



void main(void)
{
  do{
	clrscr();
	c[0] = 16;
	textcolor(LIGHTCYAN);
	cprintf("\n\r           PROGRAM PENTRU ANALIZA ERORII LA INTEGRAREA NUMERICA");
	cprintf("\n\r           ====================================================");
	cprintf("\n\n\n\n\n\r            Programul traseaza graficul de variatie a ERORII in\n\r        functie de PASUL DE INTEGRARE ( h ), la calculul integralei\n\r        definite a functiei SINUS, intre 0 si .");
	cprintf("\n\n\r     INTEGRARE PRIN :      1). Metoda trapezelor");
	cprintf("\n\r                           2). Metoda Simpson");
	cprintf("\n\r                           3). Metoda Romberg cu doua iteratii");
	cprintf("\n\r                           4). Metoda Romberg cu trei iteratii");
	textcolor(YELLOW);
	cprintf("\n\n\r      Alegeti metoda de integrare ( 1 ... 4, altfel iesire) : ");
	fflush(stdin);
	//scanf("%d", &met);
	met = atoi(cgets(c));
	if (met < 1 || met > 4) exit (0);
	cprintf("\n\n\n\n\n\n\r                       ASTEPTATI REZULTATUL !");
	switch (met){
		case 1: trapeze();  break;
		case 2: simpson();  break;
		case 3: romberg(2); break;
		case 4: romberg(3); break;
	}
  }while (1);
}

	/*do{
		cprintf("\n\r      Nr. interv. trapeze (minim 1, maxim 100, 0 pentru iesire) : ");
		fflush(stdin);
		scanf("%d", &nr_trap);
		if (nr_trap == 0) exit(0);
	}while (nr_trap < 1 || nr_trap > 100);
	cprintf("\n\r      Nr. puncte trapeze : ");
	scanf("%d", &pcte_trap);

	do{
		cprintf("\n\r      Nr. interv. Simpson (minim 2, maxim 100, par) : ");
		scanf("%d", &nr_simps);
	}while ((nr_simps % 2) == 1 || nr_simps < 2 || nr_simps > 100);
	cprintf("\n\r      Nr. puncte Simpson : ");
	scanf("%d", &pcte_simps);

	do{
		cprintf("\n\r      Nr. minim interv. Romberg (minim 1, maxim 25) : ");
		scanf("%d", &nr_romb);
	}while (nr_romb < 1 || nr_romb > 25);
	cprintf("\n\r      Nr. puncte Romberg : ");
	scanf("%d", &pcte_romb);

	do{
		cprintf("\n\r      Nr. iteratii Romberg (nr. minim interv. x nr. iter. <= 100) : ");
		scanf ("%d", &nr_iter);
	}while (nr_iter*nr_romb < 1 || nr_iter*nr_romb > 100);

	cprintf("\n\r   Factor : ");
	scanf("%f", &fact);*/


void trapeze(void)
{
	start = clock();
	for (col = 70 - 1; col >= 0; col--){
		depo[0][col] = h = M_PI / (1 + 2*(70 - 1 - col));
		rez = 0;
		for (cont = 0; cont < M_PI / h; cont++)
			rez += h * (sin(cont * h) + sin((cont+1) * h)) / 2;
		depo[1][col] = fabs(rez - 2);
	}
	end = clock();
	cprintf("\r                TIMPUL DE CALCUL : %f  [secunde]", (end-start) / CLK_TCK);
	cprintf("\n\n\r                Apasati o tasta");
	getch();
	for (col = 0; col < 70; col++){
		if (depo[1][col] < 1e-20)
			depo[1][col] = 1e-20;
	}
	initial();
	subplot(1, 1, 1);
	grafic(1, 70, depo, 1, 1);
	grid();
	label_x("Pasul de integrare");
	label_y("Eroarea");
	title("Metoda trapezelor");
	getch();
	restorecrtmode();
}

void simpson(void)
{
	start = clock();
	for (col = 70 - 1; col >= 0; col--){
		depo[0][col] = h = M_PI / (2 + 2*(70 - 1 - col));
		rez = 0;
		for (cont = 0; cont < M_PI / h - 1; cont++){
			rez += h * (sin(cont*h) + 4*sin((cont+1)*h) + sin((cont+2)*h)) / 3;
			cont++;
		}
		depo[1][col] = fabs(rez - 2);
	}
	end = clock();
	cprintf("\r                TIMPUL DE CALCUL : %f  [secunde]", (end-start) / CLK_TCK);
	cprintf("\n\n\r                Apasati o tasta");
	getch();
	for (col = 0; col < 70; col++){
		if (depo[1][col] < 1e-20)
			depo[1][col] = 1e-20;
	}
	initial();
	subplot(1, 1, 1);
	grafic(1, 70, depo, 1, 1);
	grid();
	label_x("Pasul de integrare");
	label_y("Eroarea");
	title("Metoda de integrare Simpson");
	getch();
	restorecrtmode();
}

void romberg(int nr_iter)
{
	start = clock();
	for (col = 50 - 1; col >= 0; col--){
		depo[0][col] = M_PI / (1 + 2*(50 - 1 - col)) / pow(2, nr_iter);
		for(it = 0; it <= nr_iter; it++){
			rez = 0;
			h = M_PI / (1 + 2*(50 - 1 - col)) / pow(2, it);
			for (cont = 0; cont < M_PI / h; cont++)
				rez += h * (sin(cont*h) + sin((cont+1)*h)) / 2;
			if (it != 0)  rezi = (4*rez - rez0) / 3;
			rez0 = rez;
		}
		depo[1][col] = fabs(rezi - 2);
	}
	end = clock();
	cprintf("\r                TIMPUL DE CALCUL : %f  [secunde]", (end-start) / CLK_TCK);
	cprintf("\n\n\r                Apasati o tasta");
	getch();

	for (col = 0; col < 50; col++){
		if (depo[1][col] < 1e-20)
			depo[1][col] = 1e-20;
	}
	initial();
	subplot(1, 1, 1);
	grafic(1, 50, depo, 1, 1);
	grid();
	label_x("Pasul de integrare");
	label_y("Eroarea");
	switch(nr_iter){
		case 2:    title("Metoda de integrare Romberg; iteratia 2");  break;
		case 3:    title("Metoda de integrare Romberg; iteratia 3");  break;
	}
	getch();
	restorecrtmode();
}
