	/*
		[]----------------------------------------[]
		|	 Nume program : EULER0               |
		| - Rezolva ecuatii diferentiale ordinare  |
		| prin metodele Euler implicita,explicita; |
		| - Traseaza graficul functiei;            |
		| - Afiseaza solutiile exacte,aproximative |
		|   si eroarea pe pas.                     |
		[]----------------------------------------[]  */

#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include "c:\mn\rezdif\euler\grafeu.cp"

# define 	D	double

D	a,b,h,y0,tmax;
extern float val[M+1][N];

D funcan(D t)
{
	D	f;

	if (a!=0) f = ((a*y0+b)*exp(a*t) - b)/a;
	else f = b*t + y0;
	return(f);
}

void graf(int n,D *ye,D *yi)
{
	int	i;

	initial();
	subplot(1,1,1);
	for (i=0;i<=n;i++)
	{
		val[0][i] = (float)(i*h);
		val[1][i] = (float)ye[i];
		val[2][i] = (float)yi[i];
		val[3][i] = (float)(funcan(i*h));
	}
	plot(3,n+1,val);
	grid();
	restore();
	return;
}

D euler_exp (D y,D h,D a,D b)
{
	return ( y + h*(a*y + b) );
}

D euler_imp (D y,D h,D a,D b)
{
	D     newy = 0;

	newy = (y+h*b)/(1-a*h);
	return (newy);
}

void write_t(D t)
{
	gotoxy (4,22);
	cprintf("t = %5.3f",t);
	return;
}

void solve (D *ye,D *yi)
{
	int	i,n;
	D	t = 0;			          /* nod initiala */

	ye[0] = y0;                              /* conditii initiale */
	yi[0] = ye[0];
	n = tmax/h + 1;                          /* nr. maxim de pasi */
	for ( i = 1; i <= n; i++ )                    /* calcul */
	{
		ye[i] = euler_exp (ye[i-1],h,a,b);  /* calcul Euler - explicit */
		t =t + h;                               /* nod nou */
		yi[i]= euler_imp (yi[i-1],h,a,b);   /* calcul Euler - implicit */
		if ((int)(100.*t)%10==0 ) write_t (t);
	}
	graf(n,ye,yi);
	return;
}

void waitkey(int x,int y)
{
	gotoxy(6,24);
	cputs("APASA O TASTA...");
	getch();
	gotoxy(x,y);
	return;
}

void display (D *ye,D *yi)
{
	int	i,n;
	D	y,t;

	clrscr();
	textcolor (WHITE);
	n = tmax/h + 1;                          /* nr. maxim de pasi */
	cputs(" pas |    explicit   |    implicit   |    analitic   |  err-expl |  err-impl\n\r");
	cputs("---------------------------------------------------------------------------\n\r");
	window(1,3,80,25);
	for ( i=1;i<=n;i++ )
	{
		t = i*h;
		y = funcan (t);
		cprintf("%4.2f | % 13.6f | % 13.6f | % 13.6f | % 8.5f  | % 8.5f\n\r",t,ye[i],yi[i],
			y,y - ye[i],y - yi[i]);
		if ( wherey()==23 )
		{
			waitkey(1,1);
			clrscr();
		}
	}
	window(1,1,80,25);
	waitkey(1,24);
	return;
}

int next(void)
{
	char	c;

	clrscr();
	gotoxy(5,10);
	cputs("Ecuatie noua?[D/N]");
	c = getch();
	if ( c=='d' || c=='D' ) return 1;
	return 0;
}
void input(void)
{
	char	c[20];

	c[0] = 16;
	clrscr();
	textcolor (LIGHTCYAN);
	gotoxy (4,2);
	cputs ("Programul rezolva ecuatia : dy/dt = a*y + b.\n\r\n\r");
	cputs ("   Interval de integrare  : t  [0,tmax] [s].");
	gotoxy(1,10);
	textcolor(YELLOW);
	cputs("      Coeficientul a : ");
	a = atof( cgets(c));
	cputs("\n\r      Coeficientul b : ");
	b = atof( cgets(c));
	cputs("\n\r      Conditia initiala y(0) : ");
	y0 = atof( cgets(c));
	cputs("\n\r      Pasul de integrare h(nenul) : ");
	h = fabs( atof( cgets(c)) );
	if (h==0.) h=0.01;
	cputs("\n\r      tmax : ");
	if ( y0==0. && b==0.) y0 = 1.;
	tmax = fabs( atof( cgets(c)) );
	if (tmax==0.) tmax = 100.*h;
	if (h==0.) h = tmax/300.;
	if ( (int)(tmax/h)>400 ) tmax = h*390.;
	return;
}

main()
{
	D	ye[N],				/*tablou solutie explicita*/
		yi[N];				/*tablou solutie implicita*/

	do
	{
		input();
		solve(ye,yi);
		display(ye,yi);
	}while( next() );
	return;
}

