	/*
	[]-------------------------------------------------------[]
	|			 Nume program : EULER1                  |
	|  - Rezolva ecuatia : dy/dt = -y prin metodele Euler     |
	| implicita,explicita,pentru pasi de integrare definiti   |
	| de utilizator;				                      |
	| - Pentru metoda implicita se introduce si eroarea       |
	| de aproximatie admisa;                                  |
	| - Intervalul de integrare este [0,4];			    |
	| - Conditia initiala este y(0) = 5;			    |
	| - Se afiseaza pentru cele 2 metode erorile pentru       |
	| primul pas si erorile globale;				    |
	| - Pentru metoda implicita se afiseaza si numarul de	    |
	| iteratii efectuate pentru atingerea preciziei impuse    |
	[]-------------------------------------------------------[]  */

# include <conio.h>
# include <math.h>
# include <stdlib.h>

# define 	D	double

D	a = -1.,b = 0.,				/* coeficientii ecuatiei */
	h,						/* pasul de integrare */
	y0 = 1.,					/* conditia initiala */
	tmax = 4.,					/* limita de integrare */
	err;						/* eroarea admisa */
unsigned long iter;				/* nr. iteratii */
unsigned long nimpl;				/* nr. apelari euler_imp */

D funcan(D t)
{
	D	f;

	if (a!=0) f = ((a*y0+b)*exp(a*t) - b)/a;
	else f = b*t + y0;
	return(f);
}

D euler_exp (D y,D h,D a,D b)
{
	return ( y + h*(a*y + b) );
}

D euler_imp (D y,D h,D a,D b)
{
	D     	   oldy,newy;
	unsigned long  j = 0;

	nimpl++;
	newy = y;                                /* y implicit */
	do
	{
		oldy = newy;
		newy = y + h*( a*newy+b );
		j++;
	} while ( fabs( (oldy-newy)/newy ) > err && j<=(long)5 );
	iter += j;
	return (newy);
}

void waitkey(int x,int y)
{
	gotoxy(6,24);
	cputs("APASA O TASTA...");
	getch();
	gotoxy(x,y);
	return;
}

void calc_err (D ye,D yi,D t,long k)
{
	int	i=1;
	D	epse,epsi;

	epse = funcan (t) - ye;
	epsi = funcan (t) - yi;
	if (k==1L)
	{
		gotoxy (56,i+7);
		cprintf ("% 10.4e",epse);
		gotoxy (56,i+15);
		cprintf ("% 10.4e",epsi);
	}
	else
	{
		gotoxy (56,i+9);
		cprintf ("% 10.4e",epse);
		gotoxy (56,i+17);
		cprintf ("% 10.4e",epsi);
		gotoxy (56,i+19);
		cprintf ("%ld",(long)(iter/nimpl+.5));
		gotoxy (1,1);clreol();
		waitkey (1,1);
	}
	return;
}

void write_t(D t)
{
	gotoxy (65,1);
	cprintf("t = %3.1f",t);
	return;
}

void solve (void)
{
	unsigned long dst,i,n;
	D	ye,yi,t = 0;	                     /* nod initiala */

	ye = y0;                             	   /* conditii initiale */
	yi = y0;
	if ( h>=0.1 ) dst = 5;				   /* pas de afisare  timp */
	else dst = 100;
	n = (long)(tmax/h+.5);                       /* nr. maxim de pasi */
	for ( i = 1; i <= n; i++ )                   /* calcul */
	{
		t =t + h;                              /* nod nou */
		ye = euler_exp (ye,h,a,b);  		   /* calcul Euler - explicit */
		yi = euler_imp (yi,h,a,b); 		   /* calcul Euler - implicit */
		if ( i%dst==0 ) write_t (t);
		if (i==1L) calc_err (ye,yi,t,i);	   /* calcul eroare pas 1 */
	}
	i++;
	calc_err (ye,yi,t,i);				   /* calcul eroare globala */
	return;
}


void display (void)
{
	int	i=1;

	clrscr();
	gotoxy (4,i+1);
	cprintf ("Pasul de integrare h : %8.6f\n\n\r   ",h);
	textcolor (WHITE);
	cputs ("Erori de trunchiere :\n\r");
	cputs("---------------------------------------------------------------");
	gotoxy (2,i+5);
	cputs ("* Metoda explicita :");
	textcolor (LIGHTCYAN);
	gotoxy (20,i+7);
	cputs ("- eroare locala pentru pasul 1 e1 : ");
	gotoxy (20,i+9);
	cputs ("- eroare   globala             eg : ");
	textcolor (WHITE);
	gotoxy (2,i+11);
	cputs ("* Metoda implicita :");
	textcolor (YELLOW);
	gotoxy (20,i+13);
	cprintf("- eroare    impusa            err : %10.4e",err);
	gotoxy (20,i+15);
	textcolor (LIGHTCYAN);
	cputs ("- eroare locala pentru pasul 1 e1 : ");
	gotoxy (20,i+17);
	cputs ("- eroare    globala            eg : ");
	gotoxy (20,i+19);
	cputs ("- numar  de  iteratii       niter : ");
	return;
}


int quit(void)
{
	char	hs[12];

	hs[0] = 10;
	clrscr();
	textcolor (LIGHTCYAN);
	gotoxy (4,2);
	cputs ("Programul rezolva ecuatia : dy/dt = -y.\n\r\n\r");
	cputs ("   Conditia initiala      : y0 = 1.\n\r\n\r");
	cputs ("   Interval de integrare  : t  [0,4] [s].");
	textcolor (YELLOW);
	gotoxy (4,16);
	cputs ("Introduceti pasul de integrare(<ENTER> pentru iesire) : ");
	h = fabs( atof ( cgets(hs) ) );
	if ( h==0. ) return 1;
	hs[0] = 10;
	cputs ("\n\r\n\r   Introduceti eroarea admisa : ");
	err = fabs( atof ( cgets(hs) ) );
	nimpl = 0;
	iter = 0;
	return 0;
}

main()
{
	while( !quit() )
	{
		display();
		solve();
	}
	return;
}

