	/*
	[]-------------------------------------------------------[]
	|			 Nume program : EULER2                  |
	| - Rezolva prin metodele Euler implicita,explicita,      |
	| ecuatia:dy/dt = -y+[h(t)-h(t-t0)]*A*exp(b*t)*cos(w*t+) |
	| - Intervalul de integrare este [0,tmax] s;		    |
	| - Pasul de integrare : h=tmax/100;			    |
	| - Conditia initiala : y0 = fabs(a)/sqrt(1+w*w)*cos();  |
	| - Reprezinta grafic solutiile obtinute prin cele doua   |
	| metode.								    |
	[]-------------------------------------------------------[]  */

#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include "c:\mn\rezdif\euler\grafeu.cp"

# define	NMAX	400
# define 	D	double

D	a = -1,				/* coeficientul a */
	h,                            /* pasul de integrare */
	y0,					/* conditia initiala */
	tmax,					/* limita de integrare */
	di,                           /* durata excitatiei */
	am,					/* amplitudinea excitatiei */
	be,					/* constanta de relaxare a excitatiei */
	w,					/* pulsatia excitatiei */
	fi;                           /* faza initiala a excitatiei */
extern float val[M + 1][N];		/* matricea solutiilor */

void graf(int n,D *ye,D *yi)
{
	int	i;

	initial();
	subplot(1,1,1);
	for (i=0;i<=n;i++)
	{
		val[0][i] = (float)(i*h);
		val[1][i] = (float)ye[i];
		val[2][i] = (float)yi[i];
	}
	plot(2,n+1,val);
	grid();
	restore();
	return;
}

void write_t(D t)
{
	gotoxy (10,23);
	cprintf("t = %3.1f",t);
	return;
}

D func(D t)						/* evalueaza excitatia */
{
	D f;

	if (t>di) return 0;
	f = am * exp(be*t)*cos(w*t+fi);
	return(f);
}

D euler_exp (D y,D h,D a,D t)			/* metoda explicita */
{
	return ( y + h*(a*y + func(t)) );
}

D euler_imp (D y,D h,D a,D t)			/* metoda implicita */
{
	D     newy = 0;
	int	j=0;

	newy = y;
	do
	{
		newy = y + h * (a*newy + func(t));
		j ++;
	}while ( 4 >= j );
	return (newy);
}

void solve (D *ye,D *yi)			   /* rezolvare */
{
	int	i,n;
	D	t = 0;			          /* nod initiala */

	ye[0] = y0;                              /* conditii initiale */
	yi[0] = ye[0];
	n = tmax/h + 1;                          /* nr. maxim de pasi */
	for ( i = 1; i <= n; i++ )                    /* calcul */
	{
		ye[i] = euler_exp (ye[i-1],h,a,t);  /* calcul Euler - explicit */
		t =t + h;                           /* nod nou */
		yi[i]= euler_imp (yi[i-1],h,a,t);   /* calcul Euler - implicit */
		if ((int)(100.*t+0.5)%10==0 ) write_t (t);
	}
	graf(n,ye,yi);					/* grafic */
	return;
}

int next(void)
{
	char	c;

	clrscr();
	gotoxy(5,10);
	cputs("Alta ecuatie ?[D/N]");
	c = getch();
	if ( c=='d' || c=='D' ) return 1;
	return 0;
}
void input (void) 		/* se introduc parametrii */
{
	char	c[20];

	c[0] = 16;
	clrscr();
	textcolor(LIGHTCYAN);
	cputs("\n\r  Programul rezolva ecuatia : dy/dt = -y+[h(t)-h(t-t0)]*A*exp(b*t)*cos(w*t+)");
	cputs("\n\r\n\r  Domeniul de integrare : [0,tmax] [s]");
	cputs("\n\r  Pasul de integrare  h : tmax/100 [s]");
	gotoxy(3,10);
	textcolor(YELLOW);
	cputs("    tmax [in secunde]   : ");
	tmax = fabs( atof(cgets(c)) );
	cputs("\n\r      Durata impuls t0[s] : ");
	di = fabs( atof( cgets(c)) );
	cputs("\n\r      Coeficientul   A    : ");
	am = atof( cgets(c));
	cputs("\n\r      Coeficientul   b    : ");
	be = atof( cgets(c));
	cputs("\n\r      Pulsatia w[rad/s]   : ");
	w = atof( cgets(c));
	cputs("\n\r      Faza initiala [n grade] : ");
	fi = atof( cgets(c))*3.14/180.;
/*	cputs("\n\r      Conditia initiala y(0) : ");
	y0 = atof( cgets(c));*/
	y0 = fabs(a)/sqrt(1+w*w)*cos(fi);
	if ( tmax==0. ) tmax = 1.;
	h = tmax/100.;
	textcolor(LIGHTCYAN);
	return;
}

main()
{
	D	ye[NMAX],				/*tablou solutie explicita*/
		yi[NMAX];				/*tablou solutie implicita*/

	do
	{
		input();
		solve(ye,yi);
	}while( next() );
	return;
}

