
int initial(void)
{
  int g_driver, g_mode, g_error;

  detectgraph(&g_driver, &g_mode);
  initgraph(&g_driver, &g_mode,"\\tc\\bgi\\");
  g_error = graphresult();
  if (g_error <0)
    {
    cprintf("Eroare in graphinit : %s.\n", grapherrormsg(g_error));
    return 1;
    }
  setcolor(LIGHTGRAY);
  return 0;
}

label_x(int x,int y,char *text)
{
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(WHITE);
	outtextxy(x,y,text);
	return;
}

void label_y(int x,int y,char *text)
{
	settextstyle(DEFAULT_FONT, VERT_DIR, 0);
	settextjustify(LEFT_TEXT, CENTER_TEXT);
	setcolor(WHITE);
	outtextxy(x,y,text);
	settextstyle(DEFAULT_FONT, HORIZ_DIR, 0);
	return;
}

void grid (D xs,D ys,D xtic,D ytic,int l)
{
	int				i;
	struct viewporttype	vp;
	int				xt,yt;

	getviewsettings (&vp);
	setlinestyle(l,0, NORM_WIDTH);
	setcolor(LIGHTGRAY);
	xt = xtic*xs;
	yt = ytic*ys;
	for(i=vp.top;i<=vp.bottom;i+=yt )					 /* Traseaza grid pe orizontala */
		line(vp.left,i,vp.right,i);
	for(i=vp.left ;i<=vp.right ;i+=xt )					 /* Traseaza grid pe verticala */
	{
		line (i,vp.top,i,vp.bottom);
/*		outtextxy (i,vp.bottom+5,xl[i-vp.left]);*/
	}
	setlinestyle(SOLID_LINE, 0, NORM_WIDTH);
	line (vp.left,vp.bottom,vp.right,vp.bottom);
	line (vp.left,vp.bottom,vp.left,vp.top);
	return;
}

void graphback(void)
{
	int	maxx,maxy;

	maxx = getmaxx();
	maxy = getmaxy();
	setviewport(19,0,maxx,maxy - 30,0);
	clearviewport();
	return;
}

void scale (D t0,D tmax,D ymin,D ymax,D *xscale,D *yscale)
{
	struct viewporttype	vp;
	int				nx,ny;

	getviewsettings (&vp);
	nx = vp.right - vp.left+1;
	ny = -vp.top + vp.bottom+1;
	ym = ymax;
	if (tmax!=t0 && ymax!=ymin)
	{
		*xscale = fabs((D)nx/(tmax - t0));
		*yscale = fabs((D)ny/(ymax - ymin));
	}
	else
	{
		*xscale = 0;
		*yscale = 0;
	}
	return;
}


void fungr(D t0,D tmax,D xs,D ys,D dx)
{
	D	x;
	struct viewporttype	vp;

	setcolor(WHITE);
	getviewsettings (&vp);
	moveto (vp.left,vp.bottom-(int)(y0*ys));
	for (x=t0 ;x<=tmax ;x+=dx)
		lineto (vp.left+(int)(x*xs),vp.bottom-(int)((ym-funcan(x))*ys));
	moveto (vp.left,vp.bottom-(int)(y0*ys));
	return;
}

void putgraph (int color,D x,D y,D xs,D ys)
{
	struct viewporttype	vp;

	setcolor(color);
	getviewsettings (&vp);
	lineto (vp.left+(int)(x*xs),vp.bottom-(int)((ym-y)*ys));
	return;
}


void plot (D *ye,D *yi)
{
	D	t;
	D	xscale,yscale;
	int	i,n;

	n = tmax/h + 1;                          /* nr. maxim de pasi */
	if( initial() ) return;
	graphback();
	scale (0,tmax,miny(),maxy(),&xscale,&yscale);
	if (xscale != 0) grid (xscale,yscale,tmax/10.,maxy()/10.,DOTTED_LINE);
	fungr (0,tmax,xscale,yscale,tmax/100.);
	t = 0;
	moveto (19,319-(int)(y0*yscale));
	for ( i = 0; i <= n; i++ )                    /* calcul */
	{
		putgraph(LIGHTBLUE,t,*(ye+i),xscale,yscale); /* trasez grafic */
		t = t+h;
	}
	t = 0;
	moveto (19,319-(int)(y0*yscale));
	for ( i = 0; i <= n; i++ )                    /* calcul */
	{
		putgraph(YELLOW,t,*(yi+i),xscale,yscale); /* trasez grafic */
		t = t+h;
	}
	getch();
	restorecrtmode();
	return;
}
