	/*
		[]----------------------------------------[]
		|	 Nume program : RUNGE0               |
		| - Rezolva ecuatii diferentiale ordinare  |
		| prin metodele Runge Kutta;               |
		| - Traseaza graficul functiei;            |
		| - Afiseaza solutiile exacte,aproximative |
		|   si eroarea pe pas.                     |
		[]----------------------------------------[]  */

#include <math.h>
#include <stdlib.h>
#include <conio.h>
#include "c:\mn\rezdif\euler\grafeu.cp"

# define 	D	double

D	a,b,h,y0,tmax;
extern float val[M+1][N];

D funcan(D t)
{
	D	f;

	if (a!=0) f = ((a*y0+b)*exp(a*t) - b)/a;
	else f = b*t + y0;
	return(f);
}

void graf(int n,D *ye)
{
	int	i;

	for (i=0;i<=n;i++)
	{
		val[0][i] = (float)(i*h);
		val[1][i] = (float)ye[i];
		val[2][i] = (float)(funcan(i*h));
	}
	initial();
	subplot(1,1,1);
	plot(2,n+1,val);
	grid();
	restore();
	return;
}

D f(D y)
{
	return (a*y + b);
}

D runge_4 (D y)
{
	D 	g1,g2,g3,g4,newy;

	g1 = f(y);
	g2 = f(y+h*g1/2);
	g3 = f(y+h*g2/2);
	g4 = f(y+h*g3);
	newy = y + h*( g1 + 2*g2 + 2*g3 + g4 )/6;
	return (newy);
}

void write_t(D t)
{
	gotoxy (4,22);
	cprintf("t = %5.3f",t);
	return;
}

void solve (D *ye)
{
	int	i,n;
	D	t = 0;			          /* nod initiala */

	ye[0] = y0;                              /* conditie initiale */
	n = tmax/h + 1;                          /* nr. maxim de pasi */
	for ( i = 1; i <= n; i++ )                    /* calcul */
	{
		ye[i] = runge_4 (ye[i-1]);  /* calcul Runge Kutta 4 */
		t =t + h;                               /* nod nou */
		if ((int)(100.*t)%10==0 ) write_t (t);
	}
	graf(n,ye);
	return;
}

void waitkey(int x,int y)
{
	gotoxy(6,24);
	cputs("APASA O TASTA...");
	getch();
	gotoxy(x,y);
	return;
}

void display (D *ye)
{
	int	i,n;
	D	y,t;

	clrscr();
	textcolor (WHITE);
	n = tmax/h + 1;                          /* nr. maxim de pasi */
	cputs("   pas   |  aproximativa |    analitic   |    eroare     |\n\r");
	cputs("-----------------------------------------------------------\n\r");
	window(1,3,80,25);
	for ( i=1;i<=n;i++ )
	{
		t = i*h;
		y = funcan (t);
		cprintf(" %7.5f | % 13.6f | % 13.6f | % 13.10f   \n\r",t,ye[i],
			y,y - ye[i]);
		if ( wherey()==23 )
		{
			waitkey(1,1);
			clrscr();
		}
	}
	window(1,1,80,25);
	waitkey(1,24);
	return;
}

int next(void)
{
	char	c;

	clrscr();
	gotoxy(5,10);
	cputs("Ecuatie noua?[D/N]");
	c = getch();
	if ( c=='d' || c=='D' ) return 1;
	return 0;
}
void input(void)
{
	char	c[20];

	c[0] = 16;
	clrscr();
	textcolor (LIGHTCYAN);
	gotoxy (4,2);
	cputs ("Programul rezolva ecuatia : dy/dt = a*y + b.\n\r\n\r");
	cputs ("   Interval de integrare  : t  [0,tmax] [s].");
	gotoxy(1,10);
	textcolor(YELLOW);
	cputs("      Coeficientul a : ");
	a = atof( cgets(c));
	cputs("\n\r      Coeficientul b : ");
	b = atof( cgets(c));
	cputs("\n\r      Conditia initiala y(0) : ");
	y0 = atof( cgets(c));
	cputs("\n\r      Pasul de integrare h(nenul) : ");
	h = fabs( atof( cgets(c)) );
	if (h==0.) h=0.01;
	cputs("\n\r      tmax : ");
	if ( y0==0. && b==0.) y0 = 1.;
	tmax = fabs( atof( cgets(c)) );
	if (tmax==0.) tmax = 100.*h;
	if (h==0.) h = tmax/300.;
	if ( (int)(tmax/h)>400 ) tmax = h*390.;
	return;
}

main()
{
	D	ye[N];				/*tablou solutie */

	do
	{
		input();
		solve(ye);
		display(ye);
	}while( next() );
	return;
}

