
#include <math.h>
#include <stdlib.h>
#include "c:\mn\rezdif\euler\grafeu.cp"

# define    NEC	1
# define	MAX	1e6
# define 	D	double

D	a[NEC][NEC],			/* coeficientii sistemului */
	b[NEC],				/* termenii liberi */
	h,                            /* pasul de integrare */
	c[NEC],				/* conditile initiala */
	tmax;					/* limita de integrare */
int	p;

D func (int i,D *y);

void runge_4 (D *y)    			/* metoda Runge Kutta, ordin 4*/
{
	D	g[NEC],s[NEC],z[NEC];
	unsigned			 i;

	for ( i=0; i<=NEC-1; i++) g[i] = func(i,y); /* calcul g1 */
	for ( i=0; i<=NEC-1; i++)
	{
		z[i] = y[i] + h*g[i]/2.;			/* argument g2 */
		s[i] = g[i];
	}
	for ( i=0; i<=NEC-1; i++)
			g[i] = func(i,z);				/* calcul g2 */
	for ( i=0; i<=NEC-1; i++)
	{
		z[i] = y[i] + h*g[i]/2.;			/* argument g3 */
		s[i] = s[i] + 2.*g[i];
	}
	for ( i=0; i<=NEC-1; i++)
			g[i] = func(i,z);				/* calcul g3 */
	for ( i=0; i<=NEC-1; i++)
	{
		z[i] = y[i] + h*g[i];			/* argument g4 */
		s[i] = s[i] + 2.*g[i];
	}
	for ( i=0; i<=NEC-1; i++)
			g[i] = func(i,z);				/* calcul g4 */
	for ( i=0; i<=NEC-1; i++)
		y[i+NEC] = y[i] + h*(s[i]+g[i])/6.;	/* solutie finala */
	i=1;
	return ;
}

int magn_test (D *val,unsigned nr,unsigned *n,unsigned *i)
{
	unsigned	max,j,ctrl = 0;

	max = nr - 1;
	for ( j=0; j<=max; j++)
		if ( fabs(val[j])>(D)MAX )
		{ val[j] = 0.;
		  ctrl = 1;
		}
	if ( ctrl )
		{
			 *n = *i - 2;
			 return 1;
		}
	return 0;
}

int runge (D *y,D *f)			          /* rezolvare cu Runge Kutta 4 */
{
	unsigned	j,i;
	D	t = 0;			          /* nod initial */

	for ( i=0; i<=NEC-1; i++)
		y[i] = c[i];                       /* conditii initiale */
	for ( i =1; i<=p-1; i++ )                /* calcul */
	{
		if ( magn_test(&y[(i-1)*NEC],NEC,&i,&i) ) return 1;
		runge_4 ( &y[(i-1)*NEC] );  	     /* calcul Runge Kutta 4 */
		t =t + h;                          /* nod nou */
	}
	for( i=1; i<=p; i++)                      /* calcul derivate */
		for( j=0; j<=NEC-1; j++)
			f[i*NEC+j] = func( j,&y[(i-1)*NEC] );
	return 0;
}
