		/*[]--------------------------------------------------[]
		  | - Nume program : TRADISP.C						   |
		  | - Contine functiile de afisare a tabelului si a    |
		  |   marimilor de iesire (curenti/potentiale) pentru  |
		  |   programul TRANZ.								   |
		  []---------------------------------------------------[] */

void head (U *tab,char tip,char unit)
{
	U	i;

	for ( i=1; i<=tab[0]; i++)
		cprintf (" %c%2d [%c]   |",tip,tab[i],unit);
}

D header (void)
{
	D		magn = 1.;
	U		i;

	if ( tmax>=1. ) strcpy (tu,"[ s] |");
	else if (0.001<tmax && tmax<1.) { strcpy (tu,"[ms] |"); magn=1000.; }
		 else if (1e-6<tmax && tmax<=0.001) { strcpy (tu,"[us] |"); magn=1.e6; }
			  else { strcpy (tu,"[ns] |"); magn=1.e9; }
	clrscr ();
	cprintf ("t %s",tu);
	head (itab,'I','A');
	head (vtab,'V','V');
	cputs ("\n\r");
	for ( i=1; i<=12*ntab+8; i++) putch('=');
	window (1,3,80,25);
	return (magn);
}

void display (U *tab,D *val)
{
	U	i;

	for ( i=1; i<=tab[0]; i++)
		cprintf ("%+11.3e ",val[tab[i]-1]);
}

void wait (void)
	{
		gotoxy (10,23);
		cputs ("APASA O TASTA...");
		getch();
		clrscr();
	}

void tabel (U step)
{
	U	prec;

	if ( step%plotstep ) return;
	if ( !step )									/* afis. conditii initiale */
	{
		magnt = header();
		cprintf (" %5.3f  ",0);
		display (itab,ci);
		display (vtab,ci);
		cputs ("\n\r");
	}
	prec = abs( 3-(int)(log10(t*magnt)) );
	cprintf (" %5.*f  ",prec,t*magnt);              /* afis. marimi pt.momentul t */
	display (itab,curent);
	display (vtab,potential);
	cputs ("\n\r");
	if ( wherey()==21 ) wait();
}

void fill (U *plot,D *v,U *j,U step)
{
	U	i;

	for ( i=1; i<=plot[0]; i++)
	{
		val[*j][step] = (float)v[plot[i]-1];
		++ *j;
	}
}

void fill_plot_mat (U step)
{
	U	j=1;

	if ( step%plotstep ) return;
	if ( !step )
	{
		val[0][0] = 0.;
		fill (iplot,ci,&j,plotcount);
		fill (vplot,ci,&j,plotcount);
		j = 1;
	}
	plotcount ++;
	val[0][plotcount] = (float)(t);
	fill (iplot,curent,&j,plotcount);
	fill (vplot,potential,&j,plotcount);
}
