/*		[]-----------------------------------------------------[]
		| - Nume program : TRAINPUT.C							|
		| - Functiile de intrare pentru programul de rezolvare  |
		|   a circuitelor de cc. in regim tranzitoriu : TRANZ   |
		[]-----------------------------------------------------[] */

#include <conio.h>
#include <ctype.h>
#include <stdlib.h>

#include "tralin.cp"						/* declaratii comune */

U	n,									/* nr. noduri in circuit */
	l,									/* nr. laturi in circuit */
	ni[MAXN],							/* noduri initiale */
	nf[MAXN],							/* noduri finale */
	ntab,								/* nr. marimi tabelate */
	nplot,								/* nr. marimi grafice */
	maxstep,							/* nr. maxim de pasi */
	plotstep;							/* interval de afisare/plotare */

D	evals[MAXL],						/* valoare sursa de tensiune */
	jvals[MAXL],						/* valoare surse de curent */
	ci[MAXL],							/* conditii initiale */
	e[MAXL],							/* surse echivalente */
	r[MAXL],							/* rezisyente echivalente */
	h,									/* pas */
	tmax;								/* limita de timp */

char	tipe[MAXL];						/* tip element */

U		itab[MAXTAB+1],					/* indici curenti tabelati */
		vtab[MAXTAB+1],					/* indici potentiale tabelate */
		iplot[MAXPLOT+1],				/* indici curenti grafic */
		vplot[MAXPLOT+1];				/* indici potentiale grafic */

char *strchr (const char *s,int c);
double fabs (double x);

int duplind (U ind,U *disp,U count)
{
	U	i;

	for ( i=1; i<=count; i++)
		if ( ind==disp[i] ) return 1;
	return 0;
}

void disp_index (char m[25],U dim,U *disp,U *count,U max)
{
	U		ind,j=0;
	char 	c[6];

	c[0] = 3;
	if (*count > max) { disp[0]=0; return; }
	while ( *count<=max )						/* se pot introduce max indici */
	{
		gotoxy (COL,10);
		clreol();
		cprintf("Indice %s (<ENTER> pentru incheiere)  ",m);
		ind = getabsi (c);
		if (!ind) { disp[0]=j; return; }
		if ( ind<=dim && !duplind(ind,disp,j) )
			 { ++ *count; j++; disp[j]=ind; }
	}
	disp[0] = max;
}

void disp_state (void)
{
	clrscr();
	textcolor (YELLOW);
	cprintf ("\n\r    Un tabel poate contine max. %d marimi(curenti sau potentiale).",MAXTAB);
	cprintf ("\n\r    Se pot reprezenta grafic max. %d marimi(curenti sau potentiale).\n\r",MAXPLOT);
	cputs ("\n\r    Se introduc indicii marimilor de iesire (curenti/potentiale) ce vor");
	cputs ("\n\r    fi reprezentate in tabel si/sau grafic.");
	ntab = nplot = 0;
	disp_index ("curent tabelat",l,itab,&ntab,MAXTAB);
	disp_index ("potential tabelat",n,vtab,&ntab,MAXTAB);
	disp_index ("curent grafic",l,iplot,&nplot,MAXPLOT);
	disp_index ("potential grafic",n,vplot,&nplot,MAXPLOT);
	textcolor (WHITE);
}

char input_tip (char str[30],char goodch[5],int line)
{
	char inp;

	do
	{
		gotoxy(COL,line);
		clreol();
		cprintf ("Tip %s : ",str);
		inp = toupper ( getche() );
	} while( strchr(goodch,inp)==NULL );
	return (inp);
}

D input_val (char str[40],int wrong,int line)
{												/* se asteapta introducerea */
												/* valorii inp la mesajul str */
	char c[16];
	D	 inp;									/* inp de tip double */

	c[0] = 13;
	do
	{
		gotoxy(COL,line);
		clreol();
		cprintf ("Valoare %s : ",str);
		inp = atof ( cgets(c) );
	} while( inp==wrong );
	return (inp);
}

void element (U i)
{
	tipe[i] = input_tip("element[R/L/C]","RLC",7);
	switch ( tipe[i] )
	{
	case 'R' : r[i] = fabs ( input_val("rezistenta [ohmi] (nenula)",0.,8) );break;
	case 'C' : r[i] = fabs ( h/input_val("capacitate [F] (nenula)",0.,8) );break;
	case 'L' : r[i] = fabs ( input_val("inductivitate [H] (nenula)",0.,8)/h );
	}
}

void sursa (U i)
{
	D	v;
	int	lin = 13;

	if ( tipe[i]=='R' ) lin = 11;
	v = input_val("sursa de tensiune [V]",RAND_MAX,lin);
	if ( tipe[i]=='R' ) e[i] = v;
	else 			evals[i] = v;
	jvals[i] = input_val ("sursa de curent [A]",RAND_MAX,lin+1);
}

void conditie (U i)
{
	switch ( tipe[i] )
	{
	case 'L' : ci[i] = input_val("curent initial prin bobina [A]",RAND_MAX,10);break;
	case 'C' : ci[i] = input_val("tensiune initiala pe condensator [A]",RAND_MAX,10);
	}
}

U input_nod (char str[15],int line)
{
	char	inp[10];
	U		valn;

	inp[0] = 7;
	do
	{
		gotoxy (COL,line);
		clreol();
		cprintf ("%s (min. 1 - max.%3d) : ",str,n);
		valn  = getabsi (inp);
		if ( inp[0] == '@' ) exit (0);				/* iesire - nedocumentat */
	} while (valn>n || valn<1 );
	return (valn);
}

void noduri (U i)
{
	ni[i] = input_nod ("Nod initial",4);
	nf[i] = input_nod ("Nod final",5);
}

void init_mem (void)							/* initializari */
{
	U i;

	for ( i=0; i<=l-1; i++)
	{
		tipe[i] = 'R';
		evals[i] = 0.;
		jvals[i] = 0.;
		ci[i] = 0.;
	}
}

int ok(void)
{
	gotoxy (COL,17);
	cputs ("CORECT ? ( [D]/N )");
	if ( toupper(getch())=='N' )  return 0;
	return 1;
}

U input_lat (char str[60],U max,int lin)
{
	char	s[10];
	U		inp;

	s[0] = 7;
	do
	{
		gotoxy (1,lin);
		clreol();
		cprintf ("%s(min.2 - max.%3d) : ",str,max);
		inp = (U)getabsi (s);
	} while (inp>max || inp<2) ;
	return (inp);
}

void input_data (void)
{
	U		i;

	clrscr();
	textcolor (YELLOW);
	cprintf ("PROGRAM PENTRU ANALIZA REGIMULUI TRANZITORIU AL CIRCUITELOR LINIARE\n\r");
	cprintf ("===================================================================");
	textcolor (WHITE);
	do
	{
		n = input_lat ("    Numarul de noduri n ",MAXN,3);
		l = input_lat ("    Numarul de laturi l ( n<=l ) ",MAXL,4);
	} while ( n>l );
	tmax = fabs ( input_val("tmax [in s](implicit 1s)",RAND_MAX,5) );
	if (tmax==0.) tmax = 1.;
	h = fabs ( input_val("pas de integrare [in s](impicit tmax/500)",RAND_MAX,6) );
	if ( h==0 )	h = tmax/500.;
	maxstep = (int)(tmax/h + 0.5);
	if ( maxstep<=100 ) plotstep = 1;
	else 				plotstep = (int)(maxstep/100+0.5);
	cprintf("\n\r    Potentialul nodului %2d este luat ca referinta (v[%2d]=0)",n,n);
	init_mem();
	window (1,8,80,25);
	textcolor (LIGHTCYAN);
	for ( i=0; i<=l-1; i++)                	/* introduc datele circuitului */
	{
		clrscr();
		gotoxy (COL,2);
		cprintf ("Latura %3d",i+1);
		do
		{
			noduri (i);
			element (i);
			conditie (i);
			sursa (i);
		} while ( !ok() );
	}
	disp_state ();                      	/* mod de afisare */
	window (1,1,80,25);
}
