
/* []---------------------------------------------[]
   |     Procedura de factorizare fara pivotare    |
   []---------------------------------------------[] */

int fact_lu(unsigned n, double (*a)[MAXN])
{
   unsigned i,j,k;

	for (k=0; k<n-1; k++) 							/* Contor linii pivot */
		for (j=k+1; j<n; j++) 						/* Contor coloane urmatoare */
		{
			if ( a[k][k]==0. ) return 1;
			a[k][j] = a[k][j]/a[k][k];
			for (i=k+1; i<n; i++)  					/* Contor coloane */
				a[i][j] -= a[i][k]*a[k][j];
		}
	return 0;
}  /* end fact_lu */

/* []---------------------------------------------[]
   |    Procedura de rezolvare a unui sistem cu    |
   |	matricea factorizata LU                    |
   []---------------------------------------------[] */

void rez_lu(unsigned n, double (*a)[MAXN], double b[], double x[])
{
	int	i,j;

   for ( i=0; i<n; i++)                   /* substitutie progresiva : Ly = b*/
   {
		if ( a[i][i]<1e-10 ) b[i] = 0.;   /* poate fi 0 numai a[n-1][n-1] */
										  /* in consecinta potential[n-1]=0 */
		else	b[i] = b[i]/a[i][i];
		for ( j=i+1; j<n; j++)
			b[j] -= a[j][i]*b[i];
   }
   x[n-1] = b[n-1];                        /* substitutie regresiva */
   for (i=n-2; i>=0; i--)
   {
	   for (j=n-1; j>i; j--)
			b[i] -= a[i][j]*x[j];
   x[i] = b[i];
   }
   return;
}	/* end functie rez_lu */

