#define N 100
#define PI 3.14159
#define MAXIT 150
#include <conio.h>
#include <stdio.h>
#include <ctype.h>
#include <process.h>
#include <math.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <time.h>

void in_mat(void);
gauss_fp(int m, float (*a)[N], float b[], float x[]);
void ana_liza(void);
void iter(void);

float a[N][N], b[N],x[N], xt[N], vnv, vne, vsv, vse, vsup, vinf,vst, vdr;
float eps;
int n, lim, nrit;

main ()
{
   ana_liza();
 }/*end main*/


  void in_mat(void)
  {
  int i,j;

vsup = 1;
vinf = 0;
vst = 0;
vdr = 0;
vnv = 0;
vne = 0;
vsv = 0;
vse = 0;


	for (i = 0; i < (n-1)*(n-1); i++)
		{
		for (j = 0; j < (n-1)*(n-1); j++)
			a[i][j] = 0;
		b[i] = 0;
		x[i] = 0;
		}
  b[0] = -vsup-vst;
  b[n-2] = -vsup-vdr;
  j = (n-1)*(n-2);
  b[j] = -vst-vinf;
  j = (n-1)*(n-1) - 1;
  b[j] = -vdr-vinf;

	for ( i = 1; i < (n-2); i++)
	{
		b[i] = -vsup;
		j = (n-1)*(n-2) + i;
		b[j] = -vinf;
		j = (i+1)*(n-1) - 1;
		b[j] = -vdr;
		j = i * (n-1);
		b[j] = -vst;
	}

	for ( i = 0; i < (n-1)*(n-1); i++)
		a[i][i] = -4;
	for ( i = 1; i < (n-1)*(n-1); i++)
		{
		if ( i%(n-1))
		{
			a[i][i-1] = 1;
			a[i-1][i] = 1;
		}
		else
		;
		}
	for ( i = 0; i < (n-1)*(n-2); i++)
		{
		a[i][n-1+i] = 1;
		a[n-1+i][i] = 1;
		}

/*  for ( i = 0; i < (n-1)*(n-1); i++)
	{
		for ( j = 0; j < (n-1)*(n-1); j++)
		printf("%2.0f",a[i][j]);
	printf("\t\t%2.0f",b[i]);
	printf("\n");
	}*/

 }

/* Procedura Gauss fara pivotare */
/*-------------------------------*/
/* Data:23.01.1990   */
gauss_fp(int m, float (*a)[N], float b[], float x[])
{	/* m = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;
   float s,p;

   /* Eliminare */
   for (i=0; i<m-1; i++) /* Contor linii pivot */
	 {
/*     printf(" %d",i);*/
	 for (k=i+1; k<m; k++) /* Contor linii urmatoare */
	   {
	   p=a[k][i]/a[i][i];
	   for (j=i+1; j<m; j++)  /* Contor coloane */
	 a[k][j] -= p*a[i][j];
       b[k] -= p*b[i];
       }
     }
   /* Retrosubstitutie */
   x[m-1] = b[m-1]/a[m-1][m-1];
   for (i=m-2; i>=0; i--)
	 {
	 s = b[i];
	 for (j=m-1; j>i; j--)
	   s -= a[i][j]*x[j];
	 x[i] = s/a[i][i];
	 }

   return;
}	/* end functie */

void ana_liza(void)
{
clock_t start, end;
char c;
int m, i, j, k, nod;
float v, s, s1, errc, maxc;

clrscr();
do
{

printf("\n\n\tANALIZA PERFORMANTELOR PROGRAMULUI DIFIN\n");
printf("\t========================================\n\n");
printf("\tSe rezolva ecuatia lui Laplace pentru interiorul unui patrat cu\n");
printf("conditii Dirichlet pe frontiera:\n");
printf("\t- V = 1 pe latura superioara, V = 0 in rest.\n");
printf("\t- Potentialele colturilor sint nule.\n");
printf("Programul determina:\n");
printf("\t- eroarea metodei numerice fata de solutia analitica\n");
printf("\t- timpul de calcul.\n");
printf("pentru sisteme de ecuatii liniare, rezolvate prin metode directe\n");
printf("si iterative, in functie de finetea discretizarii.\n");
printf("\n\n\n\nNumarul de intervale pe fiecare latura, minim 4 maxim 9, altfel iesire : ");
scanf("%d", &n);
if (n < 4 || n > 9)
	break;
printf("\nEroarea dorita pentru metoda iterativa: (cel mult 1.e-8)");
scanf("%g", &eps);
printf("\n");
eps = ( (eps < 1.0e-8) ? 1.0e-8: eps);
clrscr();
	start = clock();
	in_mat();
	m = (n-1) * (n-1);
	printf("Se rezolva sistemul de %d ecuatii...\n", m);
	gauss_fp(m,a,b,x);
	clrscr();
	end = clock();
	printf("Rezultatele metodei directe :\n");
	printf("\tTimpul de calcul = %f secunde\n", (end - start)/ CLK_TCK);
	printf("\tSe calculeaza erorile...\n");
	s = 0;
	s1 = 0;
	errc= 0;
	maxc = 0;
	for (i = 0; i < n - 1; i++)                /*ind. linie*/
		{
		for (j = 0; j < n -1; j++)         /*ind. coloana*/
			{
			nod = j + (n - 1) * i;
			v = 0;
			for ( k = 26; k > 0 ; k--)
			{
				if(k%2)
				v  += sinh(k*PI*(1 - (1+i)/(float)n)) * sin(k*PI*(1+j)/(float)n) * sin(k*PI/n)/k/k/sinh(k*PI);
			}
			v = v * 4 *n/ PI / PI;
			s1 += v * v;
			s += (v - x[nod]) * (v - x[nod]);
			if (fabs( x[nod] - v) > errc)
				errc = fabs( x[nod] - v);
			if (fabs(x[nod]) > maxc)
				maxc = fabs(x[nod]);
			}
		 }
printf("\tNorma erorii euclidiene :\t");
printf("Norma erorii Cebisev :\n");
printf("\t- absoluta = %f ", sqrt(s1));
printf("\t\t- absoluta = %f \n", errc);
printf("\t- relativa = %f ", sqrt(s / s1));
printf("\t\t- relativa = %f \n", errc / maxc);
printf("\n\n");
				      /* metoda iterativa*/
nrit = MAXIT;
printf("Rezultatele metodei iterative:\n");
iter();

}while(1);
}

void iter()
{
clock_t start, end;
float v[10][10], vnou, err, d;
int i, j, k;

   	start = clock();
for (i = 1; i < n; i++)
	{
	for (j = 1; j < n; j++)
		v[i][j] = 0;
	}
for (i = 0; i <= n; i++)
	{
	v[i][0] = 0;
	v[i][n] = 1;
	v[0][i] = 0;
	v[n][i] = 0;
	}

k = 0;
do {
	err = 0;
	k = k + 1;
	for (i = 1; i < n; i++)
		{
		for (j = 1; j < n; j++)
			{
			vnou = (v[i+1][j] + v[i-1][j] + v[i][j+1] + v[i][j-1])/4;
			d = fabs(vnou- v[i][j]);
			v[i][j] = vnou;
			if (d > err)
				err = d;
			}
		}
    }while ( err > eps && k < nrit);
end = clock();

printf("\tTimpul de calcul = %f secunde\n", (end - start)/ CLK_TCK);
printf("\tEroarea %g a fost obtinuta dupa %d iteratii\n", err, k);
printf("\n\n\nPentru continuare apasati o tasta...\n");
getch();
}
