#define MAXIT 200
#define PI 3.14159265358979323846
#define N 101
#include <alloc.h>
#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#include <math.h>
#include <dos.h>
#include <time.h>

struct coord
	{             /* coord. unui nod */
	float x;
	float y;
	};

int nr_nod, nr_el;
int ind1[2*N];             /* nodurile virfurilor unui elem. */
int ind2[2*N];
int ind3[2*N];
struct coord *x_y;
float a[N][N], c[N],b[N], x[N];
float eps, vsup = 1.0, vinf = -1.0;
double lim;
int n, m, nrit;


void auto_mesh(void);
void gen_sis(void);
gauss_fp(int m, float (*a)[N], float b[], float x[]);
void ana_liza(void);
float convert_x (float x);
float convert_y(float y);
seidel(int n, float (*a)[N], float b[N], float x[N], int *nrit, float *eps);
float pot(float beta);

main ()
{

ana_liza();
}/*end main*/


/* Procedura Gauss fara pivotare */
/*-------------------------------*/
/* Data:23.01.1990   */
gauss_fp(int m, float (*a)[N], float b[], float x[])
{	/* m = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;
   float s,p;

   /* Eliminare */
   for (i=0; i<m-1; i++) /* Contor linii pivot */
	 {
/*     printf(" %d",i);*/
	 for (k=i+1; k<m; k++) /* Contor linii urmatoare */
	   {
	   p=a[k][i]/a[i][i];
	   for (j=i+1; j<m; j++)  /* Contor coloane */
	 a[k][j] -= p*a[i][j];
       b[k] -= p*b[i];
       }
     }
   /* Retrosubstitutie */
   x[m-1] = b[m-1]/a[m-1][m-1];
   for (i=m-2; i>=0; i--)
	 {
	 s = b[i];
	 for (j=m-1; j>i; j--)
	   s -= a[i][j]*x[j];
	 x[i] = s/a[i][i];
	 }

   return;
}	/* end functie */

void ana_liza(void)
{
clock_t start, end;
int  i, j, k;
double v, s, s1, errc, maxc;
double r, fi, fi_zero, x1, y1, eps1 = 1.0e-15;
int g_driver = DETECT, g_mode;

clrscr();
do
{
fflush(stdin);
clrscr();
printf("\n\n\tANALIZA PERFORMANTELOR PROGRAMULUI ELFIN\n");
printf("\t========================================\n\n");
printf("\tSe rezolva ecuatia lui Laplace pentru interiorul unui cerc cu\n");
printf("conditii Dirichlet pe frontiera:\n");
printf("\t-  V = 1 pe sfertul de cerc superior, V  = -1 pe sfertul de  cerc \n");
printf("inferior. In stinga si dreapta exista cite un interstitiu cu deschiderea\n");
printf("unghiulara de 90 grade.\n");
printf("Programul determina:\n");
printf("\t- eroarea metodei numerice fata de solutia analitica\n");
printf("\t- timpul de calcul.\n");
printf("pentru sisteme de ecuatii liniare, rezolvate prin metode directe\n");
printf("si iterative, in functie de finetea discretizarii.\n");
printf("\n\n\n\nIndicele de finete a discretizarii, minim 2 maxim 4, altfel iesire : ");
scanf("%d", &n);
if (n < 2 || n > 4)
	break;
n = 2*n;
printf("\nEroarea dorita pentru metoda iterativa: (cel mult 1.e-5)");
scanf("%g", &eps);
printf("\n");
eps = ( (eps < 1.0e-5) ? 1.0e-5: eps);
clrscr();
	start = clock();
	nr_nod = n*(n+2);
	nr_el = 2*n*n;

	detectgraph(&g_driver, &g_mode);
	initgraph( &g_driver, &g_mode, "c:\\tc\\bgi");
	lim = 4*getmaxy()/5.0;
	auto_mesh();
	gen_sis();
	closegraph();
	printf("Se rezolva sistemul de %d ecuatii...\n", nr_nod + 1);
	gauss_fp(nr_nod + 1,a,c,x);
	clrscr();
	end = clock();
	printf("Rezultatele metodei directe :\n");
	printf("\tTimpul de calcul = %f secunde\n", (end - start)/ CLK_TCK);
	printf("\tSe calculeaza erorile...\n");
	s = 0;
	s1 = 0;
	errc= 0;
	maxc = 0;
	fi_zero = atan2(1,1);        /* interstitiu de 90 grade*/
	for (i = 0; i < nr_nod + 1; i++)
		{
		x1 = convert_x(x_y[i].x);       /* conversie coord. */
		y1 = convert_y(x_y[i].y);
		r = sqrt(x1 * x1 + y1 * y1);    /* raza crt.*/
		fi = atan2( y1 + eps1, x1 + eps1);   /* unghi crt.*/
		v = 0;
		for ( k = 75; k >=  0 ; k--)
			{
			if (k % 2)
				v  += (pow(r/0.5, k))*sin(k*fi)*sin(k*fi_zero)
				      / k / k;
			}
		v = 4.0  * v / PI / fi_zero;
		s1 += v * v;
		s += (v - x[i]) * (v - x[i]);
		if (fabs( x[i] - v) > errc)
			errc = fabs( x[i] - v);
		if (fabs(x[i]) > maxc)
			maxc = fabs(x[i]);
	 }
printf("\tNorma erorii euclidiene :\t");
printf("Norma erorii Cebisev :\n");
printf("\t- absoluta = %f ", sqrt(s1));
printf("\t\t- absoluta = %f \n", errc);
printf("\t- relativa = %f ", sqrt(s / s1));
printf("\t\t- relativa = %f \n", errc / maxc);
printf("\n\n");
				      /* metoda iterativa*/
nrit = MAXIT;
printf("Rezultatele metodei iterative:\n");
auto_mesh();
gen_sis();
start = clock();
m = nr_nod + 1;
seidel(m, a, c, x, &nrit, &eps);
end = clock();
printf("\tTimpul de calcul = %f secunde\n", (end - start)/ CLK_TCK);
printf("\tEroarea %g a fost obtinuta dupa %d iteratii\n", eps, nrit);
printf("\n\n\nPentru continuare apasati o tasta...\n");
getch();

}while(1);
}



void auto_mesh(void)
{
int i, j, k, lin, col;
int aux1[420], aux2[420], aux3[420];
int min, max;
float eps = 1.0e-10;
double alfa, d, r, r1;
			  /* calc. param. triangulatiei reg. pt. patrat */
			  /* primul rind de triunghiuri cu virfurile in aux  [ ] */
aux1[0] = ind1[0] = 0;
aux1[ 2*n -1] = ind1[ 2*n -1] = n;
for (i = 1; i < n; i++)
	aux1[ 2*i - 1] = aux1[ 2*i] = ind1[ 2*i - 1] = ind1[ 2*i] = i;
for (i = 0; i < n; i++)
	aux2[ 2*i ] = aux2[ 2*i + 1] = ind3[ 2*i ] = ind3[ 2*i + 1] = n + 1 + i;
for (i = 0; i < n; i++)
	{
	aux3[ 2*i ] =ind2[ 2*i ] = i + 1;
	aux3[ 2*i + 1] = ind2[ 2*i + 1] = n + 2 + i;
	}
for (i = 1; i < n; i++)                /* recopiere pt. celelalte n-1 rinduri */
	{
	for (j = 0; j < 2*n; j++)
		{
		ind1[ 2*n*i + j ] = aux1[ j ] + i*(n + 1);
		ind3[ 2*n*i + j ] = aux2[ j ] + i*(n + 1);
		ind2[ 2*n*i + j ] = aux3[ j ] + i*(n + 1);
		}
	}
x_y = (struct coord*)calloc(nr_nod, sizeof(struct coord));

for (i = 0; i < nr_nod + 1; i++)           /* calc. coord. nod. in patrat unitar */
	{
	x_y[i].x = -0.5 + (i % (n+1)) / (float)n ;
	x_y[i].y = 0.5 - (i / (n+1)) / (float)n ;
	x_y[i].x = 4.0*(float)getmaxy()/10.0 + 4.0*(float)getmaxy()/5.0 * x_y[i].x;  /* recalc. in pixeli */
	x_y[i].y = 4.0*(float)getmaxy()/10.0 - 4.0*(float)getmaxy()/5.0 * x_y[i].y;
	}
r1 = 4.0 * (float)getmaxy() / 10.0;       /* raza cerc. exterior (domeniu) */
	/* stab. limitele conturului patratic ce se proiecteaza pe cerc */
min = 0;     /* initial, contur exterior */
max = n;

for (j = 0; j < n/2; j++)   /*  parcurge toate contururile   */
    {
    for (i = 0; i < nr_nod + 1; i++)     /*  parcurge nodurile */
	{
	lin = i / (n+1);
	col = i % (n+1);
	if ( lin == min || lin == max || col == min || col == max)  /*  selecteaza nodurile ce apartin contur. crt. */
		{
		if (!(lin < min || lin > max || col < min || col > max))   /*  elimina nodurile de pe cont. anterioare (ef. colt) */
			{
			alfa = atan2(x_y[i].y + eps - r1, x_y[i].x + eps - r1); /*  proiectie pe cerc de raza r */
			r = r1 * (1 - j*2.0/(float)n);
			x_y[i].x = r1 + r * cos(alfa);    /*  recalc. coord. */
			x_y[i].y = r1 + r * sin(alfa);
			}	     /*	end if */
		}		      /*  end if */
	}        /*  end i */
     min++;     /*   reactualiz. indici lin. si col. pt. noul contur */
     max--;
     }  /* end j */
}


void gen_sis(void)
{
int e, i, j, k, perm[5], trig_sens;
double delta, l, coord_x[5], coord_y[5], eps2 = 1.0e-15;
int min, max, lin, col;
float beta;
					/* initializ. matrice sist. */
for (i = 0; i < nr_nod + 1; i++)
	{
	for (j = 0; j < nr_nod + 1; j++)
		a[i][j] = 0;
	b[i] = 0;
	c[i] = 0;
	x[i] = 0;
	}



for ( e = 0; e < nr_el; e++)      /* parc. toate elem. */
                                   /* arie elem. */
	{
	delta = (x_y[ind1[e]].x * x_y[ind2[e]].y
	      - x_y[ind2[e]].x * x_y[ind1[e]].y
	      + x_y[ind2[e]].x * x_y[ind3[e]].y
	      -	x_y[ind3[e]].x * x_y[ind2[e]].y
	      + x_y[ind3[e]].x * x_y[ind1[e]].y
	      - x_y[ind1[e]].x * x_y[ind3[e]].y) /2.0 ;
	if (delta < 0)		/* daca aria < 0, perm. 2 virfuri */
		{
		delta = - delta;
		trig_sens = ind1[e];  ind1[e] = ind2[e]; ind2[e] = trig_sens;
		}
		/* perm. circ. a virfurilor si coord. */
	perm[1] = perm[4] = ind1[e];
	perm[2] = ind2[e];
	perm[3] = perm[0] = ind3[e];
	coord_x[1] = coord_x[4] = x_y[ind1[e]].x;
	coord_x[2] = x_y[ind2[e]].x;
	coord_x[3] = coord_x[0] = x_y[ind3[e]].x;
	coord_y[1] = coord_y[4] = x_y[ind1[e]].y;
	coord_y[2] = x_y[ind2[e]].y;
	coord_y[3] = coord_y[0] = x_y[ind3[e]].y;

		/* se calc. cei 9 coef. ai matricii elem. finit "e"
		   si se expandeaza la matricea globala */
	for (i = 1; i <= 3; i++)
		 {
		 l = (coord_x[i+1] - coord_x[i-1])*(coord_x[i+1] - coord_x[i-1]) +
		 (coord_y[i+1] - coord_y[i-1])*(coord_y[i+1] - coord_y[i-1]);
		 a[perm[i]][perm[i]] += l/(4.0*delta);		/* contrib. coef. diag */			/* contributie diag. */
			for (j = i-1; j <= i+1; j += 2)
			{
				if (j == i-1 )
					k = i + 1;
				else
					k = i - 1;
				l = (coord_y[j] - coord_y[k]) * (coord_y[k] - coord_y[i]) +
				    (coord_x[j] - coord_x[k])*(coord_x[k] - coord_x[i]);
				a[perm[i]][perm[j]] += l/4.0/delta;  /* contrib. coef. nediag. */
			}
                }

	}

b[0] = vsup;
b[n/2] = vsup;
b[n] = vsup;
b[n*(n+1)] = vinf;
b[n*(n+1) + n/2] = vinf;
b[n*(n+2)] = vinf;
b[(n+1)*(n/2)] = (vsup + vinf)/2.0;
b[(n+1)*(n/2) + n] = (vsup + vinf)/2.0;
for (i = 1; i < n/2; i++)
	{
	b[i] = vsup;
	b[n/2 + i] = vsup;
	beta = atan2(convert_y(x_y[(n+1)*i].y)+eps2 , convert_x(x_y[(n+1)*i].x) +eps2);
	b[(n+1)*i] = pot(beta);
	beta = atan2(convert_y(x_y[(n+1)*i+n].y)+eps2 , convert_x(x_y[(n+1)*i+n].x) +eps2);
	b[(n+1)*i + n] = pot(beta);
	beta = atan2(convert_y(x_y[(n+1)*(i+n/2)].y)+eps2 , convert_x(x_y[(n+1)*(i+n/2)].x) +eps2);
	b[(n+1)*(i+n/2)] = pot(beta);
	beta = atan2(convert_y(x_y[(n+1)*(i+n/2)+n].y)+eps2 , convert_x(x_y[(n+1)*(i+n/2)+n].x) +eps2);
	b[(n+1)*(i+n/2) + n] = pot(beta);
	b[n*(n+1) + i] = vinf;
	b[n*(n+2) - i] = vinf;
	}

min = 0;
max = n;
for (i = 0; i < nr_nod + 1; i++)
	{
	lin = i / (n+1);
	col = i % (n+1);
	if( ( lin == min || lin == max || col == min || col == max))
		{
		for (j = 0; j < nr_nod + 1; j++)
			{
			if (j != i)
				c[j] -= a[j][i] * b[i];
			}
		}
	}

for (i = 0; i < nr_nod + 1; i++)
	{
	lin = i / (n+1);
	col = i % (n+1);
	if( ( lin == min || lin == max || col == min || col == max))
		c[i] = b[i];
	}

for (i = 0; i < nr_nod + 1; i++)
	{
	lin = i / (n + 1);
	col = i % (n+1);
	if ( lin == min || lin == max || col == min || col == max)
		{
		for (j = 0; j < nr_nod + 1; j++)
			{
			a[i][j] = 0;
			a[j][i] = 0;
			}
		a[i][i] = 1;
		}

	}
/*	for (i = 0; i < nr_nod + 1; i++)
	{
	for (j = 0; j < nr_nod + 1; j++)

	printf("%g %s", a[i][j], "  ");
	printf("\n");
	printf("\n %d  %g\n", i, c[i]);
        getch();
	}  */
}

float convert_x (float x)
{
return(( x - lim/2.0)/ lim);
}

float convert_y(float y)
{
return(( lim/2.0 - y )/ lim);
}
/* Rezolvarea unui sistem de ecuatii prin metoda Gauss-Seidel*/
/*-----------------------------------------------------------*/
/* Data : 28.01.1991
  Procedura este facuta fara pivotare.
  Restrictie : oricare a[i][i] nenul
  Intoarce : 0 = all OK
	     1 = pivot nul
	     2 = depasire nr. iteratii
	     3 = overflow */

seidel(int m, float (*a)[N], float c[N], float x[N], int *nrit, float *eps)
{

  int i,j,k,ier;
  float s,err, temp;


  /* Initializari */
  k=0;	/* contor iteratii */
  ier = 0; /* indicator overflow */
  for (i=0; i<m; i++)
    {
    if (a[i][i] == 0) return 1; 	/* eroare */
    x[i] = 0;  /* solutia */
    }

  do
    {
    err = 0;			/* eroarea */
    for ( i=0; i<m; i++)	/* ecuatia curenta */
      {
      s = c[i];
      for (j=0; j<m; j++)	/* parcurge ecuatia */
	s -= a[i][j]*x[j];
      s = (s+a[i][i]*x[i])/a[i][i];	/* se elimina termenul cu x[i] */
      temp = fabs(s-x[i]);	/* x nou - x vechi */
      if (err < temp) err=temp;
      x[i]=s;
      }
    k++;	/* incrementeaza contor iteratii */
    if (err>1.e+38) {ier = 1;break;}
  } while ((err > *eps) && (k <= *nrit));  /* cit timp.cond. e indepl.*/
  *eps = err;
  if (k>*nrit)
    {
    *nrit = k;
    return 2;	/* eroare: nr. iteratii */
    }
  *nrit = k;
  if (ier) return 3;
  return 0;	/* all OK */
}

float pot(float beta)
{
int k;
float y;

y = 0;
for ( k = 75; k >=  0 ; k--)
	{
	if (k % 2)
		y  += sin(k*beta)*sin(k*PI/4.0)/ k / k;
	}
y = 16.0  * y / PI / PI;
return (y);
}
