#define MAXIT 500
#define N 100
#include <math.h>
#include <graphics.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

int n , n1, n2, m;
float a[N][N], b[N], pot[550], p_x[550], p_y[550];
float x1, x2, x3, x4, y1, y2, y3, y4, v1, v2, vmax, vmin, q, x_arm, rap;
double dl1, dl2, alfa1, alfa2, x[N];

gauss_fp(int m, float (*a)[N], float b[], double x[]);
void gen_sist(void);
void ana_liza(void);

main()
{
ana_liza();
}

void ana_liza(void)
{

clock_t start, end;
int  i, j, k, nrit;
float r1, r2, s, s1, errc, maxc;
float coord_s_x1, coord_s_y1, coord_s_x2, coord_s_y2;
float eps;
float v[40];
clrscr();
do
{
/*fflush(stdin);*/
clrscr();
printf("\n\n\tANALIZA PERFORMANTELOR PROGRAMULUI MEFR\n");
printf("\t=======================================\n\n");
printf("\tSe determina cimpul electrostatic produs de un electrod plan cu latimea\n");
printf("de 1m.\n");
printf("Programul determina:\n");
printf("\t- eroarea metodei numerice fata de solutia analitica;\n");
printf("\t- timpul de calcul.\n");
printf("pentru sisteme de ecuatii liniare, rezolvate prin metoda directa,\n");
printf("in functie de finetea discretizarii.\n");
printf("\tAlegeti finetea discretizarii (numar natural cuprins intre 2 si 40, \n");
printf("altfel iesire):\n");
printf("-numarul de segmente pe o jumatate a electrodului:");
scanf("%d",&n1);
if (n1 < 2 || n1 > 40 )
	break;
n2 = n1;
n = n1 + n2;
x1 = -1;
y1 = 0;
x2 = 0;
y2 = 0;
x3 = 0;
y3 = 0;
x4 = 1;
y4 = 0;
v1 = 1;
v2 = 1;

clrscr();
	printf("Se genereaza sistemul de ecuatii...\n");
	start = clock();
	gen_sist();
	clrscr();
	printf("Se rezolva sistemul de %d ecuatii...\n", n1+n2);
	gauss_fp(n1+n2,a,b,x);
        end = clock();
	clrscr();
	printf("Rezultatele metodei directe :\n");
	printf("\tTimpul de calcul = %f secunde\n", (end - start)/ CLK_TCK);
	printf("\tSe calculeaza erorile...\n");
	s = 0;
	s1 = 0;

q = 0;
for (k = 0; k < n; k++)
	q += 2.0/(float)n * x[k];

for (j = 1; j < n-1; j++)
	{
	x_arm = -1.0 + 2.0*(j+0.5)/(float)n;
	s1 += 1.0/M_PI/M_PI/(1-x_arm*x_arm);
	rap = 1.0/(M_PI*sqrt(1-x_arm*x_arm));
	s += (x[j]/q - rap) * (x[j]/q - rap);
	}

printf("\tNorma erorii euclidiene :\n");
printf("\t- absoluta = %f\n ", sqrt(s1));
printf("\t- relativa = %f ", sqrt(s / s1));
printf("\n\n");
printf("\n\n\nPentru continuare apasati o tasta...\n");
getch();

}while(1);
}

void gen_sist(void)
{
int i, j;
	/* coord. punct median crt., coord. extremit. a si b ale elem. crt.*/
double coord_p_x,  coord_p_y,  coord_s_x_a,  coord_s_y_a, coord_s_x_b, coord_s_y_b;
double xm, ym, xm1, ym1, xm2, ym2;
float k_m = 0.1111111e-9, eps = 1.0e-20;

dl1 = sqrt( (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)) / n1; /* el. fr. 1*/
dl2 = sqrt( (x3 - x4) * (x3 - x4) + (y3 - y4) * (y3 - y4)) / n2; /* el. fr. 2*/
alfa1 = atan2(y2-y1+eps, x2-x1+eps);       /*orientare  fr. 1*/
alfa2 = atan2(y4-y3+eps, x4-x3+eps);       /*orientare  fr. 2*/

for (i = 0; i < n1+n2; i++)          /*initializ. */
	{
	for (j = 0; j < n1+n2; j++)
		a[i][j] = 0;
	b[i] = 0;
	x[i] = 0;
	}
		       /* calc. coef. matricelor a si b */
for (i = 0; i < n1; i++)
	{
	coord_p_x = x1 + (i+0.5)*dl1*cos(alfa1);   /*coord. pct. pe arm. 1*/
	coord_p_y = y1 + (i+0.5)*dl1*sin(alfa1);
	for (j = 0; j < n1; j++)
		{                         /*coord. surse elem. pe arm. 1 */
		coord_s_x_a = x1 + (j)*dl1*cos(alfa1);
		coord_s_y_a = y1 + (j)*dl1*sin(alfa1);
		coord_s_x_b = x1 + (j+1)*dl1*cos(alfa1);
		coord_s_y_b = y1 + (j+1)*dl1*sin(alfa1);
		xm = ((coord_p_x-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_s_y_b-coord_s_y_a))
		/ ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		ym = ((coord_s_x_b-coord_s_x_a)*(coord_p_y-coord_s_y_a)
		- (coord_p_x-coord_s_x_a)*(coord_s_y_b-coord_s_y_a))
                / ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		xm1 = ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		ym1 = ((coord_p_x-coord_s_x_a)*(coord_p_y-coord_s_y_b)
		- (coord_p_x-coord_s_x_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		xm2 = (coord_p_x-coord_s_x_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));
		ym2 = - (coord_p_y-coord_s_y_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));

		if (j != i)
			{
				       /* calc. coef. nediag. */
			a[i][j] = dl1 / k_m / 2.0
			* (xm *log(sqrt(xm1*xm1 +ym1*ym1))
			- ym*atan2(ym1, xm1+eps) + 1.0 + log(sqrt(xm2*xm2 + ym2*ym2)));
			}
		else                /* calc. coef. diag.(sursa=pct. crt.)*/
			a[i][j] = dl1 / k_m / 2.0
			* (1.0 + log(sqrt(xm2*xm2 + ym2*ym2)));
		}
	for (j = 0; j < n2; j++)
		{
				/*coord. sursa pe arm. 2 */
		coord_s_x_a = x3 + (j)*dl2*cos(alfa2);
		coord_s_y_a = y3 + (j)*dl2*sin(alfa2);
		coord_s_x_b = x3 + (j+1)*dl2*cos(alfa2);
		coord_s_y_b = y3 + (j+1)*dl2*sin(alfa2);
                xm = ((coord_p_x-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_s_y_b-coord_s_y_a))
		/ ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		ym = ((coord_s_x_b-coord_s_x_a)*(coord_p_y-coord_s_y_a)
		- (coord_p_x-coord_s_x_a)*(coord_s_y_b-coord_s_y_a))
                / ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		xm1 = ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		ym1 = ((coord_p_x-coord_s_x_a)*(coord_p_y-coord_s_y_b)
		- (coord_p_x-coord_s_x_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		xm2 = (coord_p_x-coord_s_x_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));
		ym2 = - (coord_p_y-coord_s_y_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));

		a[i][n1+j] = dl2 / k_m / 2.0
		* (xm *log(sqrt(xm1*xm1 +ym1*ym1))
		- ym*atan2(ym1, xm1+eps) + 1.0 + log(sqrt(xm2*xm2 + ym2*ym2)));

		}
       b[i] = v1;
       }
for (i = 0; i < n2; i++)
	{
	coord_p_x = x3 + (i+0.5)*dl2*cos(alfa2);   /*coord. pct. pe arm. 1*/
	coord_p_y = y3 + (i+0.5)*dl2*sin(alfa2);

	for (j = 0; j < n2; j++)
		{                        /*coord. sursa pe arm. 2 */
		coord_s_x_a = x3 + (j)*dl2*cos(alfa2);
		coord_s_y_a = y3 + (j)*dl2*sin(alfa2);
		coord_s_x_b = x3 + (j+1)*dl2*cos(alfa2);
		coord_s_y_b = y3 + (j+1)*dl2*sin(alfa2);
		xm = ((coord_p_x-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_s_y_b-coord_s_y_a))
		/ ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		ym = ((coord_s_x_b-coord_s_x_a)*(coord_p_y-coord_s_y_a)
		- (coord_p_x-coord_s_x_a)*(coord_s_y_b-coord_s_y_a))
                / ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		xm1 = ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		ym1 = ((coord_p_x-coord_s_x_a)*(coord_p_y-coord_s_y_b)
		- (coord_p_x-coord_s_x_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		xm2 = (coord_p_x-coord_s_x_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));
		ym2 = - (coord_p_y-coord_s_y_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));

		if (j != i)
			{

			a[n1+i][n1+j] = dl2 / k_m / 2.0
			* (xm *log(sqrt(xm1*xm1 +ym1*ym1))
			- ym*atan2(ym1, xm1+eps) + 1.0 + log(sqrt(xm2*xm2 + ym2*ym2)));
			}
		else
			a[n1+i][n1+j] = dl2 / k_m / 2.0
			* (1.0 + log(sqrt(xm2*xm2 + ym2*ym2)));
		}

	for (j = 0; j < n1; j++)
		{
				/*coord. sursa pe arm. 1 */
		coord_s_x_a = x1 + (j)*dl1*cos(alfa1);
		coord_s_y_a = y1 + (j)*dl1*sin(alfa1);
		coord_s_x_b = x1 + (j+1)*dl1*cos(alfa1);
		coord_s_y_b = y1 + (j+1)*dl1*sin(alfa1);
		xm = ((coord_p_x-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_s_y_b-coord_s_y_a))
		/ ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		ym = ((coord_s_x_b-coord_s_x_a)*(coord_p_y-coord_s_y_a)
		- (coord_p_x-coord_s_x_a)*(coord_s_y_b-coord_s_y_a))
                / ((coord_s_x_b-coord_s_x_a)*(coord_s_x_b-coord_s_x_a)
		+(coord_s_y_b-coord_s_y_a)*(coord_s_y_b-coord_s_y_a));
		xm1 = ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		ym1 = ((coord_p_x-coord_s_x_a)*(coord_p_y-coord_s_y_b)
		- (coord_p_x-coord_s_x_b)*(coord_p_y-coord_s_y_a))
		/ ((coord_p_x-coord_s_x_a)*(coord_p_x-coord_s_x_a)
		+ (coord_p_y-coord_s_y_a)*(coord_p_y-coord_s_y_a));
		xm2 = (coord_p_x-coord_s_x_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));
		ym2 = - (coord_p_y-coord_s_y_b)
		/ ((coord_p_x-coord_s_x_b)*(coord_p_x-coord_s_x_b)
		+ (coord_p_y-coord_s_y_b)*(coord_p_y-coord_s_y_b));

		a[n1+i][j] = dl1 / k_m / 2.0
		* (xm *log(sqrt(xm1*xm1 +ym1*ym1))
		- ym*atan2(ym1, xm1+eps) + 1.0 + log(sqrt(xm2*xm2 + ym2*ym2)));
		}

       b[n1+i] = v2;
       }
}


/* Procedura Gauss fara pivotare */
/*-------------------------------*/
/* Data:23.01.1990   */
gauss_fp(int m, float (*a)[N], float b[], double x[])
{	/* m = dimens. matricii
	   a = matricea coeficientilor
	   b = vectorul termenilor liberi
	   x = vectorul rezultatelor
	   Matricea a ca si vectorul b se distrug.
	   De aceea s-ar putea pune rezultatul in b. */


   int i,j,k;
   float s,p;

   /* Eliminare */
   for (i=0; i<m-1; i++) /* Contor linii pivot */
	 {
/*     printf(" %d",i);*/
	 for (k=i+1; k<m; k++) /* Contor linii urmatoare */
	   {
	   p=a[k][i]/a[i][i];
	   for (j=i+1; j<m; j++)  /* Contor coloane */
	 a[k][j] -= p*a[i][j];
       b[k] -= p*b[i];
       }
     }
   /* Retrosubstitutie */
   x[m-1] = b[m-1]/a[m-1][m-1];
   for (i=m-2; i>=0; i--)
	 {
	 s = b[i];
	 for (j=m-1; j>i; j--)
	   s -= a[i][j]*x[j];
	 x[i] = s/a[i][i];
	 }

   return;
}	/* end functie */







