/*****************************************************************************

    Programul face analiza modala a matricii introduse
    de utilizator si afiseaza vectorii si valorile proprii.

    La executia programului:
     - se introduce ordinul matricii;
     - se introduce matricea element cu element pe linii;
     - se face analiza modala;
     - se afiseaza:
       - valorile proprii;
       - vectorii proprii.

    Autor: Mihai Lazarescu, 17.12.1991
    (C) L.M.N., Mihai Lazarescu.

*****************************************************************************/


#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "hqr2.h"
#include "elmhes.h"
#include "eltran.h"


#define NM         (15+1)       // Dimensiunea maxima a problemei
                                // Indicele 0 nu se foloseste

typedef double tipmat;

tipmat  a[NM][NM];              // Matricea de analizat
tipmat  z[NM][NM];              // Matricea vectorilor proprii
int     n;                      // Ordinul matricilor
tipmat  wr[NM];                 // Valorile proprii (partea reala)
tipmat  wi[NM];                 // Valorile proprii (partea imaginara)
int     low;
int     igh;
int     intchg[NM];             // Auxiliare



int citeste_int(void)
{
    const MAXINTCAR = 3;
	struct {
		char max;
		char nin;
		char sir[MAXINTCAR+1];
	} s = { MAXINTCAR+1 };

	cgets((char*)&s);
	printf("\n");
	return(atoi(s.sir));
}

float citeste_real(void)
{
    const MAXREALCAR = 20;
	struct {
		char max;
		char nin;
		char sir[MAXREALCAR+1];
	} s = { MAXREALCAR+1 };

	cgets((char*)&s);
	printf("\n");
    return(atof(s.sir));
}

int citeste_matrice(int *n, tipmat *m)
{
    int     max = NM-1;

    do {
        cprintf("\n\n\n\rOrdinul matricii M (min. 1, max. %d, 0-iesire): ", max);
        *n = citeste_int();
        if (*n <= 0) return 1;          // Iesire
    } while (*n < 1 || *n > max);


    clrscr();
    cprintf("Elementele matricii\n\r");
    for (int i = 1; i <= *n; i++) {
        cprintf("\n\rLinia %d:\n\r", i);
        for (int j = 1; j <= *n; j++) {
            printf("M(%2d,% 2d) = ", i, j);
            m[NM*i+j] = citeste_real();
        }
    }
    return 0;
}

void afis_titlu(char s[])
{
    char    subl[81] = "";              // Sublinierea
    int     len      = strlen(s);       // Lungimea titlului
    int     blen     = 0;               // Numarul de blancuri initiale

    while (s[blen++] == ' ') ;          // Numararea blancurilor
    blen--;
    memset(subl, ' ', blen);            // Inserarea blancurilor
    memset(subl+blen, '=', len-blen);   // Inserarea sublinierii
    subl[len+blen] = '\0';              // Terminatorul sirului
    cprintf("%s\n\r%s\n\r", s, subl);   // Afisarea titlului si sublinierii
}

void afis_stitlu(char s[])
{
    printf("%s\n", s);                  // Afisarea subtitlului
}

void afiseaza_rez(void)
{
    char    t[]   =
"              Vectorii si valorile proprii ale matricii M";
    char    st1[] = "A. Valorile proprii";
    char    st2[] = "B. Vectorii proprii";
    int     i, j, k;        // Contoare
    int     citi  = 0;      // Citi vectori proprii incap pe pagina

    afis_titlu(t);
    printf("\n");
    afis_titlu(st1);
    for (i = 1; i <= n; i++) {
        printf("\n%2d)", i);
        printf("\t% .2E %+.2E*i", wr[i], wi[i]);
        if (i % 17 == 0) {
            printf("\n\nApasati o tasta pentru continuare . . . ");
            getch();
            clrscr();
            afis_titlu(t);
            printf("\n");
            afis_titlu(st1);
        }
    }
    if ((i-1) % 17 != 0) {
        printf("\n\nApasati o tasta pentru continuare . . . ");
        getch();
    }
    clrscr();

    afis_titlu(t);
    printf("\n");
    afis_titlu(st2);
    for (k = 1; k <= n; k++) {              // Parcurge valorile proprii
        int     semn = 0;

        if (citi == 0)
            citi = 17 / (n+1);

        if (wi[k] > 0.0)
            semn = -1;
        else if (wi[k] < 0.0)
            semn = +1;

        printf("\n%2d)", k);
        for (j = 1; j <= n; j++)
            switch (semn) {
                case +1:
                    printf("\t% .2E %+.2E*i\n", z[j][k], z[j][k+1]);
                    break;
                case  0:
                    printf("\t% .2E %+.2E*i\n", z[j][k], 0.0);
                    break;
                case -1:
                    printf("\t% .2E %+.2E*i\n", z[j][k-1], -z[j][k-1]);
                    break;
            }
        citi--;
        if (citi == 0) {
            printf("\nApasati o tasta pentru continuare . . . ");
            getch();
            clrscr();
            afis_titlu(t);
            printf("\n");
            afis_titlu(st2);
        }
    }
    if (citi != 0) {
        printf("\nApasati o tasta pentru continuare . . . ");
        getch();
    }
    clrscr();
}


void main(void)
{
    char    t[] = "\
                        ANALIZA MODALA A MATRICILOR";
    char    st[] = "\
            Programul face analiza modala a matricii introduse de\n\
            utilizator si afiseaza vectorii  si valorile proprii.";
    int     coderr = 0;
    tipmat  teps   = 1.0;
    tipmat  unu    = teps + 1.0;
    tipmat  machep = teps;         // Precizia de reprezentare a masinii

    // Determina precizia de reprezentare a masinii
    while (unu != 1.0) {
        machep  = teps;
        teps   /= 2.0;
        unu     = teps + 1.0;
    }

    highvideo();
    for (; ; ) {
        clrscr();
        afis_titlu(t);
        afis_stitlu(st);
        if (citeste_matrice(&n, &a[0][0]) != 0) break;

        low = 1;
        igh = n;
        elmhes(NM, n, low, igh, &a[0][0], intchg);
        eltran(NM, n, low, igh, &a[0][0], intchg, &z[0][0]);
        coderr = hqr2(NM, n, low, igh, &a[0][0], wr, wi, &z[0][0], machep);

        clrscr();
        if (coderr == 0)
            afiseaza_rez();
        else {
            printf("\n\n\n\n\n\n\n\n\n\n\n\n\t\t\tEroare !");
            printf("\n\n\n\n\nApasati o tasta . . .");
            getch();
        }
    }
    clrscr();
    lowvideo();
}
