#ifdef __cplusplus
extern "C" {
#endif

void elmhes(

//     This subroutine is a translation of the algol procedure ELMHES,
//     Num. math. 12, 349-368(1968) by Martin and Wilkinson.
//     Handbook for auto. comp., vol.II-Linear algebra, 339-358(1971).

//     Given a real general matrix, this subroutine
//     reduces a submatrix situated in rows and columns
//     low through igh to upper Hessenberg form by
//     stabilized elementary similarity transformations.

     int    nm,

//     nm must be set to the row dimension of two-dimensional
//       array parameters as declared in the calling program
//       dimension statement.

     int    n,

//     n is the order of the matrix,

     int    low,
     int    igh,

//     low and igh are integers determined by the balancing
//       subroutine  BALANC.    If  BALANC  has not been used,
//       set low=1, igh=n,

     double *a,

//     a contains the input matrix.
//     a contains on output the Hessenberg matrix.  The multipliers
//     which were used in the reduction are stored in the remaining
//     triangle under the Hessenberg matrix.


     int    intchg[]

//     intchg contains information on the rows and columns
//       interchanged in the reduction.
//       Only elements low through igh are used.

     );

#ifdef __cplusplus
}
#endif
