void eltran(int nm, int n, int low, int igh, double *a, int intchg[], double *z)
{
      int       i, j, mp, mp1, mm, kl;

//     This subroutine is a translation of the algol procedure ELMTRANS,
//     Num. math. 16, 181-204(1970) by Peters and Wilkinson.
//     Handbook for auto. comp., vol.II-Linear algebra, 372-395(1971).

//     This subroutine accumulates the stabilized elementary
//     similarity transformations used in the reduction of a
//     real general matrix to upper Hessenberg form by  ELMHES.

//     On input:

//     nm must be set to the row dimension of two-dimensional
//       array parameters as declared in the calling program
//       dimension statement,

//     n is the order of the matrix,

//     low and igh are integers determined by the balancing
//       subroutine  BALANC.    If  BALANC  has not been used,
//       set low=1, igh=n,

//     a contains the multipliers which were used in the
//       reduction by  ELMHES  in its lower triangle
//       below the subdiagonal,

//     intchg contains information on the rows and columns
//       interchanged in the reduction by  ELMHES.
//       Only elements low through igh are used.

//     On output:

//     z contains the transformation matrix produced in the
//       reduction by  ELMHES.

//     Questions and comments should be directed to B. S. Garbow,
//     Applied mathematics division, Argonne National Laboratory

//     ------------------------------------------------------------------

//  ***** Initialize z to identity matrix
    for (i = 1; i <= n; i++) {
        for (j = 1; j <= n; j++)
            z[nm*i+j] = 0.0;
        z[nm*i+i] = 1.0;
    }

    kl = igh - low - 1;
    if (kl < 1) return;
    for (mm = 1; mm <= kl; mm++) {
        mp = igh - mm;
        mp1 = mp + 1;

        for (i = mp1; i <= igh; i++)
            z[nm*i+mp] = a[nm*i+mp-1];

        i = intchg[mp];
        if (i == mp) continue;

        for (j = mp; j <= igh; j++) {
            z[nm*mp+j] = z[nm*i+j];
            z[nm*i+j]  = 0.0;
        }

        z[nm*i+mp] = 1.0;

    }
}
