#ifdef __cplusplus
extern "C" {
#endif

void eltran(

//     This subroutine is a translation of the algol procedure ELMTRANS,
//     Num. math. 16, 181-204(1970) by Peters and Wilkinson.
//     Handbook for auto. comp., vol.II-Linear algebra, 372-395(1971).

//     This subroutine accumulates the stabilized elementary
//     similarity transformations used in the reduction of a
//     real general matrix to upper Hessenberg form by  ELMHES.

     int    nm,

//     nm must be set to the row dimension of two-dimensional
//       array parameters as declared in the calling program
//       dimension statement,

     int    n,

//     n is the order of the matrix,

     int    low,
     int    igh,

//     low and igh are integers determined by the balancing
//       subroutine  BALANC.    If  BALANC  has not been used,
//       set low=1, igh=n,

     double *a,

//     a contains on input the multipliers which were used in the
//       reduction by  ELMHES  in its lower triangle
//       below the subdiagonal,

     int    intchg[],

//     intchg contains on input information on the rows and columns
//       interchanged in the reduction by  ELMHES.
//       Only elements low through igh are used.

     double *z

//     z contains on output the transformation matrix produced in the
//       reduction by  ELMHES.

     );

#ifdef __cplusplus
}
#endif
