#include <complex.h>

/* Descompune in serie Fourier o functie periodica liniara pe portiuni */
void Fourier_lpp(
	int		n,				/* Numarul de segmente ale functiei */
	float	t[],			/* Punctele de discretizare a domeniului de definitie */
	complex	f[],			/* Discretizarea intervalului [0..T] */
	int		m,				/* Numarul de armonici de calculat */
	complex c[]);			/* Coeficientii Fourier in sin si cos */

/* Sumarea unei serii Fourier trunchiate */
void eval_Fourier(
	int		n,				/* Numarul de segmente ale functiei */
	float	t[],			/* Punctele de discretizare a domeniului de definitie */
	complex	f[],			/* Discretizarea intervalului [0..T] */
	int		m,				/* Numarul de armonici de calculat */
	complex	c[]);			/* Coeficientii Fourier in sin si cos */

/* Calculul transformatei Fourier discrete */
void transf_F(
	int		dir,            /* 1-transf. directa; 0-transf. inversa */
	int		n,              /* Dimensiunea lui f */
	complex	f[],            /* Functia discretizata */
	complex	c[]);           /* Coeficientii Fourier complecsi */

/* Calculul optimizat al transformatei Fourier discrete */
void transf_F_opt(
	int		dir,            /* 1-transf. directa; 0-transf. inversa */
	int		n,              /* Dimensiunea lui f */
	complex	f[],            /* Functia discretizata */
	complex	c[]);           /* Coeficientii Fourier complecsi */

/* Calculul FFT */
void FFT(
	complex	x[],			/* Secventa de date la intrare/coeficientii la iesire */
	int		n,				/* Numarul de puncte de date */
	int		inv);			/* 0 - FFT directa, 1 - FFT inversa */
