#ifdef ___CAR_FRECV
/* Pentru Car_Frec.Cpp */
#define N		201		/* Numarul maxim de frecvente + 1 */
#endif

#ifdef ___NESIN
/* Pentru Nesin.Cpp */
#define N		202		/* Numarul maxim de intervale + 2 */
#endif

#ifdef ___ERR_FOUR
/* Pentru Err_four.Cpp */
#define N       202		/* Numarul maxim de intervale + 2 */
#endif

#ifdef ___TRANZITORIU
/* Pentru Tranz.Cpp */
#define N		201		/* Cam atit... */
#endif

#ifdef ___TRZ_MODAL
/* Pentru Trz_Mod.Cpp */
#define N       200     /* Numarul de intervale de simulare */
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Prototipurile functiilor */
/* ======================== */

/* ====================================================================
   Traseaza dreptunghiul reprezentind limitele pe ecran ale graficului.
   ==================================================================== */
void tras_dreptunghi(void);

/* =============================================================
   Determina valoarea maxima si minima dintr-un sir de nr. reale
   ============================================================= */
void val_min_max(int nr, float x[], float *min, float *max);

/* =======================================
   Etaloneaza axa Ox, in fereastra curenta.
   ======================================= */
void etalon_x(int nr, float x[]);

/* ====================================================
   Etaloneaza axa Ox logaritmica, in fereastra curenta.
   ==================================================== */
int logetalon_x(int nr, float x[]);

/* =======================================
   Etaloneaza axa Oy, in fereastra curenta.
   ======================================= */
void etalon_y(int n,int nr, float y[][N]);

/* ====================================================
   Etaloneaza axa Oy logaritmica, in fereastra curenta.
   ==================================================== */
int logetalon_y(int n,int nr, float y[][N]);

/* ==========================================================
   Afiseaza markeri, traseaza dreptunghiul; Obs:grafic normal
   ========================================================== */
void putmarkers(void);

/* =============
   Traseaza grid
   ============= */
void grid(void);

/* =======================
   Afiseaza eticheta pe Ox
   ======================= */
void label_x(char *text);

/* =======================
   Afiseaza eticheta pe Oy
   ======================= */
void label_y(char *text);

/* ===============
   Afiseaza titlul
   =============== */
void title(char *text);

/* ============================
   Stabileste fereastra curenta
   ============================ */
int subplot(int nrx, int nry, int crt);

/* ======================================
   Stabileste tipul liniei si culoarea ei.
   ======================================*/
int schimba_culoare(int nrgraf);

/* =====================
   Deseneaza un cerculet
   ===================== */
void cerc(int x, int y);

/* =======================
   Deseneaza un dreptunghi
   ======================= */
void drept(int x, int y);

/* ==============
   Deseneaza un x
   ============== */
void xx(int x, int y);

/* ===================
   Deseneaza o steluta
   =================== */
void stea(int x, int y);

/* ===================
   Deseneaza un pixel
   =================== */
void pix(int x, int y);

/* =================
   Deseneaza un plus
   ================= */
void plus(int x, int y);

/* ==========================
   Afiseaza punctul din tabel
   ========================== */
void punct(int i, int x, int y);

/* =============================================
   Redefineste tipurile implicite pentru grafic.
   ============================================= */
int redefinire(int graf, char point, char lin, char color);

/* ==================================================
   Returneaza pixelul curent pe Ox ptr.grafic normal.
   ================================================== */
int valx( float x);

/* ==================================================
   Returneaza pixelul curent pe Oy ptr.grafic normal.
   ================================================== */
int valy( float y);       /* Poate sa fie cu define !!! */

/* ======================================================
   Returneaza pixelul curent pe Ox ptr.grafic logaritmic.
   ====================================================== */
int logvalx( float x);

/* ======================================================
   Returneaza pixelul curent pe Oy ptr.grafic logaritmic.
   ====================================================== */
int logvaly( float y);       /* Poate sa fie cu define !!! */

/* ================================================
  Afiseaza un grafic in fereastra grafica curenta.
  ================================================= */
int grafic (int n, 	/* Numarul de grafice */
	int nr, 	/* Numarul de puncte */
	float val[][N],	/* val[0] = x; restul: cite un y */
	int logx,	/* scara pe x este logaritmica? */
	int logy);	/* scara pe y este logaritmica? */

/* ==========================
   Afiseaza un grafic liniar.
   ========================== */
int plot(int n, int nr, float val[][N]);

/* ========================================
   Afiseaza un grafic logaritmic pe axa Ox.
   ======================================== */
int semilogx(int n, int nr, float val[][N]);

/* ========================================
   Afiseaza un grafic logaritmic pe axa Oy.
   ======================================== */
int semilogy(int n, int nr, float val[][N]);

/* ============================================
   Afiseaza un grafic logaritmic pe ambele axe.
   ============================================ */
int loglog(int n, int nr, float val[][N]);

/* =============================
   Initializeaza datele necesare
   ============================= */
int initial(void);

void restore(void);       /* revine in modalfanum. dupa apsarea unei taste */

#ifdef __cplusplus
}
#endif
