// Contine un BUG ! ! !


#include <complex.h>

int hqr2(int nm, int n, int low, int igh,
         double *h, double wr[], double wi[], double *z, float machep)
{
    int     i, j, k, l, m, en, na, its;
    double  p, q, r, s, t, w, x, y, ra, sa, vi, vr, zz, norm;
    complex z3;


//     This subroutine is a translation of the algol procedure HQR2,
//     Num. math. 16, 181-204(1970) by Peters and Wilkinson.
//     Handbook for auto. comp., vol.II-Linear algebra, 372-395(1971).

//     This subroutine finds the eigenvalues and eigenvectors
//     of a real upper Hessenberg matrix by the QR method.  The
//     eigenvectors of a real general matrix can also be found
//     if  ELMHES  and  ELTRAN  or  ORTHES  and    ORTRAN    have
//     been used to reduce this general matrix to Hessenberg form
//     and to accumulate the similarity transformations.

//     On input:

//     nm must be set to the row dimension of two-dimensional
//       array parameters as declared in the calling program
//       dimension statement,

//     n is the order of the matrix,

//     low and igh are integers determined by the balancing
//       subroutine  BALANC.    If  BALANC  has not been used,
//       set low=1, igh=n,

//     h contains the upper Hessenberg matrix,

//     z contains the transformation matrix produced by  ELTRAN
//       after the reduction by  ELMHES, or by  ORTRAN  after the
//       reduction by  ORTHES, if performed.    If the eigenvectors
//       of the Hessenberg matrix are desired, z must contain the
//       identity matrix,

//     machep is a machine dependent parameter specifying
//        the relative precision of floating point arithmetic.

//     On output:

//     h has been destroyed,

//     wr and wi contain the real and imaginary parts,
//       respectively, of the eigenvalues.  The eigenvalues
//       are unordered except that complex conjugate pairs
//       of values appear consecutively with the eigenvalue
//       having the positive imaginary part first.  If an
//       error exit is made, the eigenvalues should be correct
//       for indices ierr+1,...,n,

//     z contains the real and imaginary parts of the eigenvectors.
//       If the i-th eigenvalue is real, the i-th column of z
//       contains its eigenvector.  If the i-th eigenvalue is complex
//       with positive imaginary part, the i-th and (i+1)-th
//       columns of z contain the real and imaginary parts of its
//       eigenvector.  The eigenvectors are unnormalized.  If an
//       error exit is made, none of the eigenvectors has been found,

//     ierr is set to:
//       zero       for normal return,
//       j          if the j-th eigenvalue has not been
//              determined after 30 iterations.

//     Arithmetic is real except for the replacement of the algol
//     procedure cdiv by complex division.

//     Questions and comments should be directed to B. S. Garbow,
//     Applied mathematics division, Argonne National Laboratory

//     ------------------------------------------------------------------



  

//  ***** Store roots isolated by balanc and compute matrix norm
    norm = 0.0;
    k    = 1;
    for (i = 1; i <= n; i++) {
        for (j = k; j <= n; j++)
            norm += fabs(h[nm*i+j]);
        k = i;
        if (i >= low && i <= igh) continue;
        wr[i] = h[nm*i+i];
        wi[i] = 0.0;
    }

//  ***** Search for next eigenvalues
    en = igh;
    t  = 0.0;
LABEL60:
    while (en >= low) {
//      ***** Look for single small sub-diagonal element
        its  = 0;
        na   = en - 1;
        for (; ; ) {
            for (l = en; l > low; l--) {
                s = fabs(h[nm*(l-1)+l-1]) + fabs(h[nm*l+l]);
                if (s == 0.0) s = norm;
                if (fabs(h[nm*l+l-1]) <= machep * s) break;
            }
//          ***** Form shift
            x = h[nm*en+en];
            if (l == en) goto LABEL270;
            y = h[nm*na+na];
            w = h[nm*en+na] * h[nm*na+en];
            if (l == na) goto LABEL280;
            if (its == 30) return en;
            if (its == 10 || its == 20) {   // ***** Form exceptional shift
                t = t + x;
                for (i = low; i <= en; i++)
                    h[nm*i+i] = h[nm*i+i] - x;
                s = fabs(h[nm*en+na]) + fabs(h[nm*na+na-1]);
                y = x = 0.75 * s;
                w = -0.4375 * s * s;
            }
            its++;

//          ***** Look for two consecutive small sub-diagonal elements.
            for (m = en-2; m >= l; m--) {
                zz = h[nm*m+m];
                r  = x - zz;
                s  = y - zz;
                p  = (r * s - w) / h[nm*(m+1)+m] + h[nm*m+m+1];
                q  = h[nm*(m+1)+m+1] - zz - r - s;
                r  = h[nm*(m+2)+m+1];
                s  = fabs(p) + fabs(q) + fabs(r);
                p /= s;
                q /= s;
                r /= s;
                if (m == l) break;
                if (fabs(h[nm*m+m-1]) * (fabs(q) + fabs(r)) <=
                    machep * fabs(p) * (fabs(h[nm*(m-1)+m-1]) +
                    fabs(zz) + fabs(h[nm*(m+1)+m+1]))) break;
            }
            for (i = m+2; i <= en; i++) {
                h[nm*i+i-2] = 0.0;
                if (i == m+2) continue;
                h[nm*i+i-3] = 0.0;
            }
//          ***** Double QR step involving rows l to en and columns m to en
            for (k = m; k <= na; k++) {
                if (k != m) {
                    p = h[nm*k+k-1];
                    q = h[nm*(k+1)+k-1];
                    r = 0.0;
                    if (k != na) r = h[nm*(k+2)+k-1];
                    x = fabs(p) + fabs(q) + fabs(r);
                    if (x == 0.0) continue;
                    p /= x;
                    q /= x;
                    r /= x;
                }
                s = sqrt(p*p + q*q + r*r);
                s = (p >= 0.0) ? s : -s;
                if (k != m)
                    h[nm*k+k-1] = -s * x;
                else
                    if (l != m)
                        h[nm*k+k-1] = -h[nm*k+k-1];
                p  += s;
                x   = p / s;
                y   = q / s;
                zz  = r / s;
                q  /= p;
                r  /= p;

//              ***** Row modification
                for (j = k; j <= n; j++) {
                    p = h[nm*k+j] + q * h[nm*(k+1)+j];
                    if (k != na) {
                        p         += r * h[nm*(k+2)+j];
                        h[nm*(k+2)+j] -= p * zz;
                    }
                    h[nm*(k+1)+j] -= p * y;
                    h[nm*k+j]   -= p * x;
                }

//              ***** Column modification
                j = (en < k+3) ? en : k+3;
                for (i = 1; i <= j; i++) {
                    p = x*h[nm*i+k] + y*h[nm*i+k+1];
                    if (k != na) {
                        p         += zz * h[nm*i+k+2];
                        h[nm*i+k+2] -= p * r;
                    }
                    h[nm*i+k+1] -= p * q;
                    h[nm*i+k]   -= p;
                }

//              ***** Accumulate transformations
                for (i = low; i <= igh; i++) {
                    p = x*z[nm*i+k] + y*z[nm*i+k+1];
                    if (k != na) {
                        p        += zz * z[nm*i+k+2];
                        z[nm*i+k+2] -= p * r;
                    }
                    z[nm*i+k+1] -= p * q;
                    z[nm*i+k]   -= p;
                }
            }
        }

//      ***** One root found
LABEL270:
        h[nm*en+en] = x + t;
        wr[en] = h[nm*en+en];
        wi[en] = 0.0;
        en = na;
        goto LABEL60;

//      ***** Two roots found
LABEL280:
        p = (y - x) / 2.0;
        q = p * p + w;
        zz = sqrt(fabs(q));
        h[nm*en+en] = x + t;
        x = h[nm*en+en];
        h[nm*na+na] = y + t;
        if (q >= 0.0) {         // ***** Real pair
            if (p < 0.0) zz = -zz;
            zz += p;
            wr[en] = wr[na]  = x + zz;
            if (zz != 0.0) wr[en] = x - w / zz;
            wi[en] = wi[na] = 0.0;
            x = h[nm*en+na];
            s = fabs(x) + fabs(zz);
            p = x / s;
            q = zz / s;
            r = sqrt(p*p + q*q);
            p /= r;
            q /= r;

//          ***** Row modification
            for (j = na; j <= n; j++) {
                zz = h[nm*na+j];
                h[nm*na+j] = p*h[nm*en+j] + q*zz;
                h[nm*en+j] = q*h[nm*en+j] - p*zz;
            }

//          ***** Column modification
            for (i = 1; i <= en; i++) {
                zz = h[nm*i+na];
                h[nm*i+na] = p*h[nm*i+en] + q*zz;
                h[nm*i+en] = q*h[nm*i+en] - p*zz;
            }

//          ***** Accumulate transformations
            for (i = low; i <= igh; i++) {
                zz = z[nm*i+na];
                z[nm*i+na] = p*z[nm*i+en] + q*zz;
                z[nm*i+en] = q*z[nm*i+en] - p*zz;
            }
        }
        else {              //      ***** Complex pair
            wr[en] =   wr[na] = x + p;
            wi[en] = -(wi[na] = zz);
        }
        en = na-1;
    }

//  ***** All roots found.
//        Backsubstitute to find vectors of upper triangular form.

      if (norm == 0.0) return 0;
      for (en = n; en >= 1; en--) {
          p = wr[en];
          q = wi[en];
          na = en - 1;
          if (q > 0) continue;
          if (q == 0) {         // ***** Real vector
              m = en;
              h[nm*en+en] = 1.0;
              if (na == 0) continue;
              for (i = en-1; i >= 1; i--) {
                  w = h[nm*i+i] - p;
                  r = h[nm*i+en];
                  if (m <= na)
                      for (j = m; j <= na; j++)
                          r += h[nm*i+j] * h[nm*j+en];
                  if (wi[i] < 0.0) {
                      zz = w;
                      s = r;
                      continue;
                  }
                  m = i;
                  if (wi[i] == 0.0) {
                      t = w;
                      if (w == 0.0) t = machep * norm;
                      h[nm*i+en] = -r / t;
                      continue;
                  }

//                ***** Solve real equations
                  x = h[nm*i+i+1];
                  y = h[nm*(i+1)+i];
                  q = (wr[i] - p) * (wr[i] - p) + wi[i] * wi[i];
                  t = (x * s - zz * r) / q;
                  h[nm*i+en] = t;
                  if (fabs(x) > fabs(zz)) {
                      h[nm*(i+1)+en] = (-r - w * t) / x;
                      continue;
                  }
                  h[nm*(i+1)+en] = (-s - y * t) / zz;
              }
          }
          else {        // ***** Complex vector
              m = na;

//        ***** Last vector component chosen imaginary so that
//              eigenvector matrix is triangular

              if (fabs(h[nm*en+na]) > fabs(h[nm*na+en])) {
                  h[nm*na+na] = q / h[nm*en+na];
                  h[nm*na+en] = -(h[nm*en+en] - p) / h[nm*en+na];
              }
              else {
                  z3 = complex(0.0, -h[nm*na+en]) / complex(h[nm*na+na]-p, q);
                  h[nm*na+na] = real(z3);
                  h[nm*na+en] = imag(z3);
              }
              h[nm*en+na] = 0.0;
              h[nm*en+en] = 1.0;
              if (na-1 == 0) continue;
              for (i = na-1; i >= 1; i--) {
                  w = h[nm*i+i] - p;
                  ra = 0.0;
                  sa = h[nm*i+en];
                  for (j = m; j <= na; j++) {
                      ra += h[nm*i+j] * h[nm*j+na];
                      sa += h[nm*i+j] * h[nm*j+en];
                  }
                  if (wi[i] < 0.0) {
                      zz = w;
                      r = ra;
                      s = sa;
                      continue;
                  }
                  m = i;
                  if (wi[i] == 0.0) {
                      z3 = complex(-ra, -sa) / complex(w, q);
                      h[nm*i+na] = real(z3);
                      h[nm*i+en] = imag(z3);
                      continue;
                  }

    //            ***** Solve complex equations
                  x = h[nm*i+i+1];
                  y = h[nm*(i+1)+i];
                  vr = (wr[i] - p)*(wr[i] - p) + wi[i]*wi[i] - q*q;
                  vi = (wr[i] - p) * 2.0 * q;
                  if (vr == 0.0 && vi == 0.0)
                     vr = machep*norm*(fabs(w)+fabs(q)+fabs(x)+fabs(y)+fabs(zz));
                  z3 = complex(x*r - zz*ra + q*sa, x*s - zz*sa - q*ra) /
                       complex(vr, vi);
                  h[nm*i+na] = real(z3);
                  h[nm*i+en] = imag(z3);
                  if (fabs(x) > fabs(zz) + fabs(q)) {
                      h[nm*(i+1)+na] = (-ra - w * h[nm*i+na] + q * h[nm*i+en]) / x;
                      h[nm*(i+1)+en] = (-sa - w * h[nm*i+en] - q * h[nm*i+na]) / x;
                      continue;
                  }
                  z3 = complex(-r-y*h[nm*i+na], -s-y*h[nm*i+en]) / complex(zz, q);
                  h[nm*(i+1)+na] = real(z3);
                  h[nm*(i+1)+en] = imag(z3);
              }
          }         // ***** End complex vector
      }             // ***** End back substitution.

//    ***** Vectors of isolated roots
      for (i = 1; i <= n; i++) {
          if (i >= low && i <= igh) continue;
          for (j = i; j <= n; j++)
              z[nm*i+j] = h[nm*i+j];
      }

//    ***** Multiply by transformation matrix
//          to give vectors of original full matrix.
      for (j = n; j >= low; j--) {
          m = (j < igh) ? j : igh;
          for (i = low; i <= igh; i++) {
              zz = 0.0;
              for (k = low; k <= m; k++)
                  zz += z[nm*i+k] * h[nm*k+j];
              z[nm*i+j] = zz;
          }
      }
      return 0;
}
