int hqr2(

//     This subroutine is a translation of the algol procedure HQR2,
//     Num. math. 16, 181-204(1970) by Peters and Wilkinson.
//     Handbook for auto. comp., vol.II-Linear algebra, 372-395(1971).

//     This subroutine finds the eigenvalues and eigenvectors
//     of a real upper Hessenberg matrix by the QR method.  The
//     eigenvectors of a real general matrix can also be found
//     if  ELMHES  and  ELTRAN  or  ORTHES  and    ORTRAN    have
//     been used to reduce this general matrix to Hessenberg form
//     and to accumulate the similarity transformations.

    int     nm,

//     nm must be set to the row dimension of two-dimensional
//       array parameters as declared in the calling program
//       dimension statement.

    int     n,

//     n is the order of the matrix.

    int     low,
    int     igh,

//     low and igh are integers determined by the balancing
//       subroutine  BALANC.    If  BALANC  has not been used,
//       set low=1, igh=n.

    double  *h,

//     h contains on input the upper Hessenberg matrix.
//     h will be destroyed on output.

    double  wr[],
    double  wi[],

//     wr and wi contain on output the real and imaginary parts,
//       respectively, of the eigenvalues.  The eigenvalues
//       are unordered except that complex conjugate pairs
//       of values appear consecutively with the eigenvalue
//       having the positive imaginary part first.  If an
//       error exit is made, the eigenvalues should be correct
//       for indices ierr+1,...,n.

    double  *z,

//     z contains on input the transformation matrix produced by
//       ELTRAN after the reduction by  ELMHES, or by  ORTRAN  after
//       the reduction by  ORTHES, if performed. If the eigenvectors
//       of the Hessenberg matrix are desired, z must contain the
//       identity matrix.
//     z contains on output the real and imaginary parts of the 
//       eigenvectors. If the i-th eigenvalue is real, the i-th column
//       of z contains its eigenvector.  If the i-th eigenvalue is
//       complex with positive imaginary part, the i-th and (i+1)-th
//       columns of z contain the real and imaginary parts of its
//       eigenvector.  The eigenvectors are unnormalized.  If an
//       error exit is made, none of the eigenvectors has been found.

    float   machep

//     machep is a machine dependent parameter specifying
//        the relative precision of floating point arithmetic.

    );
//     return code is set to:
//       zero       for normal return,
//       j          if the j-th eigenvalue has not been
//              determined after 30 iterations.
