/* Procedura de trasare a graficului unei functii data tabelar */
/*=============================================================*/
/* Data: 4.03.1991.
   Programator Irina Munteanu
   Data ultimei modificari: 09.04.1991 */


#include <graphics.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "c:\radu\grader.cpp"

#define afis_liniar_x outtextxy(x0-2,y1+5,ltoa( (long)(markx.min*pow10(eu)+ i*markx.inter), asc_nr, 10))
#define afis_log_x if (i%10 == 0){outtextxy(x0-2,y1+5,"10"); outtextxy(x0-2+textwidth("10"),y1+3,ltoa( (long)(markx.min+ i/10*markx.inter), asc_nr, 10));}

#define afis_liniar_y outtextxy(x0-2,y0,ltoa( (long)(marky.min+ i*marky.inter), asc_nr, 10))
#define afis_log_y if (i%10 == 0){ outtextxy(x0-2,y0-8,ltoa( (long)(marky.min+ i/10*marky.inter), asc_nr, 10));outtextxy(x0-2-textwidth("1"),y0,"10"); }


#define NR_INTERVALE 9
#define XMARGIN 60
#define YMARGIN 30
#define NGRAF 3

float val1[M+1][N], val2[M+1][N], val3[M+1][N];
float pozmark[] = {0,0.1,0.2,0.5,1,2,5,10,20,50};  /* ??? 0 */
float logpozmark[] = {0,1,2,5,10};  /* ??? 0 */
int hold=0;			/* Pastreaza vechiul grafic */
struct {
       int x;
       int y;
       int crt;
       } window_crt;
typedef struct {
	   int x;
	   int y;
	   } point;
point corners[2]; /* sus - jos; left - top - right - bottom */
struct{
      char point;
      char end;
      char line;
      char color;
	} style[5] = {{'\0','\0','-','y'},{'\0','\0','-','g'},{'\0','\0','-','b'},{'\0','\0','-','w'},
					{'\0','\0','-','w'}};
struct{
      float scale;
      float fact;   /* posibil - mai urmeaza si altele */
      float min;
      float max;
      float inter;
      int log;
      int nrmark;
      } markx, marky;
int markersx[N+1], markersy[N+1];  /* Pentru grid la log !! */
int eu = 0, y0lin;


/* ====================================================================
   Traseaza dreptunghiul reprezentind limitele pe ecran ale graficului.
   ==================================================================== */
void tras_dreptunghi(void)
{
/* Foloseste variabilele globale:  corners[]  - colturile dreptunghiului,
				   initializate la lansarea colectiei de
				   subrutine
   Modifica variabilele globale:  --
*/

  /* Culoare alba, linie continua subtire */
  setcolor(LIGHTGRAY);
  setlinestyle(SOLID_LINE,0,NORM_WIDTH);

  /* Traseaza dreptunghi */
  rectangle(corners[0].x,corners[0].y,corners[1].x,corners[1].y);

} /* End tras_dreptunghi */



/* =============================================================
   Determina valoarea maxima si minima dintr-un sir de nr. reale
   ============================================================= */
void val_min_max(int nr, float x[], float *min, float *max)
{
  float xmin, xmax;
  int i;

  xmin = *min;
  xmax = *max;
  for (i=0; i<nr; i++)           
    {
    if (x[i] > xmax) xmax = x[i];
    if (x[i] < xmin) xmin = x[i];
    }
  *min = xmin;
  *max = xmax;

} /* End val_min_max */



/* =======================================
   Etaloneaza axa Ox, in fereastra curenta.
   ======================================= */
void etalon_x(int nr, float x[])
{
  int i;
  float xmax, xmin, deltax, rest, fact, interval;
  int pixmin, pixmax,nrmark,distpixel;


/* Foloseste variabilele globale: corners, pozmark;
   Modifica variabilele globale: markx, corners[1].x
*/

  /* Determina valorile maxime ale lui x */
  /* ------ Ce se intimpla daca toti x-ii sint egali ? */
  xmin = xmax = x[0];
  val_min_max(nr, x, &xmin, &xmax);
  deltax = xmax - xmin;

  /* Extrage factorul de scala */
  fact = 0;
  if (deltax > 100)
	while (deltax > 100 && (fabs(xmax) > 100 || fabs(xmin) > 100))
	  {
	  deltax /= 10;
	  xmax /= 10;
	  xmin /= 10;
	  fact++;
	  }
  else if (deltax < 1)
	while (deltax < 1 && (fabs(xmax) < 1 || fabs(xmin) < 1))
      {
      deltax *= 10;
      xmax *= 10;
      xmin *= 10;
      fact--;
      }
  /* ------ acum xmax, xmin, deltax sint intre 1 si 100 */

  /* Determina lungimea intervalului */
  interval = deltax/NR_INTERVALE;
  for (i=4; i<10; i++)	/* Deocamdata incepe cu interval min. 1 */
	if (interval <= pozmark[i]) break;
  interval = pozmark[i];

  /* Rotunjeste xmin, xmax in vederea afisarii corecte */
  xmin = floor(xmin);  /* partea intreaga a lui xmin */
  rest = (int)(xmin) % (int)(interval);  /*  Atentie !! De verif*/
  if (rest != 0)
    {
    if (xmin < 0) xmin -= interval;
    xmin -= rest;  /* !!!! */
	}

  if (xmax - floor(xmax) > 1e-4)
	xmax = ceil(xmax);  /* cel mai mic intreg mai mare decit xmax */
  rest = (int)(xmax) % (int)(interval);
  if (rest != 0)
    {
    if (xmax > 0) xmax += interval;
    xmax -= rest;
    }

  /* Stabileste lungime marker, ...etc. */
  deltax = xmax - xmin;
  pixmin = corners[0].x;		/* x min pe ecran in pixeli */
  pixmax = corners[1].x;		/* x max pe ecran in pixeli */
  nrmark = deltax/interval;  		/* numar de markeri */
  if (nrmark == 1){
	nrmark = 10;
	eu = 1;
  }
  distpixel = (pixmax - pixmin)/nrmark;	/* lungimea markerului in pixeli*/
  pixmax = pixmin+nrmark*distpixel;	/* valoarea corectata a lui pixmax */

  /* Completeaza markersx */
  for (i=0; i<=nrmark; i++)
    markersx[i] = pixmin+i*distpixel;	/* marker pe x pentru grid */


  /* Completeaza markx, corners */
  if(eu == 0){
	  //markx.scale = deltax/(pixmax - pixmin);
	  markx.fact = fact;
  }
  else if(eu == 1){
	  //markx.scale = 10*deltax/(pixmax - pixmin);
	  markx.fact = fact - 1;
  }
  markx.scale = deltax/(pixmax - pixmin);
  markx.min = xmin;
  markx.max = xmax;
  markx.inter = interval;
  markx.log = 0;
  markx.nrmark = nrmark;
  corners[1].x = pixmax;

} /* End etalon_x */


/* ====================================================
   Etaloneaza axa Ox logaritmica, in fereastra curenta.
   ==================================================== */
int logetalon_x(int nr, float x[])
{
  int i,j;
  float xmax, xmin, deltax, rest, factmax,factmin, interval;
  int pixmin, pixmax,nrmark,distpixel;


/* Foloseste variabilele globale: corners, pozmark;
   Modifica variabilele globale: markx, corners[1].x
*/

  /* Determina valorile maxime ale lui x */
  /* ------ Ce se intimpla daca toti x-ii sint egali ? */
  xmin = xmax = x[0];
  val_min_max(nr, x, &xmin, &xmax);  /* daca xmin < 0 ? */
  if (xmin <= 0) return 1;
  deltax = xmax - xmin;

  /* Extrage factorul de scala */
  factmax = 1;
  factmin = 0;
  if ( xmax > 10)
    while (xmax>10)
      {
      xmax /= 10;
      factmax++;
      }
  else if (xmax < 1)
    while (xmax < 1)
      {
      xmax *= 10;
      factmax--;
      }
  if ( xmin > 10)
    while (xmin>10)
      {
      xmin /= 10;
      factmin++;
      }
  else if (xmin < 1)
    while (xmin < 1)
      {
      xmin *= 10;
      factmin--;
      }
  /* ------ acum xmax, xmin, deltax sint intre 1 si 10 */

  /* Determina lungimea intervalului */
  deltax = factmax-factmin;
  interval = deltax/5;	/* 5 intervale la scara logaritmica */
  for (i=0; i<5; i++)
    if (fabs(interval) <= logpozmark[i]) break;
  if (interval > 0)
    interval = logpozmark[i];
  else
    interval = -logpozmark[i-1];

  /* Rotunjeste xmin, xmax in vederea afisarii corecte */
  factmin = floor(factmin);  /* partea intreaga a lui xmin */
  rest = (int)factmin % (int)interval;
  if (rest != 0)
    {
    if (factmin < 0) factmin -= interval;
    factmin -= rest;
    }
  factmax = ceil(factmax);  /* cel mai mic intreg mai mare decit xmax */
  rest = (int)factmax % (int)interval;
  if (rest != 0)
    {
    if (factmax > 0) factmax += interval;
    factmax -= rest;
    }

  /* Stabileste lungime marker, ...etc. */
  deltax = factmax - factmin;
  pixmin = corners[0].x;		/* x min pe ecran in pixeli */
  pixmax = corners[1].x;		/* x max pe ecran in pixeli */
  nrmark = deltax/interval;  		/* numar de markeri */
  distpixel = (pixmax - pixmin)/nrmark;	/* lungimea markerului in pixeli*/
  pixmax = pixmin+nrmark*distpixel;	/* valoarea corectata a lui pixmax */

  /* Completeaza markersx */
  for (i=0; i<nrmark; i++)
    for (j=1; j<=10; j++)
      markersx[10*i+j-1] = pixmin+i*distpixel+log10(j)*distpixel;
				/* marker pe x pentru grid */


  /* Completeaza markx, corners */
  markx.scale = distpixel;
  markx.fact = 0;
  markx.min = factmin;
  markx.max = factmax;
  markx.inter = interval;
  markx.log = 1;
  markx.nrmark = nrmark*10-1;
  corners[1].x = pixmax;

  return 0;

} /* End logetalon_x */



/* =======================================
   Etaloneaza axa Oy, in fereastra curenta.
   ======================================= */
void etalon_y(int n,int nr, float y[][N])
{
  int i;
  float ymax, ymin, deltay, rest, fact, interval;
  int pixmin, pixmax,nrmark,distpixel;


/* Foloseste variabilele globale: corners, pozmark;
   Modifica variabilele globale: marky, corners[0].y
*/

  /* Determina valorile maxime ale lui y */
  /* ------ Ce se intimpla daca toti y-ii sint egali ? */
  ymin = ymax = y[0][0];
  for (i=0; i<n; i++)
    val_min_max(nr, y[i], &ymin, &ymax);
  if (fabs(ymin - ymax) < 1.0E-20) {		/* y-ii egali */
	ymax += 1;
	ymin -= 1;
  }
  deltay = ymax - ymin;

  /* Extrage factorul de scala */
  fact = 0;
  if (deltay > 100)
    while (deltay >100 && (fabs(ymax) > 100 || fabs(ymin) > 100))
      { deltay /= 10; ymax /= 10; ymin /= 10; fact++; }

  else if (deltay < 1)
    while (deltay < 1 && (fabs(ymax) < 1 || fabs(ymin) < 1))
      { deltay *= 10; ymax *= 10; ymin *= 10; fact--; }
  /* ------ acum ymax, ymin, deltay sint intre 1 si 100 */

  /* Determina lungimea intervalului */
  interval = deltay/NR_INTERVALE;
  for (i=4; i<10; i++)		/* Deocamdata incepe cu interval=1 */
    if (interval <= pozmark[i]) break;
  interval = pozmark[i];

  /* Rotunjeste ymin, ymax in vederea afisarii corecte */
  ymin = floor(ymin);  /* partea intreaga a lui ymin */
  rest = (int)ymin % (int)interval;
  if (rest != 0)
    {
    if (ymin < 0) ymin -= interval;
    ymin -= rest;
    }
  ymax = ceil(ymax);  /* cel mai mic intreg mai mare decit ymax */
  rest = (int)ymax % (int)interval;
  if (rest != 0)
    {
    if (ymax > 0) ymax += interval;
    ymax -= rest;
    }

  /* Stabileste lungime marker, ...etc. */
  deltay = ymax - ymin;
  pixmin = corners[0].y;		/* y min pe ecran in pixeli */
  pixmax = corners[1].y;		/* y max pe ecran in pixeli */
  nrmark = deltay/interval;  		/* numar de markeri */
  distpixel = (pixmax - pixmin)/nrmark;	/* lungimea markerului in pixeli*/
  pixmin = pixmax - nrmark*distpixel;	/* valoarea corectata a lui pixmin */

  /* Completeaza markersy */
  for (i=0; i<=nrmark; i++)
    markersy[i] = pixmax-i*distpixel;	/* marker pe y pentru grid */

  /* Completeaza marky, corners */
  marky.scale = deltay/(pixmax - pixmin);
  marky.fact = fact;
  marky.min = ymin;
  marky.max = ymax;
  marky.inter = interval;
  marky.log = 0;
  marky.nrmark = nrmark;
  corners[0].y = pixmin;


} /* End etalon_y */


/* ====================================================
   Etaloneaza axa Oy logaritmica, in fereastra curenta.
   ==================================================== */
int logetalon_y(int n,int nr, float y[][N])
{
  int i,j;
  float ymax, ymin, deltay, rest, factmax, factmin, interval;
  int pixmin, pixmax,nrmark,distpixel;


/* Foloseste variabilele globale: corners, pozmark;
   Modifica variabilele globale: marky, corners[0].y
*/

  /* Determina valorile maxime ale lui y */
  /* ------ Ce se intimpla daca toti y-ii sint egali ? */
  ymin = ymax = y[0][0];
  for (i=0; i<n; i++)
    val_min_max(nr, y[i], &ymin, &ymax); /* daca ymin < 0 ? */
  if (ymin <= 0) return 1;
  deltay = ymax - ymin;

  /* Extrage factorul de scala */
  factmin = 0;
  factmax = 1;
  if ( ymax > 10)
    while (ymax>10)
      {
      ymax /= 10;
      factmax++;
      }
  else if (ymax < 1)
    while (ymax < 1)
      {
      ymax *= 10;
      factmax--;
      }
  if ( ymin > 10)
    while (ymin>10)
      {
      ymin /= 10;
      factmin++;
      }
  else if (ymin < 1)
    while (ymin < 1)
      {
      ymin *= 10;
      factmin--;
      }

  /* ------ acum ymax, ymin, deltay sint intre 1 si 10 */

  /* Determina lungimea intervalului */
  deltay = factmax - factmin;
  interval = deltay/5;		/* La log - 5 intervale */
  for (i=0; i<5; i++)
    if (fabs(interval) <= logpozmark[i]) break;
  if (interval > 0)
    interval = logpozmark[i];
  else
    interval = -logpozmark[i-1];


  /* Rotunjeste ymin, ymax in vederea afisarii corecte */
  factmin = floor(factmin);  /* partea intreaga a lui ymin */
  rest = (int)factmin % (int)interval;
  if (rest != 0)
    {
    if (factmin < 0) factmin -= interval;
    factmin -= rest;
    }
  factmax = ceil(factmax);  /* cel mai mic intreg mai mare decit ymax */
  rest = (int)factmax % (int)interval;
  if (rest != 0)
    {
    if (factmax > 0) factmax += interval;
    factmax -= rest;
    }

  /* Stabileste lungime marker, ...etc. */
  deltay = factmax - factmin;
  pixmin = corners[0].y;		/* y min pe ecran in pixeli */
  pixmax = corners[1].y;		/* y max pe ecran in pixeli */
  nrmark = deltay/interval;  		/* numar de markeri */
  distpixel = (pixmax - pixmin)/nrmark;	/* lungimea markerului in pixeli*/
  pixmin = pixmax - nrmark*distpixel;	/* valoarea corectata a lui pixmin */

  /* Completeaza markersy */
  for (i=0; i<=nrmark; i++)
    for (j=1; j<=10; j++)
    markersy[10*i+j-1] = pixmax-i*distpixel-log10(j)*distpixel;	/* marker pe y pentru grid */

  /* Completeaza marky, corners */
  marky.scale = distpixel;
  marky.fact = 0;
  marky.min = factmin;
  marky.max = factmax;
  marky.inter = interval;
  marky.log = 1;
  marky.nrmark = nrmark*10 - 1;
  corners[0].y = pixmin;

  return 0;


} /* End logetalon_y */


/* ==========================================================
   Afiseaza markeri, traseaza dreptunghiul; Obs:grafic normal
   ========================================================== */
void putmarkers(void)
{

  int i;
  int x0,x1,y0,y1;
  char asc_nr[10];  /* erau suf. 5 */

  setcolor(LIGHTGRAY);
  /* Afiseaza markeri, numere pe axa Ox */
  settextjustify(LEFT_TEXT, TOP_TEXT);
  y0 = corners[0].y;
  y1 = corners[1].y;
  for (i=0; i<=markx.nrmark; i++)
    {
    x0 = markersx[i];	/* pozitia curenta pe Ox */
	/* Traseaza markeri */
    line(x0,y0,x0,y0+5);	/* Marker sus */
    line(x0,y1,x0,y1-5);	/* Marker jos */
       /* Afiseaza numerele. Daca ele pot fi reale se va folosi fcvt*/
    if (markx.log == 0)
      afis_liniar_x;
    else
      afis_log_x;

    }
	if (markx.log != 0) afis_log_x;

  //Afiseaza factorul de scala pt. axa Ox
  if (markx.fact != 0)
    {
	moveto(corners[1].x +25, y1 + 5);
	outtext("x10");
	moveto(corners[1].x + 20 + textwidth("x10"), y1-2);
    outtext(ltoa( (long)(markx.fact), asc_nr, 10));
    }



  /* Afiseaza markeri, numere pe axa Oy */
  settextjustify(RIGHT_TEXT, BOTTOM_TEXT);
  x0 = corners[0].x;
  x1 = corners[1].x;
  for (i=0; i<=marky.nrmark; i++)
    {
    y0 = markersy[i];		/* pozitia curenta pe Oy */
	/* Traseaza markeri */
    line(x0,y0,x0+5,y0);   	/* Marker stinga */
    line(x1,y0,x1-5,y0);	/* Marker dreapta */
	/* Afiseaza numerele. Daca ele pot fi reale se va folosi fcvt*/
    if (marky.log == 0)
      afis_liniar_y;
    else
      afis_log_y;
    }
    if (marky.log != 0) afis_log_y;

  /* Scrie factor de scala ptr.Oy */
  if (marky.fact != 0)
	{
	moveto(x0 - 20, corners[0].y - 5);
	outtext("x10");
	moveto(x0 - 20 + textwidth("x"), corners[0].y - 14);
	outtext(ltoa( (long)(marky.fact), asc_nr, 10));
	}


  /* Traseaza dreptunghiul */
  tras_dreptunghi();

} /* End putmarkers */





/* =============
   Traseaza grid
   ============= */
void grid(void)
{

  int pixmax, pixmin;
  int i;

/* Foloseste variabilele globale: corners, markersx, markersy;
   Modifica variabilele globale: --
*/

  setlinestyle(USERBIT_LINE, 0x8888, NORM_WIDTH);
  setcolor(LIGHTGRAY);

  /* Traseaza grid pe verticala */
  pixmin = corners[0].x;	/* x min pe ecran in pixeli */
  pixmax = corners[1].x;	/* x max pe ecran in pixeli */
  for (i=0; i<=marky.nrmark; i++)
    line(pixmin,markersy[i],pixmax,markersy[i]);

  /* Traseaza grid pe orizontala */
  pixmin = corners[0].y;	/* y min pe ecran in pixeli */
  pixmax = corners[1].y;	/* y max pe ecran in pixeli */
  for (i=0; i<=markx.nrmark; i++)
    line(markersx[i],pixmin,markersx[i],pixmax);


  setlinestyle(SOLID_LINE, 0, NORM_WIDTH);

} /* End grid */


/* =======================
   Afiseaza eticheta pe Ox
   ======================= */
void label_x(char *text)
{
  int x0, y0;

/* Foloseste variabilele globale: corners;
   Modifica variabilele globale: --
*/

  settextjustify(CENTER_TEXT, TOP_TEXT);
  setcolor(LIGHTGRAY);
  x0 = (corners[1].x + corners[0].x)/2;
  y0 = corners[1].y + 10 + textheight("0");
  outtextxy(x0,y0,text);

} /* End label_x */



/* =======================
   Afiseaza eticheta pe Oy
   ======================= */
void label_y(char *text)
{
  int x0, y0;

/* Foloseste variabilele globale: corners;
   Modifica variabilele globale: --
*/

  settextstyle(DEFAULT_FONT, VERT_DIR, 0);
  settextjustify(LEFT_TEXT, CENTER_TEXT);
  setcolor(LIGHTGRAY);
  y0 = (corners[1].y + corners[0].y)/2;
  x0 = corners[0].x -2 - 3*textwidth("0");
  outtextxy(x0,y0,text);
  settextstyle(DEFAULT_FONT, HORIZ_DIR, 0);

} /* End label_y */


/* ===============
   Afiseaza titlul
   =============== */
void title(char *text)
{
  int x0, y0;

/* Foloseste variabilele globale: corners;
   Modifica variabilele globale: --
*/

  settextjustify(CENTER_TEXT, BOTTOM_TEXT);
  setcolor(WHITE);
  x0 = (corners[1].x + corners[0].x)/2;
  y0 = corners[0].y - 5/*+ textheight("0")*/;
  outtextxy(x0,y0,text);

} /* End title */


/* ============================
   Stabileste fereastra curenta
   ============================ */
int subplot(int nrx, int nry, int crt)
{
  int x,y,maxx,maxy,x0,x1,y0,y1;

/* Foloseste variabilele globale: window_crt,XMARGIN, MARGIN;
   Modifica variabilele globale: window_crt, corners;
*/

  if (nrx>2 || nry >2 || nrx<0 || nry<0) return 1;

  if (nrx != window_crt.x || nry != window_crt.y) cleardevice();
  /* Ce fac cu hold ?? */

  /* Determina noua fereastra curenta */
  x = (crt-1)%nrx;
  y = (crt-1)/nrx;
  maxx = getmaxx();
  maxy = getmaxy();  		/* numar maxim de pixeli pe x si pe y */
  /* Limitele ferestrei */
  x0 = (maxx/nrx)*x+1;
  x1 = (maxx/nrx)*(x+1);
  y0 = (maxy/nry)*y+1;
  y1 = (maxy/nry)*(y+1);
  setviewport(x0,y0,x1,y1,1);  	/* 1 = Taie tot ce iese din fereastra */
  clearviewport();		/* Atentie la hold!! */
  corners[0].x = XMARGIN;
  corners[1].x = x1 - x0 - XMARGIN;
  corners[0].y = YMARGIN;
  corners[1].y = y1 - y0 - YMARGIN;
  y0lin = y1 - y0 - YMARGIN;
  window_crt.x = nrx;
  window_crt.y = nry;
  window_crt.crt = crt;
  return 0;

} /* End subplot */


/* ======================================
   Stabileste tipul liniei si culoarea ei.
   ======================================*/
int schimba_culoare(int nrgraf)
{
  int cul, lin;

/* Foloseste variabilele globale: NGRAF, style;
   Modifica variabilele globale: --
*/

  if (nrgraf > NGRAF) return 1;

  /* Tipul liniei */
  switch(style[nrgraf].line)
    {
    case '.':
	  lin = DOTTED_LINE; break;
	case '|':
	  lin = CENTER_LINE; break;
	case ':':
	  lin = DOTTED_LINE; break;
	case '!':
	  lin = USERBIT_LINE; break;
	case '=':
	  lin = SOLID_LINE; break;
	case '"':           
	  lin = DOTTED_LINE; break;
	default:
	case '-':
	  lin = SOLID_LINE;
	}
  setlinestyle(lin,0,NORM_WIDTH);

  /* Culoarea */
  switch(style[nrgraf].color)
    {
    case 'g':
      cul = LIGHTGREEN;break;
    case 'b':
      cul = LIGHTCYAN;break;
    case 'y':
      cul = YELLOW;break;
    case 'w':
      cul = WHITE;break;
    case 'i':
      cul = getbkcolor();break;
    default:
    case 'r':
      cul = LIGHTRED;  /* Atentie !! Neportabil !! */
    }
  setcolor(cul);

  return (0);

} /* End schimba_culoarea */


/* =====================
   Deseneaza un cerculet
   ===================== */
void cerc(int x, int y)
{
  circle(x,y,3);
}

/* =======================
   Deseneaza un dreptunghi
   ======================= */
void drept(int x, int y)
{
  rectangle(x-2,y-2,x+2,y+2);
}

/* ==============
   Deseneaza un x
   ============== */
void xx(int x, int y)
{
  line(x-2,y-2,x+2,y+2);
  line(x+2,y-2,x-2,y+2);
}

/* ===================
   Deseneaza o steluta
   =================== */
void stea(int x, int y)
{
  line(x-2,y-2,x+2,y+2);
  line(x+2,y-2,x-2,y+2);
  line(x-2,y,x+2,y);
}


/* ===================
   Deseneaza un pixel
   =================== */
void pix(int x, int y)
{
  line(x,y,x,y);
}


/* =================
   Deseneaza un plus
   ================= */
void plus(int x, int y)
{
  line(x,y-2,x,y+2);
  line(x-2,y,x+2,y);
}


/* ==========================
   Afiseaza punctul din tabel
   ========================== */
void punct(int i, int x, int y)
{
  switch(style[i].point)
  {
    case '*': stea(x,y); break;
    case '.': pix(x,y); break;
    case '#': drept(x,y); break;
    case 'x': xx(x,y); break;
    case '+': plus(x,y); break;
    case 'o': cerc(x,y); break;
  }
} /* End punct */

/* =============================================
   Redefineste tipurile implicite pentru grafic.
   ============================================= */
int redefinire(int graf, char point, char lin, char color)
{

/* Foloseste variabilele globale: NGRAF, style;
   Modifica variabilele globale: style;
*/

  style[graf-1].color = color;
  style[graf-1].point = point;
  style[graf-1].line = lin;
  return (0);  /* Verificare valori!!! Atentie! point poate fi si \0 */

} /* End redefinire */


/* ==================================================
   Returneaza pixelul curent pe Ox ptr.grafic normal.
   ================================================== */
int valx( float x)
{
	return (corners[0].x + (x/pow10(markx.fact)-markx.min)/markx.scale);
}

/* ==================================================
   Returneaza pixelul curent pe Oy ptr.grafic normal.
   ================================================== */
int valy( float y)       /* Poate sa fie cu define !!! */
{
  return (corners[0].y + (marky.max-y/pow10(marky.fact))/marky.scale);
}


/* ======================================================
   Returneaza pixelul curent pe Ox ptr.grafic logaritmic.
   ====================================================== */
int logvalx( float x)
{
  float putere = (markx.max - markx.min) * 10 / (markx.nrmark + 1);
  return (corners[0].x + (log10(x)-markx.min)*markx.scale / putere);
}

/* ======================================================
   Returneaza pixelul curent pe Oy ptr.grafic logaritmic.
   ====================================================== */
int logvaly( float y)       /* Poate sa fie cu define !!! */
{
  float putere = (marky.max - marky.min) * 10 / (marky.nrmark + 1);
  return (corners[0].y + (marky.max-log10(y))*marky.scale / putere);
}


/* ================================================
  Afiseaza un grafic in fereastra grafica curenta.
  ================================================= */
int grafic (int n, 	/* Numarul de grafice */
	int nr, 	/* Numarul de puncte */
	float val[][N],	/* val[0] = x; restul: cite un y */
	int logx,	/* scara pe x este logaritmica? */
	int logy)	/* scara pe y este logaritmica? */
{

/* Afiseaza n grafice in fereastra grafica curenta.
   Foloseste variabilele globale: NGRAF
   Modifica variabilele globale: --
*/
  int x0,y0;
  int i,j,ier;

  if (n > NGRAF || nr>N ) return (1);

  if (!hold)
    {
	clearviewport();
    if (logx==0)
      etalon_x(nr, val[0]);
    else
      {ier = logetalon_x(nr,val[0]); if (ier !=0) return 1;}
    if(logy==0)
      etalon_y(n,nr,val+1); 	/* val[1] */
    else
      {ier = logetalon_y(n,nr,val+1); if (ier !=0) return 1;}
    }
  putmarkers();
  markx.fact += eu;
  eu = 0;
  for (i=1; i<=n; i++)
    {
    schimba_culoare(i-1);
    settextjustify(CENTER_TEXT, BOTTOM_TEXT);

    /* Stabileste punctul de inceput */
    if (logx == 0) x0 = valx(val[0][0]);
    else x0 = logvalx(val[0][0]);
    if (logy == 0) y0 = valy(val[i][0]);
    else y0 = logvaly(val[i][0]);
    if (style[i-1].point != '\0') /*outtextxy(x0,y0+textheight(&style[i-1].point)/2,&style[i-1].point);	/* afis.puncte */
	punct(i-1,x0,y0);
    moveto(x0,y0);

    /* Deseneaza graficul si punctele */
    for (j=1; j<nr; j++)
      {
      if (logx == 0) x0 = valx(val[0][j]);
      else x0 = logvalx(val[0][j]);
      if (logy == 0) y0 = valy(val[i][j]);
      else y0 = logvaly(val[i][j]);
      if (style[i-1].line != '\0')
	lineto(x0, y0);		/* afis.linie.polig.*/
      if (style[i-1].point != '\0')
	{
	/*outtextxy(x0,y0+textheight(&style[i-1].point)/2,&style[i-1].point);	/* afis.puncte */
	/*cerc(x0,y0);*/
	punct(i-1,x0,y0);
	moveto(x0,y0);
	}
      }
    } /* for i */
  return (0);

} /* End grafic */


/* ==========================
   Afiseaza un grafic liniar.
   ========================== */
int plot(int n, int nr, float val[][N])
{
  return( grafic(n,nr,val,0,0)) ;
} /* End plot */


/* ========================================
   Afiseaza un grafic logaritmic pe axa Ox.
   ======================================== */
int semilogx(int n, int nr, float val[][N])
{
  return( grafic(n,nr,val,1,0));
} /* End semilogx */


/* ========================================
   Afiseaza un grafic logaritmic pe axa Oy.
   ======================================== */
int semilogy(int n, int nr, float val[][N])
{
  return (grafic(n,nr,val,0,1));
} /* End semilogy */


/* ============================================
   Afiseaza un grafic logaritmic pe ambele axe.
   ============================================ */
int loglog(int n, int nr, float val[][N])
{
  return (grafic(n,nr,val,1,1));
} /* End loglog */


/* =============================
   Initializeaza datele necesare
   ============================= */
int initial(void)
{
  int g_driver, g_mode, g_error;

  detectgraph(&g_driver, &g_mode);
  initgraph(&g_driver, &g_mode,"c:\\tc\\bgi\\");
  g_error = graphresult();
  if (g_error <0)
    {
    printf("Eroare in graphinit : %s.\n", grapherrormsg(g_error));
    return 1;
    }
  hold = 0;
  setcolor(LIGHTGRAY);
  subplot(1,1,1);
  return 0;
  /* De initializat si culorile? */

} /* End initial */

void restore(void)       /* revine in modalfanum. dupa apsarea unei taste */
{
	getch();
	restorecrtmode();
}