function rez = timp_produs_scalar(n)
a = rand(n,1);
b = rand(n,1);
timer();
ps = 0;
for i = 1:n
	ps = ps + a(i)*b(i);
end
rez = timer();
return;

// *********************************

function rez = timp_produs_polinoame(n)
r = rand(n+1,1);
q = rand(n+1,1);
timer();

sizepp = 2*n+1;
pp = zeros(sizepp,1);
for i = 1:n+1
	for j = 1:n+1
		k = i + j - 1;
		pp(k) = pp(k) + r(i)*q(j)
	end
end
rez = timer();
return
	
// *********************************

function rez = timp_produs_matrice(n)
a = rand(n,n);
b = rand(n,n);
timer();

c = zeros(n,n);
for i = 1:n
	for j = 1:n
		c(i,j) = 0;
		for k = 1:n
			c(i,j) = c(i,j) + a(i,k)*b(k,j);
		end
	end
end
rez = timer();
return

// *****************

function [] = demo_analiza(valori,tip)

getf('alte_functii.sci');

// valori = 0:10000:100000  pentru produs scalar (tip = 1)
// valori = 0:100:500 pentru produs polinoame (tip = 2)
// valori = 0:10:100 pentru produs matrice (tip = 3)
// valori = ..... pentru toate (tip = 4)

no = length(valori);
abscisa = zeros(no,1);
timp3 = zeros(no,1);

for i = 1:no
	n = valori(i);
	printf('\n n = %d',n);
	abscisa(i) = n;
	select tip
	case 1 then
		printf(' Produs scalar: ');
		timp1(i) = timp_produs_scalar(n);
		printf(' timp CPU = %e',timp1(i));
	case 2 then
		printf(' Produs polinoame: ');
		timp2(i) = timp_produs_polinoame(n);
		printf(' timp CPU = %e',timp2(i));	
	case 3 then
		printf(' Produs matrice: ');
		timp3(i) = timp_produs_matrice(n);
		printf(' timp CPU = %e',timp3(i));
	end;
end;

xclear();
delmenu(0,'File');
delmenu(0,'3D Rot.');
actions = ['xdel(0); exec analizaL01.sci;'];
addmenu(0,'Exit');
Exit_0 = [actions(1)];

select tip
case 1 then
	set("figure_style","old");xname('Timpul de calcul al produsului scalar a doi vectori de dimensiune n');
	xtitle('Timp CPU pentru produsul scalar','dimensiunea n','Timp [s]');
	xgrid();
	plot2d([abscisa],[timp1],[2],'121','Timp CPU - produs scalar');
	
case 2 then
	set("figure_style","old");xname('Timpul de calcul al produsului a doua polinoame de grad n');
        xtitle('Timp CPU pentru produsul polinoamelor','gradul n','Timp [s]');
	xgrid();
	plot2d([abscisa],[timp2],[3],'121','Timp CPU - produs polinoame');
	
case 3 then
	set("figure_style","old");xname('Timpul de calcul al produsului a doua matrice de dimensiune n');
        xtitle('Timp CPU pentru produsul matricelor','gradul n','Timp [s]');
	xgrid();
	plot2d([abscisa],[timp3],[5],'121','Timp CPU - produs matrice');
end;

wait2close();
return;


