function [] = analiza_algoritmi_gauss(valori)

getf('gen_sist.sci');
getf('compute_errors.sci');
getf('GaussL03.sci');
getf('../L01/alte_functii.sci');
getf('gauss_pl1.sci');
getf('gauss_pt.sci');

no = length(valori);
abscisa = zeros(no,1);
timpGfp = zeros(no,1);
errGfp = zeros(no, 8);

timpGpp = zeros(no,1);
errGpp = zeros(no, 8);

timpGpt = zeros(no,1);
errGpt = zeros(no, 8);


for i = 1:no,
    n = valori(i);
    printf('\n \nErorile si timpul de calcul al metodei Gauss fara pivotare pentru n = %d',n);
   
    abscisa(i) = n;
    a = zeros(n, n);
    b = zeros(n, 1);
    x = zeros(n, 1);
    
    [a, x, b] = gen_sist(n);
    timer();
    [x_g] = Gauss(n, a, b);
    time = timer();
    timpGfp(i) = time;
    errGfp = compute_errors(x, x_g, a, i, errGfp);
   
    printf(' \nNorma euclidiana absoluta = %e', errGfp(i, 1));
    printf(' \nNorma euclidiana relativa = %e', errGfp(i, 2));
    printf(' \nNorma Cebisev absoluta = %e', errGfp(i, 3));
    printf(' \nNorma Cebisev relativa = %e', errGfp(i, 4));
    printf(' \nNorma reziduului euclidian absolut = %e', errGfp(i, 5));
    printf(' \nNorma reziduului euclidian relativ = %e', errGfp(i, 6));
    printf(' \nNorma reziduului Cebisev absolut = %e', errGfp(i, 7));
    printf(' \nNorma reziduului Cebisev relativ = %e', errGfp(i, 8));
    printf(' \ntimp CPU = %e',timpGfp(i));

    printf('\n \nErorile si timpul de calcul al metodei Gauss cu pivotare partiala pentru n = %d',n);
    timer();
    ierr = 0;
    [ierr, x_g] = gauss_pl1(n, a, b);
    time = timer();
    timpGpp(i) = time;
    errGpp = compute_errors(x, x_g, a, i, errGpp);
    printf(' \nNorma euclidiana absoluta = %e', errGpp(i, 1));
    printf(' \nNorma euclidiana relativa = %e', errGpp(i, 2));
    printf(' \nNorma Cebisev absoluta = %e', errGpp(i, 3));
    printf(' \nNorma Cebisev relativa = %e', errGpp(i, 4));
    printf(' \nNorma reziduului euclidian absolut = %e', errGpp(i, 5));
    printf(' \nNorma reziduului euclidian relativ = %e', errGpp(i, 6));
    printf(' \nNorma reziduului Cebisev absolut = %e', errGpp(i, 7));
    printf(' \nNorma reziduului Cebisev relativ = %e', errGpp(i, 8));
    printf(' \ntimp CPU = %e',timpGpp(i));

    printf('\n \nErorile si timpul de calcul al metodei Gauss cu pivotare totala pentru n = %d',n);

    ierr = 0;
    [ierr, x_g] = gauss_pt(n, a, b);
    time = timer();
    timpGpt(i) = time;
    errGpt = compute_errors(x, x_g, a, i, errGpt);
    printf(' \nNorma euclidiana absoluta = %e', errGpt(i, 1));
    printf(' \nNorma euclidiana relativa = %e', errGpt(i, 2));
    printf(' \nNorma Cebisev absoluta = %e', errGpt(i, 3));
    printf(' \nNorma Cebisev relativa = %e', errGpt(i, 4));
    printf(' \nNorma reziduului euclidian absolut = %e', errGpt(i, 5));
    printf(' \nNorma reziduului euclidian relativ = %e', errGpt(i, 6));
    printf(' \nNorma reziduului Cebisev absolut = %e', errGpt(i, 7));
    printf(' \nNorma reziduului Cebisev relativ = %e', errGpt(i, 8));
    printf(' \ntimp CPU = %e',timpGpt(i));
end;

xclear();
delmenu(0,'File');
delmenu(0,'3D Rot.');
actions = ['xdel(0);'];
addmenu(0,'Exit');
Exit_0 = [actions(1)];

set("figure_style","old");xname('Timpul de calcul la rezolvarea sistemelor de calcul cu metoda Gauss');
xtitle('Timp CPU','dimensiunea n','Timp [s]');
plot2d('nn',[abscisa abscisa abscisa],[timpGfp timpGpp timpGpt],[5 2 3],'121','Gauss fara pivotare@Gauss cu pivotare partiala@Gauss cu pivotare totala');
xgrid();

wait2close();

xclear();
delmenu(0,'File');
delmenu(0,'3D Rot.');
actions = ['xdel(0);'];
addmenu(0,'Exit');
Exit_0 = [actions(1)];

xname('Erorile absolute si reziduul absolut la rezolvarea sistemelor de calcul cu  Gauss');
xtitle('Erorile absolute si reziduul absolut','dimensiunea n','Erori');
plot2d('nl',[abscisa], [errGfp(:, 1) errGfp(:, 3) errGfp(:, 5) errGpp(:, 1) errGpp(:, 3) errGpp(:, 5)], [1 2 3 4 5 6], '181','er.abs.-norma euclidiana Gfp@er.abs.-norma Cebisev Gfp@rez.abs.-norma euclidiana Gfp@er.abs.-norma euclidiana Gpp@er.abs.-norma Cebisev Gpp@rez.abs-norma euclidiana Gpp');
xgrid();

wait2close();

xclear();
delmenu(0,'File');
delmenu(0,'3D Rot.');
actions = ['xdel(0);'];
addmenu(0,'Exit');
Exit_0 = [actions(1)];

xname('Erorile relative si reziduul relativ la rezolvarea sistemelor cu Gauss');
xtitle('Erorile relative si reziduul relativ','dimensiunea n','Erori');

plot2d('nl',[abscisa], [errGfp(:, 2) errGfp(:, 4) errGfp(:, 6) errGpp(:, 2) errGpp(:, 4) errGpp(:, 6)], [1 2 3 4 5 6], '181','er.rel.-norma euclidiana Gfp@er.rel.-norma Cebisev Gfp@rez.rel.-norma euclidianaGfp@er.rel.-norma euclidiana Gpp@er.rel.-norma Cebisev Gpp@rez.rel.-norma euclidiana Gpp');
xgrid();
wait2close();
return;
