
function [z] = AP(x, y, a, pivlin)
    z = a(pivlin(1, x), pivlin(2, y));
return;

function [z] = BP(x, b, pivlin)
    z = b(pivlin(1, x));
return;

function [ierr, x] = gauss_pt(n, a, b)

//Procedura Gauss cu pivotare totala
//n = dimens. matricii
//a = matricea coeficientilor
//b = vectorul termenilor liberi
//x = vectorul rezultatelor
//Matricea a ca si vectorul b se distrug.
//De aceea s-ar putea pune rezultatul in b.
//Se face pivotare totala pe linii si coloane fara
//cautarea pivotului optim ci doar a unui pivot
//nenul de valoare absoluta maxima.
//Intoarce ier = 0 - all OK
//ier = 1 - eroare. Nu se gaseste pivot diferit de 0. 

pivlin = zeros(2, n);
for i = 1:n
    pivlin(1, i) = i;
    pivlin(2, i) = i;
end;
//Eliminare
for i = 1:n-1
    maxl = i;
    maxc = i;
    for m = i+1: n
        for m1 = i:n
	    if ( abs( AP(m, m1, a, pivlin) )  > abs( AP(maxl, maxc, a, pivlin) ) )
	        maxl = m; maxc = m1;
	    end;
	end;
    end;
    if (AP(maxl, maxc, a, pivlin) == 0) then
        ierr = 1; return;
    else
        if (maxl <> i | maxc <> i) then
	    temp = pivlin(1, i);
	    pivlin(1, i) = pivlin(1, maxl);
	    pivlin(1, maxl) = temp;
	    temp = pivlin(2, i);
	    pivlin(2, i) = pivlin(2, maxc);
	    pivlin(2,maxc) = temp;
	end;
    end;
    for k = i+1:n
        if (AP(k, i, a, pivlin) <> 0) then
	    p = AP(k, i, a, pivlin)/AP(i, i, a, pivlin);
	    for j = i+1:n
		a(pivlin(1, k), pivlin(2, j)) =  AP(k, j, a, pivlin) - p*AP(i, j, a, pivlin);
	    end;
	    b(pivlin(1, k)) =  BP(k, b, pivlin) - p*BP(i, b, pivlin);
	end;
    end;
end;


//Retrosubstitutie

if (AP(n, n, a, pivlin) == 0) then
    ierr = 1; return;
end;

x(pivlin(2, n)) = BP(n, b,pivlin)/AP(n, n, a, pivlin);
for i = n-1:-1:1
    s = BP(i, b, pivlin);
    for j = n:-1:i+1
        s = s - AP(i, j, a, pivlin)*x(pivlin(2, j))
    end;
    x(pivlin(2, i)) = s/AP(i, i, a, pivlin);
end;

ierr = 0;
return;
