function [L] = lower(A)
	L = zeros(A);
	[l c] = size(A);
	if (l==c) then
		for i=1:l,
			L(i,1:i-1) = A(i,1:i-1);
		end;
	end;
return;

function [U] = upper(A)
	U = zeros(A);
	[l c] = size(A);
	if (l==c) then
		for i=1:l,
			U(i,i+1:l) = A(i,i+1:l);
		end;
	end;
return;

function [rho,norma] = testConv(A,met)
	D = diag(diag(A,0));
	L = lower(A);
	U = upper(A);
	select met,
		case 1 then // metoda Jacobi
			B = D;
			C = -(L+U);
		case 2 then // metoda Gauss-Seidel
			B = D + L;
			C = -U;
	end;
	M = B^(-1)*C;
	valP = spec(M); // vectorul valorilor proprii ale matricei M
	rho = max(abs(valP)); // raza de convergenta a matricei M
	norma = norm(M); // norma matricei de iteratie M
return;
