function [x]=Gauss(n,a,b)
	for k = 1:n-1,
		for i = k+1:n,
			p = a(i,k)/a(k,k);
			for j = k+1:n,
				a(i,j) = a(i,j)-a(k,j)*p;
			end;
			b(i) = b(i) - b(k)*p;
		end;
	end;
	x(n)=b(n)/a(n,n);
	for i = n-1:-1:1,
		s = b(i);
		for j = n:-1:i+1,
			s = s - a(i,j)*x(j);
		end;
		x(i) = s/a(i,i);
	end;
return;

function [V]=nodalCC(N,L,ni,nf,R,E)
	is(1:N,1)=0; // vectorul injectiilor de curent
	G(1:N,1:N)=0; // matricea conductantelor nodale

	for k = 1:L,
		n1 = ni(k);
		n2 = nf(k);
		G(n1,n1) = G(n1,n1) + 1/R(k);
		G(n2,n2) = G(n2,n2) + 1/R(k);
		G(n1,n2) = G(n1,n2) - 1/R(k);
		G(n2,n1) = G(n2,n1) - 1/R(k);
		is(n1) = is(n1) - E(k)/R(k);
		is(n2) = is(n2) + E(k)/R(k);
	end;
	[V] = Gauss(N-1, G, is);
	V(N) = 0;
return;

function [V]=nodalCA(N,L,ni,nf,Z,E)
	is(1:N,1)=0; // vectorul injectiilor de curent
	Y(1:N,1:N)=0; // matricea admitantelor nodale

	for k = 1:L,
		n1 = ni(k);
		n2 = nf(k);
		Y(n1,n1) = Y(n1,n1) + 1/Z(k);
		Y(n2,n2) = Y(n2,n2) + 1/Z(k);
		Y(n1,n2) = Y(n1,n2) - 1/Z(k);
		Y(n2,n1) = Y(n2,n1) - 1/Z(k);
		is(n1) = is(n1) - E(k)/Z(k);
		is(n2) = is(n2) + E(k)/Z(k);
	end;
	[V] = Gauss(N-1, Y, is);
	V(N) = 0;
return;
