function [c] = prep_pol(n, x, y)
// Calculeaza coeficientii c0, c1, ..., cn ai polinomului
// de interpolare pentru reteaua x - y, prin metoda "clasica"
// genereaza matricea sistemului liniar
for i = 1: n+1
    a(i, 1) = 1;
    for j = 2:n+1
        a(i, j) = a(i, j-1) * x(i);
    end;
end;
//rezolva sistem liniar
[c] = Gauss(n+1, a, y);
return;


function [c] = prep_pol_n(n, x, y)
//  Calculeaza coeficientii c0, c1, ..., cn din polinomul
//  de interpolare Newton pentru reteaua x - y
//  genereaza matricea sistemului liniar
for i = 1:n+1
    a(i, 1) = 1;
    for j = 2: i
        a(i, j) = a(i, j-1) *(x(i)-x(j-1));
    end;
end;

//rezolva sistem liniar prin substitutie progresiva
c(1) = y(1);
for i=2:n+1
    s = y(i);
    for j = 1:i-1
        s = s - a(i, j)*c(j);
    end;
    c(i) = s/a(i, i);
end;
return;


function [valp] = eval_pol(n, c, x)
//evalueaza polinom
valp = c(n+1);
for i = n:-1:1
    valp = c(i) + x * valp;
end;
return;

function [valp] = eval_pol_n(n, c, x, xcrt)
//evalueaza polinom newton
valp = c(n+1);
for k = n:-1:1
    valp = c(k) + (xcrt - x(k))*valp
end;
return;


function [valp] = eval_pol_l(n, x, y, xcrt)
// lagrange fara pregatire
valp = 0;
for i = 1:n+1
    p =  1;
    for j = 1:n+1
        if (i <> j) then
            p = p * ((xcrt - x(j))/(x(i) - x(j)));
        end;
    end;
    valp = valp + y(i) * p;
end;
return;
