function [D] = derivata_exacta(x0,func)
	select func
		case 1 then
			D = 2*x0;
		case 2 then
			D = 1/2/x0^.5;
		case 3 then
			D = exp(x0);
		case 4 then
			D = 1/x0;
		case 5 then
			D = cos(x0);
		case 6 then 
			D = 1/cos(x0)^2;
	end;
return;

function [D] = regresivaI(x0,h,func)
	getf('functie.sci');
	D = (functie(x0,func)-functie(x0-h,func))/h;
return;

function [D] = progresivaI(x0,h,func)
	getf('functie.sci');
	D = (functie(x0+h,func)-functie(x0,func))/h;
return;

function [D] = centrataII(x0,h,func)
	getf('functie.sci');
	D = (-functie(x0-h,func)+functie(x0+h,func))/2/h;
return;

function [D] = regresivaII(x0,h,func)
	getf('functie.sci');
	D = ((-3)*functie(x0,func)+4*functie(x0+h,func)-functie(x0+2*h,func))/2/h;
return;

function [D] = progresivaII(x0,h,func)
	getf('functie.sci');
	D = (functie(x0-2*h,func)-4*functie(x0-h,func)+3*functie(x0,func))/2/h;
return;

function [D,ho] = progresiva_optim(x0,h,func)
	getf('functie.sci');
	
	nrit = 10; // nr. max. de iter. pt. det. h optim
	err = %eps; //1e-5; // er. rel. de rot. 
	f0 = functie(x0,func); // val. func. in pct. de deriv.

	// er. abs. de rot.
	e = err*(abs(functie(x0,func))+err);
	k = 0; // contor iteratii
	r = 1/2; // rata de modificare a pasului
	while (k<=nrit & (r<=1/2 | r>=2))
		k = k + 1;
		f1 = functie(x0+h,func);
		f2 = functie(x0+2*h,func);
		d2 = abs(f0-2*f1+f2)/h^2; // modulul dublei derivate
		if (d2 == 0) then
			ho = h;
		else
			ho = sqrt(2*e/d2); // pasul optim
		end;
		r = h/ho;
		h = ho; // actualizeaza pasul la val. optima
	end;
	D = (functie(x0+h,func) - f0)/h; // derivata progresiva de ordinul I
return;

