function [] = rezultate1(li, ls, ni, func)
	getf('functie.sci');
	getf('integrare.sci')
	getf('../L01/alte_functii.sci');

	// reprezentarea grafica a functiei si a trapezelor
	// corespunzatoare subdiviziunilor intervalului considerat
	xclear();
	delmenu(0,'File');
	delmenu(0,'3D Rot.');
	actions = ['xdel(0);'];
	addmenu(0,'Exit');
	Exit_0 = [actions(1)];

	select func
		case 1 then
			txt = 'x^2';
		case 2 then
			txt = 'radical(x)';
		case 3 then
			txt = 'exp(x)';
		case 4
			txt = 'ln(x)';
		case 5
			txt = 'sin(x)';
		case 6
			txt = 'tg(x)';
	end;			

	set("figure_style","old");xname('Graficul functiei pe intervalul considerat:');
	xtitle('Reprezentarea grafica a functiei: f(x)=' + txt,'x',txt);
	xsetech([0,0,1,1]);
	
	pas = (ls-li)/500;
	x = [li:pas:ls];
	[y] = functie(x,func);
	pas = (ls-li)/ni; // pentru adaptarea axei x la reprezentarea trapezelor
	
	plot2d(x,y,-4,"015","",rect=[min(x),min(y),max(x)+pas,max(y)],nax=[1,ni+1,1,10]);
	
	x = [li:pas:ls];
	[y] = functie(x,func);
	plot2d(x,y,5,"005","");
	plot2d3(x,y,5,"005","");

	// afisarea valorii exacte si valorii aproximative
	// ale integralei, si a modulului erorii absolute
	printf('\n\nFunctia: %s',txt);
	printf('\nIntervalul de integrare: [%f, %f]', li, ls);
	printf('\nNumarul de subintervale: %i',ni);
	Ie = intExacta(li,ls,func);
	printf('\nI_exact = %14.10f',Ie);

	Ia = trapez(li,ls,ni,func);
	//Ia = simpson(li,ls,ni,func);
	//Ia = romberg(li,ls,ni,func,3);

	printf('\nI_aprox = %14.10f',Ia);
	erAbs = abs(Ie-Ia);
	printf('\nModulul erorii absolute: %e', erAbs);

	wait2close();
return;

function [] = rezultate2(metInt)
	getf('integrare.sci');
	getf('../L01/alte_functii.sci');

	// x=0...PI, f(x) = sin(x), I(sin(x),x=0...PI) = 2
	// reprezentare grafica a modulului erorii absolute
	// in functie de pasul de integrare h

	xclear();
	delmenu(0,'File');
	delmenu(0,'3D Rot.');
	actions = ['xdel(0);'];
	addmenu(0,'Exit');
	Exit_0 = [actions(1)];

	// Date din sursele C:
	// trapez:   ni = 1:2:139
	// simpson:  ni = 2:2:140 !!! PAR
	// romberg:  ni = 1:2:99
	
	Ie = 2; // valoarea exacta a integralei din sin(x) pe [0;PI]
	
	select metInt
		case 1 then
			// metoda trapezelor
			//timer();
			k=0;
			//for ni=201:4:899,
			for ni=10:10:899,
				k = k+1;
				timer();
				Ia = trapez(0,%pi,ni,5);
				tim(k) = timer();
				h_v(k) = %pi/ni;
				err_abs(k) = abs(Ie-Ia);
				printf("\n nr intervale = %d, h = %g, eroare = %g timp = %g",ni,h_v(k),err_abs(k),tim(k));
				//pause;
			end;
			//time=timer();
			//printf('\n\nMetoda trapezelor: timp CPU = %8.5f [s]',time);
		case 2 then
			// metoda simpson
			// timer();
			k=0;
			//for ni=202:4:900,
			for ni=10:10:900,
				k = k+1;
				timer();
				Ia = simpson(0,%pi,ni,5);
				tim(k) = timer();
				h_v(k) = %pi/ni;
				err_abs(k) = abs(Ie-Ia);
				printf("\n nr intervale = %d, h = %g, eroare = %g timp = %g",ni,h_v(k),err_abs(k),tim(k));
			end;
			time=timer();
			printf('\n\nMetoda Simpson: timp CPU = %8.5f [s]',time);
		case 3 then
			// metoda romberg cu 2 iteratii
			//timer();
			k=0;
			//for ni=201:4:599,
			for ni=10:4:599,
				k = k+1;
				timer();
				Ia = romberg(0,%pi,ni,5,2);
				tim(k) = timer();
				h_v(k) = %pi/ni;
				err_abs(k) = abs(Ie-Ia);
				printf("\n nr intervale = %d, h = %g, eroare = %g timp = %g",ni,h_v(k),err_abs(k),tim(k));
			end;
			time=timer();
			printf('\n\nMetoda Romberg cu 2 iteratii: timp CPU = %8.5f [s]',time);
		case 4 then
			// metoda romberg cu 3 iteratii
			//timer();
			k=0;
			//for ni=201:4:599,
			for ni=10:4:599,
				k = k+1;
				timer();
				Ia = romberg(0,%pi,ni,5,3);
				tim(k) = timer();
				h_v(k) = %pi/ni;
				err_abs(k) = abs(Ie-Ia);
				printf("\n nr intervale = %d, h = %g, eroare = %g timp = %g",ni,h_v(k),err_abs(k),tim(k));
			end;
			//time=timer();
			//printf('\n\nMetoda Romberg cu 3 iteratii: timp CPU = %8.5f [s]',time);
	end;

	set("figure_style","old");xname(['Variatia erorii absolute in functie';'de pasul de integrare:']);
	xtitle('','h','eroarea');
	xsetech([0,0,1,1]);
	plot2d('ll',[h_v],[err_abs],2,'021','',nax=[1,9,1,9]);
	xgrid();

	// afisarea timpului CPU necesar calculului integralei
	// prin metoda de integrare considerata
	wait2close();
	//xname(['Variatia timpului in functie';'de pasul de integrare:']);
	//xtitle('','h','timp [s]');
	//xsetech([0,0,1,1]);
	//plot2d('ln',[h_v],[tim],2,'021','',nax=[1,9,1,9]);
	//xgrid();


return;

