function [f] = func(t,di,am,be,w,fi)	// evalueaza excitatia 
	if (t>di) 
		f = 0;
	else
		f = am * exp(be*t)*cos(w*t+fi);
	end
return

function [rez] = euler_exp3(y,h,a,t,di,am,be,w,fi)      // metoda explicita 
	rez =  y + h*(a*y + func(t,di,am,be,w,fi));
return

function [newy] = euler_imp3 (y,h,a,t,di,am,be,w,fi,err,itmax)    // metoda implicita 
        j = 0;
        newy = y;                                // y implicit
        oldy = 10000; // ca sa intre in ciclu prima data
        while (abs(oldy-newy)> err*abs(newy)) & (j<=ITMAX );
                oldy = newy;
                //if (h <= -1/a)
                        newy = y + h*(a*newy + func(t,di,am,be,w,fi)); //iteratie simpla
                //else
                        //newy = oldy - (oldy -y + h*oldy)/h; //newton
                //end
                j = j + 1;
                //pause;
        end
        if j > ITMAX
                printf("\n Rezolvarea neliniara a metodei implicite nu este convergenta" );
        end
}


function [ye,yi,timp] = solve3 (a,y0,h,tmax,t0,A,B,w,phi,err,ITMAX) // rezolvare 
	t = 0;			          // nod initiala 
	ye(1) = y0;                       // conditii initiale 
	yi(1) = y0;
	n = int(tmax/h + 1);                   // nr. maxim de pasi 
	timp(1) = t;
	for i = 2:n+1                    // calcul 
		ye(i) = euler_exp3 (ye(i-1),h,a,t,t0,A,B,w,phi);  
		t =t + h;                           // nod nou
		timp(i) = t;
		yi(i)= euler_imp3 (yi(i-1),h,a,t,t0,A,B,w,phi,err,ITMAX);   
	end	
return

function [a,y0,h,tmax,t0,A,B,w,phi,err,ITMAX] = inputl18c()
a = -1;
h = [];
tmax = [];
initial = ['4','2','5','-2','10','0','0.001','30'];
txt = ['timp maxim de simulare tmax [s]',...
       'durata impuls t0',...
       'coeficientul A',...
       'coeficientul b',...
       'pulsatia w [rad/s]',...
       'faza initiala phi [grade]',...
       'eroare impusa pt metoda implicita',...
       'nr max de iteratii pt metoda implicita'];
sig = x_mdialog(['Programul rezolva ecuatia : dy/dt = -y+[h(t)-h(t-t0)]*A*exp(b*t)*cos(w*t+phi)'; '                            y(0) = 1';...
                 'Interval de integrare : t in [0,tmax] [s].';...
		 'Pas de integrare h = tmax/100'],txt,initial);
if (sig <> [])
       tmax = evstr(sig(1));
       t0 = evstr(sig(2));
       A = evstr(sig(3));
       B = evstr(sig(4));
       w = evstr(sig(5));
       phi = evstr(sig(6));
       err = evstr(sig(7));
       ITMAX = evstr(sig(8));
else
       exec('mainL18.sci');
end;
h = tmax/100;
phi = phi*%pi/180;

//y0 = abs(a)/sqrt(1+w*w)*cos(phi);
y0 = 0;

printf("\n ===================================");
printf("\n A = %f, b = %f, w = %f, phi = %f, t0 = %f",...
A,B,w,phi,t0 );
printf("\n Pasul de integrare h = %e",h);
printf("\n Eroarea impusa pentru metoda implicita = %e",err);
printf("\n Numarul maxim de iteratii pentru rezolvarea neliniara = %d",ITMAX);

return

